/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_int_list_h_included
#define v3c_meta_treedb_int_list_h_included

#define COBJMACROS
#include <v3c/meta-treedb-list.h>

#ifdef __cplusplus
extern "C" {
#endif

extern treedb_list_backend_vtbl_t IntList_backend_vtbl;
extern void STDCALL IntList_Dump(treedb_list_ptr_t p);

#define IntList_PushBack(p, i) \
	treedb_list_t_PushBack(p, (HTREEDB_LISTDATA)(&i))
#define IntList_PushFront(p, i) \
	treedb_list_t_PushFront(p, (HTREEDB_LISTDATA)(&i))
#define IntList_PopBack(p) \
	treedb_list_t_PopBack(p)
#define IntList_PopFront(p) \
	treedb_list_t_PopFront(p)

#define IntList_ImplDataPointer(This, pv) \
	((int32_t *)treedb_list_impl_t_NodeToDataPtr(This, pv))

#define IntList_ImplData(This, pv) \
	(*IntList_ImplDataPointer(This, pv))

#define IntList_DataPointer(This, pv) \
	IntList_ImplDataPointer((This)->m_pImpl, pv)
#define IntList_Data(This, pv) (*IntList_DataPointer(This, pv))

#ifdef __cplusplus
} /* extern "C" { */
#endif

#endif /* #ifndef v3c_meta_treedb_int_list_h_included */
