/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_int_tree_h_included
#define v3c_meta_treedb_int_tree_h_included

#define COBJMACROS
#include <v3c/meta-treedb.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct IntTreeData_tag {
	char buf[4096 + 8];
	treedb_storage_on_memory_t storage;
	treedb_allocator_on_storage_impl_t allocator_impl;
	treedb_allocator_on_storage_t allocator;
	treedb_const_tree_ptr_t ptree_template;
	uint64_t payload;
	size_t free_offset, free_size;
	treedb_tree_backend_t backend;
	TreedbItemDescription description;
	treedb_tree_impl_t int_tree_impl;
	treedb_tree_t int_tree;
} IntTreeData;

extern IntTreeData g_data;

extern int setup_IntTreeData(uint16_t abytes, uint16_t aflags, uint16_t xbytes
	, uint16_t xflags);

static inline char * g_buf()
{
	return V3C_ROUND_UP_PTR(g_data.buf,8);
}
static inline treedb_allocator_on_storage_t * allocator()
{
	return & g_data.allocator;
}
extern treedb_tree_backend_vtbl_t IntTree_backend_vtbl;
extern void STDCALL IntTree_Dump(treedb_tree_ptr_t p);

#define IntTree_Insert(p, i) \
	treedb_tree_t_Insert(p, (HTREEDB_TREEKEY)(&i), 0)
#define IntTree_Remove(p, i) \
	treedb_tree_t_Remove(p, (HTREEDB_TREEKEY)(&i))
#define IntTree_Contains(p, i) \
	( treedb_tree_t_Search(p, (HTREEDB_TREEKEY)(&i)) ? 1 : 0)

#define IntTree_DataPointer(This, pv) \
	((int32_t *)treedb_tree_t_NodeToDataPtr(This, pv))
#define IntTree_Data(This, pv) \
	(*IntTree_DataPointer(This, pv))

#ifdef __cplusplus
} /* extern "C" { */
#endif

#endif /* #ifndef v3c_meta_treedb_int_tree_h_included */
