#!/bin/sh

# Copyright (C) 2009  Philip Ashmore (contact@philipashmore.com)
# License: LPGLv3.  See LICENSE.txt for the full license.

set -e

POINTER=$(($POINTER_SIZE*8))

app="./v3c-meta-comet"
# This value must be low enough so that the 16 bit heap doesn't run out of
# addresses.
LARGE_VAL_16=1000
LARGE_VAL=100000

eFail=1
eUnrecognisedCommand=2
eBadCommand=3
eOutOfResources=4
eFileOpenFailure=5
eUnknownAllocatorAlgorithm=6
eUnknownSchema=7

result_name()
{
	case $1 in
	$eFail) echo "False";;
	$eUnrecognisedCommand) echo "Unrecognised Command";;
	$eBadCommand) echo "Bad Command";;
	$eOutOfResources) echo "Out Of Resources";;
	$eFileOpenFailure) echo "File Open Failure";;
	$eUnknownAllocatorAlgorithm) echo "Unknown Allocator Algorithm";; #!
	$eUnknownSchema) echo "Unknown Schema";;
	*) echo "Heap Error<$1>";;
	esac
}
run()
{
	echo -n "> v3c-meta-comet $@ : "
	eval "$app $@" || {
		ret=$?
		echo "returned $ret ($(result_name $ret))"
		return $ret
	}
	echo "[OK]"
}
comet_run()
{
	echo -n "> v3c-comet $@ : "
	eval "v3c-comet $@" || {
		ret=$?
		echo "returned $ret ($(result_name $ret))"
		return $ret
	}
	echo "[OK]"
}

rm test.sb 2>/dev/null || true
