#!/bin/sh

# Copyright (C) 2009  Philip Ashmore (contact@philipashmore.com)
# License: LPGLv3.  See LICENSE.txt for the full license.

. $srcdir/meta-comet-test-helper.sh

run_test_part()
{
	local the_type="$1 $2"
	local is_set="0"
	if test "$2" = "set" ; then
		local is_set="1"
	fi
	shift
	shift
	# Dash doesn't do as expected with this!
	#local the_input="$@"
	local the_input="$1 $2 $3 $4 $5 $6"

	$writer $the_type init test.sb $num_bits
	echo "$writer_name streaming \"$the_input\" into test.sb."
	echo "$the_input" | $writer stream test.sb
	$reader check test.sb
	count="$($reader_app count test.sb)"
	if test "$count" != "6" ; then
		echo "$reader_name got the count wrong($count != 6)."
		$writer count test.sb
		exit 1
	fi
	if test "$is_set" = "1" ; then
		if ! $reader_app $the_type contains test.sb "$1"; then
			echo "$reader_name didn't see \"$1\" in the treedb."
			$reader $the_type contains test.sb "$1" || true
			$writer $the_type contains test.sb "$1" || true
			$reader $the_type dump test.sb
			$writer $the_type dump test.sb
			exit 1
		fi
	fi
	local a="$($reader_app dump test.sb | tr '\n' ' ' | sed -e 's| $||g')"
	local b="$($writer_app dump test.sb | tr '\n' ' ' | sed -e 's| $||g')"
	if test "$a" != "$b" ; then
		echo "$reader_name saw \"$a\" != what $writer_name saw \"$b\"."
		exit 1
	fi
}

run_test_parts()
{
	run_test_part "string" "set" "apple" "orange" "lemon" "pear" "plum" "banana"
	run_test_part "int" "set" "0" "1" "2" "3" "4" "5"
	run_test_part "string" "list" "apple" "orange" "lemon" "pear" "plum" "banana"
	run_test_part "int" "list" "0" "1" "2" "3" "4" "5"
}
run_tests()
{
	local num_bits="16"
	run_test_parts
	num_bits="32"
	run_test_parts
	if test "$POINTER" = "64" ; then
		echo "Running $POINTER bit tests."
		num_bits="64"
		run_test_parts
	fi
}
# Test that v3c-meta-comet can read v3c-comet's treedb's.
reader="run"
reader_app="$app"
reader_name="v3c-meta-comet"
writer="comet_run"
writer_app="v3c-comet"
writer_name="v3c-comet"
run_tests

# Test that v3c-comet can read v3c-meta-comet's treedb's.
reader="comet_run"
reader_app="v3c-comet"
reader_name="v3c-comet"
writer="run"
writer_app="$app"
writer_name="v3c-meta-comet"
run_tests

rm test.sb
