/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_comet_h_included
#define v3c_meta_treedb_comet_h_included

#include <treedb/comet.h>
#define COBJMACROS
#include "meta-treedb.h"
#include <treedb/comet-guids.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct u_tree_tag {
	treedb_tree_impl_t m_tree_impl;
	treedb_tree_t m_tree;
	treedb_tree_backend_t m_backend;
	TreedbItemDescription m_description;
} u_tree_t;
typedef struct u_list_tag {
	treedb_list_impl_t m_list_impl;
	treedb_list_t m_list;
	treedb_list_backend_t m_backend;
	TreedbItemDescription m_description;
} u_list_t;
typedef struct meta_comet_tag {
	treedb_storage_on_file_t m_storage;
	treedb_allocator_on_storage_impl_t m_allocator_impl;
	treedb_allocator_on_storage_t m_allocator;
	union {
		u_tree_t u_tree;
		u_list_t u_list;
	};
} meta_comet_t, * meta_comet_ptr_t;

#define META_COMET_INIT \
{ TREEDB_STORAGE_ON_FILE_INIT \
, META_TREEDB_ALLOCATOR_ON_STORAGE_IMPL_INIT \
, META_TREEDB_ALLOCATOR_ON_STORAGE_INIT \
, {} /* union */\
}
typedef CometCommandStatus (* PFN_META_COMET_INIT_FUNCTION)
(meta_comet_ptr_t /*runtime*/);
typedef CometCommandStatus (* PFN_META_COMET_FUNCTION2)
(meta_comet_ptr_t /*runtime*/, const char * /*filename*/);
typedef CometCommandStatus (* PFN_META_COMET_FUNCTION)
(meta_comet_ptr_t /*runtime*/);
typedef CometCommandStatus (* PFN_META_COMET_UPDATE_FUNCTION)
(meta_comet_ptr_t /*runtime*/, int /*argc*/, char * /*argv*/[]);
typedef CometCommandStatus (* PFN_META_COMET_UPDATE2_FUNCTION)
(meta_comet_ptr_t /*runtime*/, const char * /*filename*/);

extern CometCommandStatus meta_comet_stream(meta_comet_ptr_t runtime);
extern CometCommandStatus meta_comet_dump(meta_comet_ptr_t runtime);

typedef struct CometDetails_tag {
	const unsigned char * schema;
	PFN_META_COMET_INIT_FUNCTION fn;
	uint16_t uPayloadOffsCount;
} CometDetails, * CometDetailsPtr;

#ifdef __cplusplus
} // extern "C" {
#endif

#endif /* #ifndef v3c_meta_treedb_comet_h_included */
