/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifdef DOXYGEN_processing
{
#endif

#include "meta-allocator.h"

#ifdef DOXYGEN_processing
}
#endif

/******************************************************************************/
/* Allocator tree backends                                                    */
/******************************************************************************/
static PCVOID STDCALL AVL_TMPL_NS(used_backend_UnpackKey)
( treedb_tree_backend_ptr_t This
, treedb_tree_runtime_ptr_t runtime
, PCVOID pv
) {
	(void)This;
	/* Given a node pointer, return it's offset */
	PCVOID ret = (PCVOID)
		treedb_tree_t_PointerPack(runtime, pv);
	META_TREEDB_printf2("used_backend_UnpackKey(%lu) : returning packed address"
		" %lu.\n"
		, treedb_allocator_t_PointerToOffset(runtime->m_pImpl->m_pAllocator, pv)
		, (uintptr_t)ret);
	return ret;
}
static int STDCALL AVL_TMPL_NS(used_backend_Compare)
( treedb_tree_backend_ptr_t This
, treedb_tree_runtime_ptr_t runtime
, PCVOID av
, PCVOID bv
) {
	(void)This;
	(void)runtime;
	return av < bv ? -1 : av == bv ? 0 : 1;
}
static PCVOID STDCALL AVL_TMPL_NS(free_backend_UnpackKey)
( treedb_tree_backend_ptr_t This
, treedb_tree_runtime_ptr_t runtime
, PCVOID pv
) {
	(void)This;
	AVL_TMPL_NS(item_ptr_t) item
		= (AVL_TMPL_NS(item_ptr_t))treedb_tree_t_NodeToDataPtr(runtime, pv);
	/* Given a node pointer, return it's length */
	META_TREEDB_printf2("free_backend_UnpackKey(%lu) : returning length %lu.\n"
		, treedb_allocator_t_PointerToOffset(runtime->m_pAllocator, pv)
		, (size_t)item->m_uLength);
	return (PCVOID)(uintptr_t)item->m_uLength;
}
static int STDCALL AVL_TMPL_NS(free_backend_Compare)
( treedb_tree_backend_ptr_t This
, treedb_tree_runtime_ptr_t runtime
, PCVOID av
, PCVOID bv
) {
	(void)This;
	(void)runtime;
	AVL_TMPL_count_t a = (AVL_TMPL_count_t)(uintptr_t)av;
	AVL_TMPL_count_t b = (AVL_TMPL_count_t)(uintptr_t)bv;
	return a < b ? -1 : a == b ? 0 : 1;
}
static treedb_tree_backend_vtbl_t
AVL_TMPL_NS(allocator_used_backend_vtbl) =
{ & AVL_TMPL_NS(used_backend_UnpackKey)
, & AVL_TMPL_NS(used_backend_Compare)
, 0, 0
};
static treedb_tree_backend_t
AVL_TMPL_NS(allocator_used_backend) =
{ & AVL_TMPL_NS(allocator_used_backend_vtbl) };

static treedb_tree_backend_vtbl_t
AVL_TMPL_NS(allocator_free_backend_vtbl) =
{ & AVL_TMPL_NS(free_backend_UnpackKey)
, & AVL_TMPL_NS(free_backend_Compare)
, 0, 0
};
static treedb_tree_backend_t
AVL_TMPL_NS(allocator_free_backend) =
{ & AVL_TMPL_NS(allocator_free_backend_vtbl) };

static TreedbAllocatorDescription AVL_TMPL_NS(allocator_on_storage_desc) =
{ { sizeof(AVL_TMPL_count_t), sizeof(AVL_TMPL_count_t) }
, { sizeof(AVL_TMPL_NS(tree_t)), sizeof(AVL_TMPL_count_t) }
#if (defined(AVL_TMPL_have_count) && defined(AVL_TMPL_have_depth))
, { offsetof(AVL_TMPL_NS(node_t), m_depth) + 1, sizeof(AVL_TMPL_count_t) }
, eTreedbContainerHasCount | eTreedbContainerHasDepth
#elif defined(AVL_TMPL_have_count)
, { offsetof(AVL_TMPL_NS(node_t), m_count) + sizeof(AVL_TMPL_count_t)
	, sizeof(AVL_TMPL_count_t) }
, eTreedbContainerHasCount
#elif defined(AVL_TMPL_have_depth)
, { offsetof(AVL_TMPL_NS(node_t), m_depth) + 1, sizeof(AVL_TMPL_count_t) }
, eTreedbContainerHasDepth
#endif
#ifdef AVL_POINTER_TREE
	| eTreedbContainerIsPointer
#endif
	, V3C_ROUND_UP_T(uint32_t, sizeof(AVL_TMPL_NS(node_t))
		, sizeof(AVL_TMPL_count_t))
	, V3C_ROUND_UP_T(uint32_t, sizeof(AVL_TMPL_NS(item_t))
		, sizeof(AVL_TMPL_count_t))
};
static TreedbItemDescription AVL_TMPL_NS(allocator_free_desc) =
{ { sizeof(AVL_TMPL_count_t), sizeof(AVL_TMPL_count_t) }
, { sizeof(AVL_TMPL_NS(tree_t)), sizeof(AVL_TMPL_count_t) }
#if (defined(AVL_TMPL_have_count) && defined(AVL_TMPL_have_depth))
, { offsetof(AVL_TMPL_NS(node_t), m_depth) + 1, sizeof(AVL_TMPL_count_t) }
, eTreedbContainerHasCount | eTreedbContainerHasDepth
#elif defined(AVL_TMPL_have_count)
, { offsetof(AVL_TMPL_NS(node_t), m_count) + sizeof(AVL_TMPL_count_t)
	, sizeof(AVL_TMPL_count_t) }
, eTreedbContainerHasCount
#elif defined(AVL_TMPL_have_depth)
, { offsetof(AVL_TMPL_NS(node_t), m_depth) + 1, sizeof(AVL_TMPL_count_t) }
, eTreedbContainerHasDepth
#endif
#ifdef AVL_POINTER_TREE
	| eTreedbContainerIsPointer
#endif
	| eTreedbContainerAllowsDuplicates
	, V3C_ROUND_UP_T(uint32_t, sizeof(AVL_TMPL_NS(node_t))
		, sizeof(AVL_TMPL_count_t))
};
#if 0
static void AVL_TMPL_NS(test)(treedb_tree_impl_t * v)
{
	v->lpVtbl = 0;
	v->m_pAllocator = 0;
	v->m_pBackend = & AVL_TMPL_NS(allocator_used_backend);
	v->m_pDescription = (TreedbItemDescriptionConstPtr)
		(& AVL_TMPL_NS(allocator_on_storage_desc));
}
#endif

extern treedb_tree_impl_vtbl_t AVL_TMPL_NS(vtbl);

static treedb_tree_impl_t AVL_TMPL_NS(allocator_on_storage_used_tree_impl) =
{ & AVL_TMPL_NS(vtbl)
, 0
, & AVL_TMPL_NS(allocator_used_backend)
, (TreedbItemDescriptionConstPtr)(& AVL_TMPL_NS(allocator_on_storage_desc))
};
static treedb_tree_impl_t AVL_TMPL_NS(allocator_on_storage_free_tree_impl) =
{ & AVL_TMPL_NS(vtbl)
, 0
, & AVL_TMPL_NS(allocator_free_backend)
, & AVL_TMPL_NS(allocator_free_desc)
};
struct AVL_TMPL_NS(two_trees) {
	AVL_TMPL_NS(tree_t) t0;
	AVL_TMPL_NS(tree_t) t1;
};
enum { AVL_TMPL_NS(offs1) = offsetof(struct AVL_TMPL_NS(two_trees), t1) };

extern treedb_allocator_on_storage_impl_vtbl_t
	AVL_TMPL_NS(allocator_on_storage_impl_vtbl);

treedb_allocator_on_storage_impl_t
AVL_TMPL_NS(allocator_on_storage_impl) =
{ & AVL_TMPL_NS(allocator_on_storage_impl_vtbl)
, & AVL_TMPL_NS(allocator_on_storage_desc)
, 0 /* m_pStorage */
};
treedb_allocator_on_storage_t
AVL_TMPL_NS(allocator_on_storage) =
{ & AVL_TMPL_NS(allocator_on_storage_impl)
, & v3c_treedb_allocator_abort /* m_abort_fn */
, 0 /* m_errno */
, { & AVL_TMPL_NS(allocator_on_storage_free_tree_impl)
	, 0} /* m_free */
, { & AVL_TMPL_NS(allocator_on_storage_used_tree_impl)
	, (uintptr_t)AVL_TMPL_NS(offs1)} /* m_used */
};
