/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_meta_avl_defines_h_included
#define v3c_meta_treedb_meta_avl_defines_h_included

#include <stdio.h>
#include "meta-avl.h"

#ifdef __cplusplus
extern "C" {
#endif

#define AVL_TMPL_runtime_ptr_t treedb_tree_runtime_ptr_t
#define AVL_TMPL_size_t uintptr_t
#define AVL_TMPL_ssize_t intptr_t
#define AVL_TMPL_packed_node_ptr_t AVL_TMPL_count_t
#define AVL_TMPL_packed_tree_ptr_t AVL_TMPL_count_t
#define AVL_TMPL_data_t char
#define AVL_TMPL_item_SUFFIX []
#define AVL_TMPL_key_t HTREEDB_TREEKEY
#define AVL_TMPL_input_t HTREEDB_TREEKEY
#undef AVL_TMPL_has_count
#undef AVL_TMPL_has_depth

//#define AVL_TMPL_item m_itemX

#define AVL_TMPL_omit_unpack_tree_DECLARE
#define AVL_TMPL_omit_pack_tree_DECLARE
#define AVL_TMPL_omit_unpack_node_DECLARE
#define AVL_TMPL_omit_pack_node_DECLARE

/******************************************************************************/
/* o16                                                                        */
/******************************************************************************/
#define AVL_TMPL_count_t uint16_t

/* count */
#define AVL_TMPL_has_count
#define AVL_TMPL_NS_ treedb_avl_tree_o16c_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

/* depth */
#undef AVL_TMPL_has_count
#define AVL_TMPL_has_depth
#define AVL_TMPL_NS_ treedb_avl_tree_o16d_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

/* count + depth */
#define AVL_TMPL_has_count
#define AVL_TMPL_NS_ treedb_avl_tree_o16cd_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

#undef AVL_TMPL_has_count
#undef AVL_TMPL_has_depth

/******************************************************************************/
/* o32                                                                        */
/******************************************************************************/
/* 16->32 */
#undef AVL_TMPL_count_t
#define AVL_TMPL_count_t uint32_t

/* count */
#define AVL_TMPL_has_count
#define AVL_TMPL_NS_ treedb_avl_tree_o32c_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

/* depth */
#undef AVL_TMPL_has_count
#define AVL_TMPL_has_depth
#define AVL_TMPL_NS_ treedb_avl_tree_o32d_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

/* count + depth */
#define AVL_TMPL_has_count
#define AVL_TMPL_NS_ treedb_avl_tree_o32cd_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

#undef AVL_TMPL_has_count
#undef AVL_TMPL_has_depth

#if HAVE_64_BITS

/******************************************************************************/
/* o64                                                                        */
/******************************************************************************/
/* 32->64 */
#undef AVL_TMPL_count_t
#define AVL_TMPL_count_t uint64_t

/* count */
#define AVL_TMPL_has_count
#define AVL_TMPL_NS_ treedb_avl_tree_o64c_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

/* depth */
#undef AVL_TMPL_has_count
#define AVL_TMPL_has_depth
#define AVL_TMPL_NS_ treedb_avl_tree_o64d_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

/* count + depth */
#define AVL_TMPL_has_count
#define AVL_TMPL_NS_ treedb_avl_tree_o64cd_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

#undef AVL_TMPL_has_count
#undef AVL_TMPL_has_depth

#endif /* #if HAVE_64_BITS */

/******************************************************************************/
/* pointer                                                                    */
/******************************************************************************/
/* 64->pointer */
#undef AVL_TMPL_count_t
#define AVL_TMPL_count_t uintptr_t

//#if 0
#undef AVL_TMPL_unpack_tree
#undef AVL_TMPL_pack_tree
#undef AVL_TMPL_unpack_node
#undef AVL_TMPL_pack_node
#define AVL_TMPL_unpack_tree(x) (x)
#define AVL_TMPL_pack_tree(x) (x)
#define AVL_TMPL_unpack_node(x) (x)
#define AVL_TMPL_pack_node(x) (x)

#undef AVL_TMPL_packed_node_ptr_t
#undef AVL_TMPL_packed_tree_ptr_t
#define AVL_TMPL_packed_node_ptr_t AVL_TMPL_node_ptr_t
#define AVL_TMPL_packed_tree_ptr_t AVL_TMPL_tree_ptr_t
//#endif

#undef AVL_TMPL_pack_tree
#undef AVL_TMPL_pack_node
#undef AVL_TMPL_unpack_tree
#undef AVL_TMPL_unpack_node

#define AVL_TMPL_omit_pack_tree_DECLARE
#define AVL_TMPL_omit_pack_node_DECLARE
#define AVL_TMPL_omit_unpack_tree_DECLARE
#define AVL_TMPL_omit_unpack_node_DECLARE

/* count */
#define AVL_TMPL_has_count
#define AVL_TMPL_NS_ treedb_avl_tree_pc_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

/* depth */
#undef AVL_TMPL_has_count
#define AVL_TMPL_has_depth
#define AVL_TMPL_NS_ treedb_avl_tree_pd_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

/* count + depth */
#define AVL_TMPL_has_count
#define AVL_TMPL_NS_ treedb_avl_tree_pcd_
#include <treedb/avl-template.h>
#undef AVL_TMPL_NS_

#undef AVL_TMPL_count_t

#undef AVL_TMPL_has_count
#undef AVL_TMPL_has_depth

#ifdef __cplusplus
} /* extern "C" { */
#endif

#undef AVL_TMPL_size_t

#undef AVL_TMPL_packed_node_ptr_t
#undef AVL_TMPL_packed_tree_ptr_t

#undef AVL_TMPL_unpack_tree
#undef AVL_TMPL_unpack_node
#undef AVL_TMPL_pack_tree
#undef AVL_TMPL_pack_node

#undef AVL_TMPL_omit_pack_tree
#undef AVL_TMPL_omit_pack_node
#undef AVL_TMPL_omit_unpack_tree
#undef AVL_TMPL_omit_unpack_node

#undef AVL_TMPL_omit_pack_tree_DECLARE
#undef AVL_TMPL_omit_pack_node_DECLARE
#undef AVL_TMPL_omit_unpack_tree_DECLARE
#undef AVL_TMPL_omit_unpack_node_DECLARE

#endif /* #ifndef v3c_meta_treedb_meta_avl_defines_h_included */
