/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_meta_avl_h_included
#define v3c_meta_treedb_meta_avl_h_included

#include "meta-treedb.h"

#ifdef __cplusplus
extern "C" {
#endif

extern treedb_const_tree_ptr_t
treedb_get_avl_tree_template_for
( uint16_t uBytesPerOffset /* 2, 4, 8 */
, uint16_t flags
);

extern treedb_const_tree_ptr_t
treedb_get_avl_tree_template_using_allocator
( treedb_allocator_ptr_t pallocator
);

extern BOOL
treedb_init_avl_tree_from_template
( treedb_tree_ptr_t p
, uint16_t uBytesPerOffset /* 2, 4, 8 */
, uint16_t flags
);

extern BOOL
treedb_init_avl_tree_using_allocator
( treedb_tree_ptr_t p
, treedb_allocator_ptr_t pa
);

extern treedb_const_allocator_on_storage_ptr_t
treedb_get_allocator_on_storage_template_for
( uint16_t uBytesPerOffset /* 2, 4, 8 */
, uint16_t flags
);
extern BOOL
treedb_init_allocator_on_storage_from_template
( treedb_allocator_on_storage_ptr_t pAllocator
, treedb_allocator_on_storage_impl_ptr_t pAllocatorImpl
, uint16_t uBytesPerOffset /* 2, 4, 8 */
, uint16_t flags
, uint64_t offset
, treedb_storage_ptr_t pStorage
);

#ifdef __cplusplus
} /* extern "C" { */
#endif

#endif /* #ifndef v3c_meta_treedb_meta_avl_h_included */
