/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_meta_list_defines_h_included
#define v3c_meta_treedb_meta_list_defines_h_included

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

#define LIST_TMPL_prefix static
#define LIST_TMPL_NS(x) V3C_INVOKE2(V3C_JOIN2,LIST_TMPL_NS_,x)
#define LIST_TMPL_input_t HTREEDB_LISTDATA

#define LIST_TMPL_size_t uintptr_t
#define LIST_TMPL_packed_node_ptr_t LIST_TMPL_count_t
#define LIST_TMPL_packed_list_ptr_t LIST_TMPL_count_t
#define LIST_TMPL_data_t char
#define LIST_TMPL_item_SUFFIX []
#define LIST_TMPL_runtime_ptr_t treedb_list_runtime_ptr_t

/******************************************************************************/
/* o16                                                                        */
/******************************************************************************/
#define LIST_TMPL_count_t uint16_t

/* */
#define LIST_TMPL_NS_ treedb_list_o16_
#include <treedb/list-template.h>
#undef LIST_TMPL_NS_

/* count */
#define LIST_TMPL_have_count
#define LIST_TMPL_NS_ treedb_list_o16c_
#include <treedb/list-template.h>
#undef LIST_TMPL_NS_

#undef LIST_TMPL_have_count

/******************************************************************************/
/* o32                                                                        */
/******************************************************************************/
/* 16->32 */
#undef LIST_TMPL_count_t
#define LIST_TMPL_count_t uint32_t

/* */
#define LIST_TMPL_NS_ treedb_list_o32_
#include <treedb/list-template.h>
#undef LIST_TMPL_NS_

/* count */
#define LIST_TMPL_have_count
#define LIST_TMPL_NS_ treedb_list_o32c_
#include <treedb/list-template.h>
#undef LIST_TMPL_have_count
#undef LIST_TMPL_NS_

#if HAVE_64_BITS

/******************************************************************************/
/* o64                                                                        */
/******************************************************************************/
/* 32->64 */
#undef LIST_TMPL_count_t
#define LIST_TMPL_count_t uint64_t

/* Offset 64 */
#define LIST_TMPL_NS_ treedb_list_o64_
#include <treedb/list-template.h>
#undef LIST_TMPL_NS_

/* Offset 64 count */
#define LIST_TMPL_have_count
#define LIST_TMPL_NS_ treedb_list_o64c_
#include <treedb/list-template.h>
#undef LIST_TMPL_have_count
#undef LIST_TMPL_NS_

#endif /* #if HAVE_64_BITS */

/******************************************************************************/
/* pointer                                                                    */
/******************************************************************************/
/* 64->pointer */
#undef LIST_TMPL_count_t
#define LIST_TMPL_count_t uintptr_t

#undef LIST_TMPL_unpack_list
#undef LIST_TMPL_pack_list
#undef LIST_TMPL_unpack_node
#undef LIST_TMPL_pack_node
#define LIST_TMPL_unpack_list(x) (x)
#define LIST_TMPL_pack_list(x) (x)
#define LIST_TMPL_unpack_node(x) (x)
#define LIST_TMPL_pack_node(x) (x)

#undef LIST_TMPL_packed_node_ptr_t
#undef LIST_TMPL_packed_list_ptr_t
#define LIST_TMPL_packed_node_ptr_t LIST_TMPL_NS(node_ptr_t)
#define LIST_TMPL_packed_list_ptr_t LIST_TMPL_NS(list_ptr_t)

#define LIST_TMPL_POINTER

#undef LIST_TMPL_unpack_pointer
#undef LIST_TMPL_pack_pointer
#define LIST_TMPL_unpack_pointer(x) ((PVOID)(x))
#define LIST_TMPL_pack_pointer(x) ((LIST_TMPL_count_t)(x))

#define LIST_TMPL_omit_unpack_list_DECLARE
#define LIST_TMPL_omit_unpack_node_DECLARE
#define LIST_TMPL_omit_pack_list_DECLARE
#define LIST_TMPL_omit_pack_node_DECLARE

/* */
#define LIST_TMPL_NS_ treedb_list_p_
#include <treedb/list-template.h>
#undef LIST_TMPL_NS_

/* count */
#define LIST_TMPL_have_count
#define LIST_TMPL_NS_ treedb_list_pc_
#include <treedb/list-template.h>
#undef LIST_TMPL_NS_

#ifdef __cplusplus
} /* extern "C" { */
#endif

#undef LIST_TMPL_POINTER

#include <treedb/list-template-cleardefs.h>

#endif /* #ifndef v3c_meta_treedb_meta_list_defines_h_included */
