/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#define LIST_TMPL_NS(x) V3C_INVOKE2(V3C_JOIN2,LIST_TMPL_NS_,x)
#define LIST_TMPL_input_t HTREEDB_LISTDATA
#define LIST_TMPL_list_ptr_t LIST_TMPL_NS(list_ptr_t)
#define LIST_TMPL_runtime_ptr_t treedb_list_runtime_ptr_t

#include <treedb/list-template-impl.h>

static void STDCALL LIST_TMPL_NS(Init)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
) {
	LIST_TMPL_NS(init)(runtime, LIST_TMPL_unpack_list(hl));
}
static void STDCALL LIST_TMPL_NS(Clear)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
) {
	LIST_TMPL_NS(clear)(runtime, (LIST_TMPL_packed_list_ptr_t)hl);
}
static HTREEDB_LIST STDCALL LIST_TMPL_NS(Alloc)
( treedb_list_runtime_ptr_t runtime
) {
	LIST_TMPL_NS(list_ptr_t) pt = (LIST_TMPL_NS(list_ptr_t))
		treedb_allocator_t_Alloc(runtime->m_pImpl->m_pAllocator
			, sizeof(LIST_TMPL_NS(list_t)));
	if(!pt)
		return 0;
	pt->m_head = pt->m_tail = 0;
	return LIST_TMPL_pack_list(pt);
}

static void STDCALL LIST_TMPL_NS(Free)
( treedb_list_runtime_ptr_t runtime, HTREEDB_LIST hl
) {
	LIST_TMPL_NS(free)(runtime, (LIST_TMPL_packed_list_ptr_t)hl);
}

static uint64_t STDCALL LIST_TMPL_NS(Count)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
) {
	(void)runtime;
	return LIST_TMPL_NS(count)(runtime, LIST_TMPL_unpack_list(hl));
}

static HTREEDB_LISTNODE STDCALL LIST_TMPL_NS(PushFront)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, HTREEDB_LISTDATA pv
) {
	return (HTREEDB_LISTNODE)LIST_TMPL_pack_node(
		LIST_TMPL_NS(push_front)(runtime, (LIST_TMPL_packed_list_ptr_t)hl, pv)
	);
}
static HTREEDB_LISTNODE STDCALL LIST_TMPL_NS(PushBack)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, HTREEDB_LISTDATA pv
) {
	return (HTREEDB_LISTNODE)LIST_TMPL_pack_node(
		LIST_TMPL_NS(push_back)(runtime, (LIST_TMPL_packed_list_ptr_t)hl, pv)
	);
}
static BOOL STDCALL LIST_TMPL_NS(RemoveNodes)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, HTREEDB_LISTNODE hstart
, uintptr_t count
) {
	return ! LIST_TMPL_NS(remove_nodes)(runtime, (LIST_TMPL_packed_list_ptr_t)hl
		, (LIST_TMPL_packed_node_ptr_t)hstart, count);
}
static BOOL STDCALL LIST_TMPL_NS(RemoveMany)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, uintptr_t where
, uintptr_t count
) {
	return ! LIST_TMPL_NS(remove_many)(runtime, (LIST_TMPL_packed_list_ptr_t)hl, where
		, count);
}
static BOOL STDCALL LIST_TMPL_NS(Remove)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, uintptr_t where
) {
	return ! LIST_TMPL_NS(remove)(runtime, (LIST_TMPL_packed_list_ptr_t)hl, where);
}
static BOOL STDCALL LIST_TMPL_NS(PopFront)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
) {
	return ! LIST_TMPL_NS(pop_front)(runtime, (LIST_TMPL_packed_list_ptr_t)hl);
}
static BOOL STDCALL LIST_TMPL_NS(PopFrontMany)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, uintptr_t count
) {
	return ! LIST_TMPL_NS(pop_front_many)(runtime, (LIST_TMPL_packed_list_ptr_t)hl
		, count);
}
static BOOL STDCALL LIST_TMPL_NS(PopBack)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
) {
	return ! LIST_TMPL_NS(pop_back)(runtime, (LIST_TMPL_packed_list_ptr_t)hl);
}
static BOOL STDCALL LIST_TMPL_NS(PopBackMany)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, uintptr_t count
) {
	return ! LIST_TMPL_NS(pop_back_many)(runtime, (LIST_TMPL_packed_list_ptr_t)hl
		, count);
}
static BOOL STDCALL LIST_TMPL_NS(ReverseSome)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, uintptr_t where
, uintptr_t count
) {
	return ! LIST_TMPL_NS(reverse_some)(runtime, LIST_TMPL_unpack_list(hl), where
		, count);
}
static void STDCALL LIST_TMPL_NS(Reverse)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
) {
	LIST_TMPL_NS(reverse)(runtime, LIST_TMPL_unpack_list(hl));
}
static HTREEDB_LISTNODE STDCALL LIST_TMPL_NS(Head)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
) {
	(void)runtime;
	return (HTREEDB_LISTNODE)(LIST_TMPL_unpack_list(hl)->m_head);
}
static HTREEDB_LISTNODE STDCALL LIST_TMPL_NS(Tail)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
) {
	(void)runtime;
	return (HTREEDB_LISTNODE)(LIST_TMPL_unpack_list(hl)->m_tail);
}
static PVOID STDCALL LIST_TMPL_NS(PointerHead)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
) {
	(void)runtime;
	return LIST_TMPL_unpack_node(
		(HTREEDB_LISTNODE)(LIST_TMPL_unpack_list(hl)->m_head));
}
static PVOID STDCALL LIST_TMPL_NS(PointerTail)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
) {
	(void)runtime;
	return LIST_TMPL_unpack_node(
		(HTREEDB_LISTNODE)(LIST_TMPL_unpack_list(hl)->m_tail));
}

/* Handle ------------------------------------------------------------------- */
static HTREEDB_LISTNODE STDCALL LIST_TMPL_NS(PushFrontNode)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, HTREEDB_LISTNODE hn
) {
	if(!hn)
		return 0;
	LIST_TMPL_node_ptr_t pnode = LIST_TMPL_unpack_node(hn);
	LIST_TMPL_NS(push_front_node)(runtime
		, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
		, pnode);
	return hn;
}
static HTREEDB_LISTNODE STDCALL LIST_TMPL_NS(PushBackNode)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, HTREEDB_LISTNODE hn
) {
	if(!hn)
		return 0;
	LIST_TMPL_node_ptr_t pnode = LIST_TMPL_unpack_node(hn);
	LIST_TMPL_NS(push_back_node)(runtime
		, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
		, pnode);
	return hn;
}
static void STDCALL LIST_TMPL_NS(InsertNodeBefore)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, HTREEDB_LISTNODE hn
, HTREEDB_LISTNODE hn_new
) {
	LIST_TMPL_NS(insert_node_before)
	( runtime
	, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
	, LIST_TMPL_unpack_node((LIST_TMPL_packed_node_ptr_t)hn)
	, LIST_TMPL_unpack_node((LIST_TMPL_packed_node_ptr_t)hn_new)
	);
}
static void STDCALL LIST_TMPL_NS(InsertNodeAfter)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, HTREEDB_LISTNODE hn
, HTREEDB_LISTNODE hn_new
) {
	LIST_TMPL_NS(insert_node_after)
	( runtime
	, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
	, LIST_TMPL_unpack_node((LIST_TMPL_packed_node_ptr_t)hn)
	, LIST_TMPL_unpack_node((LIST_TMPL_packed_node_ptr_t)hn_new)
	);
}
static void STDCALL LIST_TMPL_NS(RelinkNode)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, HTREEDB_LISTNODE hn
) {
	LIST_TMPL_NS(relink_node)
	( runtime
	, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
	, LIST_TMPL_unpack_node((LIST_TMPL_packed_node_ptr_t)hn)
	);
}
static void STDCALL LIST_TMPL_NS(UnlinkNode)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, HTREEDB_LISTNODE hn
) {
	LIST_TMPL_NS(unlink_node)
	( runtime
	, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
	, LIST_TMPL_unpack_node((LIST_TMPL_packed_node_ptr_t)hn)
	);
}
static void STDCALL LIST_TMPL_NS(DeleteNode)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, HTREEDB_LISTNODE hn
) {
	LIST_TMPL_NS(delete_node)
	( runtime
	, (LIST_TMPL_packed_list_ptr_t)hl
	, LIST_TMPL_unpack_node((LIST_TMPL_packed_node_ptr_t)hn)
	);
}
static BOOL STDCALL LIST_TMPL_NS(NodeHasNext)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LISTNODE hn
) {
	(void)runtime;
	return hn ? (LIST_TMPL_unpack_node(hn)->m_next != 0) : 0;
}
static HTREEDB_LISTNODE STDCALL LIST_TMPL_NS(NodeNext)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LISTNODE hn
) {
	(void)runtime;
	return hn ? (HTREEDB_LISTNODE)(LIST_TMPL_unpack_node(hn)->m_next) : 0;
}
static PVOID STDCALL LIST_TMPL_NS(PointerNodeNext)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LISTNODE hn
) {
	(void)runtime;
	return hn ?
		LIST_TMPL_unpack_node(
			(HTREEDB_LISTNODE)(LIST_TMPL_unpack_node(hn)->m_next))
		: 0;
}
static BOOL STDCALL LIST_TMPL_NS(NodeHasPrev)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LISTNODE hn
) {
	(void)runtime;
	return hn ? (LIST_TMPL_unpack_node(hn)->m_prev != 0) : 0;
}
static HTREEDB_LISTNODE STDCALL LIST_TMPL_NS(NodePrev)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LISTNODE hn
) {
	(void)runtime;
	return hn ? (HTREEDB_LISTNODE)(LIST_TMPL_unpack_node(hn)->m_prev) : 0;
}
static PVOID STDCALL LIST_TMPL_NS(PointerNodePrev)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LISTNODE hn
) {
	(void)runtime;
	return hn ?
		LIST_TMPL_unpack_node(
			(HTREEDB_LISTNODE)(LIST_TMPL_unpack_node(hn)->m_prev))
		: 0;
}
/* Pointer ------------------------------------------------------------------ */
static PVOID STDCALL LIST_TMPL_NS(PushFrontNodePtr)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, PVOID pnode
) {
	if(!pnode)
		return 0;
	LIST_TMPL_node_ptr_t pn = (LIST_TMPL_node_ptr_t)pnode;
	LIST_TMPL_NS(push_front_node)(runtime, LIST_TMPL_unpack_list(hl), pn);
	return pnode;
}
static PVOID STDCALL LIST_TMPL_NS(PushBackNodePtr)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, PVOID pnode
) {
	if(!pnode)
		return 0;
	LIST_TMPL_NS(push_back_node)(runtime
		, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
		, (LIST_TMPL_node_ptr_t)pnode);
	return pnode;
}
static void STDCALL LIST_TMPL_NS(InsertNodeBeforePtr)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, PVOID pn
, PVOID pn_new
) {
	LIST_TMPL_NS(insert_node_before)
	( runtime
	, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
	, (LIST_TMPL_node_ptr_t)pn
	, (LIST_TMPL_node_ptr_t)pn_new
	);
}
static void STDCALL LIST_TMPL_NS(InsertNodeAfterPtr)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, PVOID pn
, PVOID pn_new
) {
	LIST_TMPL_NS(insert_node_after)
	( runtime
	, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
	, (LIST_TMPL_node_ptr_t)pn
	, (LIST_TMPL_node_ptr_t)pn_new
	);
}
static void STDCALL LIST_TMPL_NS(RelinkNodePtr)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, PVOID pn
) {
	LIST_TMPL_NS(relink_node)
	( runtime
	, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
	, (LIST_TMPL_node_ptr_t)pn
	);
}
static void STDCALL LIST_TMPL_NS(UnlinkNodePtr)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, PVOID pnode
) {
	LIST_TMPL_NS(unlink_node)
	( runtime
	, LIST_TMPL_unpack_list((LIST_TMPL_packed_list_ptr_t)hl)
	, (LIST_TMPL_node_ptr_t)pnode
	);
}
static void STDCALL LIST_TMPL_NS(DeleteNodePtr)
( treedb_list_runtime_ptr_t runtime
, HTREEDB_LIST hl
, PVOID pnode
) {
	LIST_TMPL_NS(delete_node)
	( runtime
	, (LIST_TMPL_packed_list_ptr_t)hl
	, (LIST_TMPL_node_ptr_t)pnode
	);
}
static BOOL STDCALL LIST_TMPL_NS(NodeHasNextPtr)
( treedb_list_runtime_ptr_t runtime
, PVOID pnode
) {
	(void)runtime;
	return pnode ? (((LIST_TMPL_node_ptr_t)pnode)->m_next != 0) : 0;
}
static HTREEDB_LISTNODE STDCALL LIST_TMPL_NS(NodeNextPtr)
( treedb_list_runtime_ptr_t runtime
, PVOID pnode
) {
	(void)runtime;
	return pnode ?
		(HTREEDB_LISTNODE)(((LIST_TMPL_node_ptr_t)pnode)->m_next)
		: 0;
}
static PVOID STDCALL LIST_TMPL_NS(PointerNodeNextPtr)
( treedb_list_runtime_ptr_t runtime
, PVOID pnode
) {
	(void)runtime;
	return pnode ?
		LIST_TMPL_unpack_node(
			(HTREEDB_LISTNODE)(((LIST_TMPL_node_ptr_t)pnode)->m_next))
		: 0;
}
static BOOL STDCALL STDCALL LIST_TMPL_NS(NodeHasPrevPtr)
( treedb_list_runtime_ptr_t runtime
, PVOID pnode
) {
	(void)runtime;
	return pnode ? (((LIST_TMPL_node_ptr_t)pnode)->m_prev != 0) : 0;
}
static HTREEDB_LISTNODE STDCALL LIST_TMPL_NS(NodePrevPtr)
( treedb_list_runtime_ptr_t runtime
, PVOID pnode
) {
	(void)runtime;
	return pnode ?
		(HTREEDB_LISTNODE)(((LIST_TMPL_node_ptr_t)pnode)->m_prev)
		: 0;
}
static PVOID STDCALL LIST_TMPL_NS(PointerNodePrevPtr)
( treedb_list_runtime_ptr_t runtime
, PVOID pnode
) {
	(void)runtime;
	return pnode ?
		LIST_TMPL_unpack_node(
			(HTREEDB_LISTNODE)(((LIST_TMPL_node_ptr_t)pnode)->m_prev))
		: 0;
}
#if 0
#define ve(x) v->x = & LIST_TMPL_NS(x)
static void LIST_TMPL_NS(test)(treedb_list_impl_vtbl_t * v)
{
	ve(Init);
	ve(Clear);
	ve(Alloc);
	ve(Free);
	ve(Count);
	ve(PushFront);
	ve(PushBack);
	ve(PopFront);
	ve(PopBack);
	ve(Reverse);

	ve(Head);
	ve(Tail);
	ve(PointerHead);
	ve(PointerTail);

	ve(PushFrontNode);
	ve(PushBackNode);
	ve(InsertNodeBefore);
	ve(InsertNodeAfter);
	ve(UnlinkNode);
	ve(DeleteNode);
	ve(NodeHasNext);
	ve(NodeNext);
	ve(PointerNodeNext);
	ve(NodeHasPrev);
	ve(NodePrev);
	ve(PointerNodePrev);

	ve(PushFrontNodePtr);
	ve(PushBackNodePtr);
	ve(InsertBeforePtr);
	ve(InsertAfterPtr);
	ve(UnlinkNodePtr);
	ve(DeleteNodePtr);
	ve(NodeHasNextPtr);
	ve(NodeNextPtr);
	ve(PointerNodeNextPtr);
	ve(NodeHasPrevPtr);
	ve(NodePrevPtr);
	ve(PointerNodePrevPtr);
}
#endif
treedb_list_impl_vtbl_t LIST_TMPL_NS(vtbl) = {
	V3C_INVOKE1(treedb_list_impl_vtbl_t_entries,LIST_TMPL_NS_)
};
static TreedbItemDescription LIST_TMPL_NS(desc) = {
	{ sizeof(LIST_TMPL_count_t), sizeof(LIST_TMPL_count_t) },
	{ sizeof(LIST_TMPL_NS(list_t)), sizeof(LIST_TMPL_count_t) },
	{ sizeof(LIST_TMPL_NS(node_t)), sizeof(LIST_TMPL_count_t) }
#if (defined(LIST_TMPL_have_count) && defined(LIST_TMPL_POINTER))
, eTreedbContainerHasCount | eTreedbContainerIsPointer
#elif defined(LIST_TMPL_POINTER)
, eTreedbContainerIsPointer
#elif defined(LIST_TMPL_have_count)
, eTreedbContainerHasCount
#else
, 0
#endif
	, V3C_ROUND_UP_T(uint32_t, sizeof(LIST_TMPL_NS(node_t))
		, sizeof(LIST_TMPL_count_t))
};

static treedb_list_impl_t LIST_TMPL_NS(impl) =
{ & LIST_TMPL_NS(vtbl)
, 0
, 0
, & LIST_TMPL_NS(desc)
};
static treedb_list_t LIST_TMPL_NS(list) =
{ & LIST_TMPL_NS(impl)
, 0
};
