/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#include "meta-treedb.h"

static void STDCALL tree_renderer_Add
( treedb_fd_tree_renderer_ptr_t This
, const char * text
, int last
) {
	v3c_tree_printer_add(& This->m_printer, text, last);
}
static void STDCALL tree_renderer_Push
( treedb_fd_tree_renderer_ptr_t This
) {
	v3c_tree_printer_push(& This->m_printer);
}
static void STDCALL tree_renderer_Pop
( treedb_fd_tree_renderer_ptr_t This
) {
	v3c_tree_printer_pop(& This->m_printer);
}
static void STDCALL tree_renderer_Reset
( treedb_fd_tree_renderer_ptr_t This
) {
	v3c_tree_printer_reset(& This->m_printer);
}
static void STDCALL tree_renderer_Term
( treedb_fd_tree_renderer_ptr_t This
) {
	v3c_tree_printer_term(& This->m_printer);
}

treedb_fd_tree_renderer_vtbl_t treedb_fd_tree_renderer_vtbl = {
	treedb_tree_renderer_vtbl_t_entries(tree_renderer_)
};

void render_tree_to_fd
( treedb_tree_ptr_t ptree
, treedb_tree_data_renderer_ptr_t pd
, int fd
) {
	treedb_fd_tree_renderer_t renderer = INIT_TREEDB_FD_TREE_RENDERER(fd);
	treedb_tree_renderer_t_Reset(& renderer);
	treedb_tree_t_Dump(ptree, (treedb_tree_renderer_ptr_t)&renderer, pd);
	treedb_tree_renderer_t_Term(& renderer);
}
