/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_h_included
  #include "meta-treedb.h"
#endif

#ifndef v3c_meta_treedb_allocator_h_included
  #define v3c_meta_treedb_allocator_h_included

  #ifdef __cplusplus
extern "C" {
  #endif

/******************************************************************************/
/* Delegates                                                                  */
/******************************************************************************/
  #define TREEDB_Allocator_DELEGATE_TO(x) \
\
/* Regular methods */ \
\
inline BOOL STDCALL \
	Init(A size_t paysz, size_t size, uint64_t * puPayloadOffs) \
		{ return V3C_DELEGATE(x, Init( DGTHIS(x) Ax paysz, size \
		, puPayloadOffs)); } \
inline int STDCALL \
	Check(A0) \
		{ return V3C_DELEGATE(x, Check(DGTHIS0(x) A0x0)); } \
inline void STDCALL \
	Dump(A treedb_tree_renderer_ptr_t pr, \
			treedb_tree_data_renderer_ptr_t pd) \
		{ return V3C_DELEGATE(x, Dump(DGTHIS(x) Ax pr, pd)); } \
inline BOOL STDCALL \
	LargestFree(A uintptr_t * poffs, uintptr_t * psize) \
		{ return V3C_DELEGATE(x, LargestFree(DGTHIS(x) Ax poffs, psize)); } \
inline uintptr_t STDCALL \
	Size(A0) \
		{ return V3C_DELEGATE(x, Size(DGTHIS0(x) A0x0)); } \
inline void STDCALL \
	DumpSchema(A int fd) \
		{ V3C_DELEGATE(x, DumpSchema(DGTHIS(x) Ax fd)); } \
\
inline HTREEDB_HANDLE STDCALL \
	Alloc(A uintptr_t cb) \
		{ return V3C_DELEGATE(x, Alloc(DGTHIS(x) Ax cb)); } \
inline HTREEDB_HANDLE STDCALL \
	Calloc(A uintptr_t count, uintptr_t cb) \
		{ return V3C_DELEGATE(x, Calloc(DGTHIS(x) Ax count, cb)); } \
inline HTREEDB_HANDLE STDCALL \
	AlignedAlloc(A uintptr_t cb, USHORT align, USHORT offs) \
		{ return V3C_DELEGATE(x, AlignedAlloc(DGTHIS(x) Ax cb, align, offs)); } \
inline HTREEDB_HANDLE STDCALL \
	AlignedCalloc(A uintptr_t count, uintptr_t cb, USHORT align \
			, USHORT offs) \
		{ return V3C_DELEGATE(x, AlignedCalloc(DGTHIS(x) Ax count, cb, align \
		, offs)); } \
\
inline PVOID STDCALL \
	PointerAlloc(A uintptr_t cb) \
		{ return V3C_DELEGATE(x, PointerAlloc(DGTHIS(x) Ax cb)); } \
inline PVOID STDCALL \
	PointerCalloc(A uintptr_t count, uintptr_t cb) \
		{ return V3C_DELEGATE(x, PointerCalloc(DGTHIS(x) Ax count, cb)); } \
inline PVOID STDCALL \
	PointerAlignedAlloc(A uintptr_t cb, USHORT align, USHORT offs) \
		{ return V3C_DELEGATE(x, PointerAlignedAlloc(DGTHIS(x) Ax cb, align \
		, offs)); } \
inline PVOID STDCALL \
	PointerAlignedCalloc(A uintptr_t count, uintptr_t cb, \
			USHORT align, USHORT offs) \
		{ return V3C_DELEGATE(x, PointerAlignedCalloc(DGTHIS(x) Ax count, cb, \
		align, offs)); } \
\
/* "Handle" methods */ \
\
inline HTREEDB_HANDLE STDCALL \
	Realloc(A HTREEDB_HANDLE hloc, uintptr_t cb) \
		{ return V3C_DELEGATE(x, Realloc(DGTHIS(x) Ax hloc, cb)); } \
inline PVOID STDCALL \
	PointerRealloc(A HTREEDB_HANDLE hloc, uintptr_t cb) \
		{ return V3C_DELEGATE(x, PointerRealloc(DGTHIS(x) Ax hloc, cb)); } \
inline TreedbFreeResult STDCALL \
	Free(A HTREEDB_HANDLE hloc) \
		{ return V3C_DELEGATE(x, Free(DGTHIS(x) Ax hloc)); } \
inline uintptr_t STDCALL \
	GetSize(A HTREEDB_HANDLE hloc) \
		{ return V3C_DELEGATE(x, GetSize(DGTHIS(x) Ax hloc)); } \
inline BOOL STDCALL \
	InHeap(A HTREEDB_HANDLE hloc) \
		{ return V3C_DELEGATE(x, InHeap(DGTHIS(x) Ax hloc)); } \
inline BOOL STDCALL \
	DidAlloc(A HTREEDB_HANDLE hloc) \
		{ return V3C_DELEGATE(x, DidAlloc(DGTHIS(x) Ax hloc)); } \
inline HTREEDB_HANDLE STDCALL \
	AlignedRealloc(A HTREEDB_HANDLE hloc, uintptr_t cb, USHORT align \
			, USHORT offs) \
		{ return V3C_DELEGATE(x, AlignedRealloc(DGTHIS(x) Ax hloc, cb, align \
		, offs)); } \
inline PVOID STDCALL \
	PointerAlignedRealloc(A HTREEDB_HANDLE hloc, uintptr_t cb \
			, USHORT align, USHORT offs) \
		{ return V3C_DELEGATE(x, PointerAlignedRealloc(DGTHIS(x) Ax hloc, cb, \
		align, offs)); } \
\
/* "Pointer" methods */ \
\
inline HTREEDB_HANDLE STDCALL \
	ReallocPtr(A PVOID pv, uintptr_t cb) \
		{ return V3C_DELEGATE(x, ReallocPtr(DGTHIS(x) Ax pv, cb)); }\
inline PVOID STDCALL \
	PointerReallocPtr(A PVOID pv, uintptr_t cb) \
		{ return V3C_DELEGATE(x, PointerReallocPtr(DGTHIS(x) Ax pv, cb)); } \
inline TreedbFreeResult STDCALL \
	FreePtr(A PVOID pv) \
		{ return V3C_DELEGATE(x, FreePtr(DGTHIS(x) Ax pv)); } \
inline uintptr_t STDCALL \
	GetSizePtr(A PCVOID pv) \
		{ return V3C_DELEGATE(x, GetSizePtr(DGTHIS(x) Ax pv)); } \
inline BOOL STDCALL \
	InHeapPtr(A PCVOID pv) \
		{ return V3C_DELEGATE(x, InHeapPtr(DGTHIS(x) Ax pv)); } \
inline BOOL STDCALL \
	DidAllocPtr(A PCVOID pv) \
		{ return V3C_DELEGATE(x, DidAllocPtr(DGTHIS(x) Ax pv)); } \
inline HTREEDB_HANDLE STDCALL \
	AlignedReallocPtr(A PVOID pv, uintptr_t cb, USHORT align \
			, USHORT offs) \
		{ return V3C_DELEGATE(x, AlignedReallocPtr(DGTHIS(x) Ax pv, cb, align \
		, offs)); } \
inline PVOID STDCALL \
	PointerAlignedReallocPtr(A PVOID pv, uintptr_t cb \
			, USHORT align, USHORT offs) \
		{ return V3C_DELEGATE(x, PointerAlignedReallocPtr(DGTHIS(x) Ax pv, cb \
		, align, offs)); } \
\
/* Allocator-neutral methods */ \
\
inline const unsigned char * STDCALL \
	Guid() \
		{ return V3C_DELEGATE(x, Guid(DGTHIS0(x))); } \
inline uintptr_t STDCALL \
	PointerToOffset(PCVOID pv) \
		{ return V3C_DELEGATE(x, PointerToOffset(DGTHIS(x) pv)); } \
inline PVOID STDCALL \
	OffsetToPointer(uintptr_t u) \
		{ return V3C_DELEGATE(x, OffsetToPointer(DGTHIS(x) u)); } \
	\
	/* These get the internal representation. */ \
	\
inline uintptr_t STDCALL \
	PointerPack(PCVOID pv) \
		{ return V3C_DELEGATE(x, PointerPack(DGTHIS(x) pv)); } \
inline PVOID STDCALL \
	PointerUnpack(uintptr_t u) \
		{ return V3C_DELEGATE(x, PointerUnpack(DGTHIS(x) u)); } \
\
/* Allocator-neutral "Handle" methods */ \
\
inline uintptr_t STDCALL \
	Read(HTREEDB_HANDLE hloc) \
		{ return V3C_DELEGATE(x, Read(DGTHIS(x) hloc)); } \
inline PVOID STDCALL \
	PointerRead(HTREEDB_HANDLE hloc) \
		{ return V3C_DELEGATE(x, PointerRead(DGTHIS(x) hloc)); } \
inline void STDCALL \
	Write(HTREEDB_HANDLE hloc, uintptr_t value) \
		{ V3C_DELEGATE(x, Write(DGTHIS(x) hloc, value)); } \
	\
	/* My naming convention broke down here :) */ \
	\
inline void STDCALL \
	PointerWrite(HTREEDB_HANDLE hloc, PCVOID value) \
		{ V3C_DELEGATE(x, PointerWrite(DGTHIS(x) hloc, value)); } \
inline void STDCALL \
	AddTo(HTREEDB_HANDLE hloc, uintptr_t u) \
		{ V3C_DELEGATE(x, AddTo(DGTHIS(x) hloc, u)); } \
\
/* Allocator-neutral "Pointer" methods */ \
\
inline HTREEDB_HANDLE STDCALL \
	ReadPtr(PCVOID pv) \
		{ return V3C_DELEGATE(x, ReadPtr(DGTHIS(x) pv)); } \
inline PVOID STDCALL \
	PointerReadPtr(PCVOID pv) \
		{ return V3C_DELEGATE(x, PointerReadPtr(DGTHIS(x) pv)); } \
inline void STDCALL \
	WritePtr(PVOID loc, uintptr_t value) \
		{ V3C_DELEGATE(x, WritePtr(DGTHIS(x) loc, value)); } \
	\
	/* My naming convention broke down here :) */ \
	\
inline void STDCALL \
	PointerWritePtr(PVOID pv, PCVOID value) \
		{ V3C_DELEGATE(x, PointerWritePtr(DGTHIS(x) pv, value)); } \
\
inline void STDCALL \
	AddToPtr(PVOID pv, size_t u) \
		{ V3C_DELEGATE(x, AddToPtr(DGTHIS(x) pv, u)); } \
\
inline uint8_t STDCALL \
	EndianIndex() \
		{ return V3C_DELEGATE(x, EndianIndex(DGTHIS0(x))); } \
inline uint8_t STDCALL \
	EndianSwapIndex() \
		{ return V3C_DELEGATE(x, EndianSwapIndex(DGTHIS0(x))); }

/******************************************************************************/
/* typedefs                                                                   */
/******************************************************************************/
  #ifndef MetaTreedb_allocator_typedefs_DEFINED
	#define MetaTreedb_allocator_typedefs_DEFINED

typedef struct treedb_allocator_impl_t
	treedb_allocator_impl_t
, * treedb_allocator_impl_ptr_t;
typedef const treedb_allocator_impl_t * treedb_allocator_impl_const_ptr_t;

/* Forward-declared in meta-treedb-tree.h
typedef struct treedb_allocator_impl_vtbl_t
	treedb_allocator_impl_vtbl_t
, * treedb_allocator_impl_vtbl_ptr_t;
*/
typedef struct treedb_two_tree_allocator_t
	treedb_two_tree_allocator_t
, * treedb_two_tree_allocator_ptr_t;

typedef struct treedb_two_tree_allocator_impl_t
	treedb_two_tree_allocator_impl_t
, * treedb_two_tree_allocator_impl_ptr_t;

typedef struct treedb_allocator_on_storage_impl_t
	treedb_allocator_on_storage_impl_t
, * treedb_allocator_on_storage_impl_ptr_t;

typedef const treedb_allocator_on_storage_t
	* treedb_const_allocator_on_storage_ptr_t;

	#ifndef __cplusplus
typedef struct treedb_two_tree_allocator_impl_vtbl_t
	treedb_two_tree_allocator_impl_vtbl_t
, * treedb_two_tree_allocator_impl_vtbl_ptr_t;

typedef struct treedb_allocator_on_storage_impl_vtbl_t
	treedb_allocator_on_storage_impl_vtbl_t
, *  treedb_allocator_on_storage_impl_vtbl_ptr_t;
	#endif

  #endif /* #ifndef MetaTreedb_allocator_typedefs_DEFINED */

/******************************************************************************/
/* TreedbAllocatorDescription                                                 */
/******************************************************************************/
  #define TreedbAllocatorDescription_members \
	TreedbItemDescription_members; \
	uint16_t m_aligned_item_size

  #ifndef MetaTreedb_TreedbAllocatorDescription_DEFINED
	#define MetaTreedb_TreedbAllocatorDescription_DEFINED

typedef struct TreedbAllocatorDescription_tag {
	TreedbAllocatorDescription_members;
} TreedbAllocatorDescription;
typedef const TreedbAllocatorDescription * TreedbAllocatorDescriptionConstPtr;

  #endif /* #ifndef MetaTreedb_TreedbAllocatorDescription_DEFINED */

/******************************************************************************/
/* treedb_allocator_impl_t                                                    */
/******************************************************************************/
  #define treedb_allocator_impl_t_methods(Imp, Prefix, Impl, AllocatorPtr) \
\
/* Regular methods */ \
\
	STDMETHOD##Imp##_(BOOL, Prefix##Init) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  size_t /*paysz*/ \
		, size_t /*size*/ \
		, uint64_t * /*puPayloadOffs*/) PURE; \
	STDMETHOD##Imp##_(int, Prefix##Check) \
		( THIS(Impl) \
		  I3dbCLASS0(AllocatorPtr) /*p*/) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Dump) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  treedb_tree_renderer_ptr_t /*pr*/ \
		, treedb_tree_data_renderer_ptr_t /*pd*/) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##LargestFree) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  size_t * /*offs*/ \
		, size_t * /*size*/) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##Size) \
		( THIS(Impl) \
		  I3dbCLASS0(AllocatorPtr) /*p*/) PURE; \
	STDMETHOD##Imp##_(void, Prefix##DumpSchema) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  int /*fd*/) PURE; \
	\
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##Alloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  size_t /*cb*/) PURE; \
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##Calloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  size_t /*count*/ \
		, size_t /*cb*/) PURE; \
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##AlignedAlloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  size_t /*cb*/ \
		, USHORT /*align*/ \
		, USHORT /*offs*/) PURE; \
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##AlignedCalloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  size_t /*count*/ \
		, size_t /*cb*/ \
		, USHORT /*align*/ \
		, USHORT /*offs*/) PURE; \
	\
	STDMETHOD##Imp##_(PVOID, Prefix##PointerAlloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  size_t /*cb*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerCalloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  size_t /*count*/ \
		, size_t /*cb*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerAlignedAlloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  size_t /*cb*/ \
		, USHORT /*align*/ \
		, USHORT /*offs*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerAlignedCalloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  size_t /*count*/ \
		, size_t /*cb*/ \
		, USHORT /*align*/ \
		, USHORT /*offs*/) PURE; \
\
/* "Handle" methods */ \
\
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##Realloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  HTREEDB_HANDLE /*h*/ \
		, size_t /*cb*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerRealloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  HTREEDB_HANDLE /*h*/ \
		, size_t /*cb*/) PURE; \
	STDMETHOD##Imp##_(TreedbFreeResult, Prefix##Free) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  HTREEDB_HANDLE /*h*/) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##GetSize) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  HTREEDB_HANDLE /*hloc*/) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##InHeap) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  HTREEDB_HANDLE /*hloc*/) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##DidAlloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  HTREEDB_HANDLE /*hloc*/) PURE; \
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##AlignedRealloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  HTREEDB_HANDLE /*h*/ \
		, size_t /*cb*/ \
		, USHORT /*align*/ \
		, USHORT /*offs*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerAlignedRealloc) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  HTREEDB_HANDLE /*h*/ \
		, size_t /*cb*/ \
		, USHORT /*align*/ \
		, USHORT /*offs*/) PURE; \
\
/* "Pointer" methods */ \
\
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##ReallocPtr) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  PVOID /*pv*/ \
		, size_t /*cb*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerReallocPtr) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  PVOID /*pv*/ \
		, size_t /*cb*/) PURE; \
	STDMETHOD##Imp##_(TreedbFreeResult, Prefix##FreePtr) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  PVOID /*pv*/) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##GetSizePtr) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  PCVOID /*pv*/) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##InHeapPtr) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  PCVOID /*pv*/) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##DidAllocPtr) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  PCVOID /*pv*/) PURE; \
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##AlignedReallocPtr) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  PVOID /*pv*/ \
		, size_t /*cb*/ \
		, USHORT /*align*/ \
		, USHORT /*offs*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerAlignedReallocPtr) \
		( THIS(Impl) \
		  I3dbCLASS(AllocatorPtr) /*p*/ \
		  PVOID /*pv*/ \
		, size_t /*cb*/ \
		, USHORT /*align*/ \
		, USHORT /*offs*/) PURE; \
\
/* Allocator-neutral methods */ \
\
	STDMETHOD##Imp##_(const unsigned char *, Prefix##Guid) \
		( THIS0(Impl)) PURE; \
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##PointerToOffset) \
		( THIS(Impl) \
		  PCVOID /*pv*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##OffsetToPointer) \
		( THIS(Impl) \
		  HTREEDB_HANDLE /*u*/) PURE; \
	\
	/* These get the internal representation. */ \
	\
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##PointerPack) \
		( THIS(Impl) \
		  PCVOID /*pv*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerUnpack) \
		( THIS(Impl) \
		  HTREEDB_HANDLE /*loc*/) PURE; \
\
/* Allocator-neutral "Handle" methods */ \
\
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##Read) \
		( THIS(Impl) \
		  HTREEDB_HANDLE /*hloc*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerRead) \
		( THIS(Impl) \
		  HTREEDB_HANDLE /*hloc*/) PURE; \
	\
	STDMETHOD##Imp##_(void, Prefix##Write) \
		( THIS(Impl) \
		  HTREEDB_HANDLE /*hloc*/ \
		, HTREEDB_HANDLE /*value*/) PURE; \
	\
	/* My naming convention broke down here :) */ \
	\
	STDMETHOD##Imp##_(void, Prefix##PointerWrite) \
		( THIS(Impl) \
		  HTREEDB_HANDLE /*hloc*/ \
		, PCVOID /*pvvalue*/) PURE; \
	STDMETHOD##Imp##_(void, Prefix##AddTo) \
		( THIS(Impl) \
		  HTREEDB_HANDLE /*hloc*/ \
		, size_t /*u*/) PURE; \
\
/* Allocator-neutral "Pointer" methods */ \
\
	STDMETHOD##Imp##_(HTREEDB_HANDLE, Prefix##ReadPtr) \
		( THIS(Impl) \
		  PCVOID /*pv*/) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerReadPtr) \
		( THIS(Impl) \
		  PCVOID /*pv*/) PURE; \
	\
	STDMETHOD##Imp##_(void, Prefix##WritePtr) \
		( THIS(Impl) \
		  PVOID /*pv*/ \
		, HTREEDB_HANDLE /*hvalue*/) PURE; \
	\
	/* My naming convention broke down here :) */ \
	\
	STDMETHOD##Imp##_(void, Prefix##PointerWritePtr) \
		( THIS(Impl) \
		  PVOID /*pv*/ \
		, PCVOID /*value*/) PURE; \
	STDMETHOD##Imp##_(void, Prefix##AddToPtr) \
		( THIS(Impl) \
		  PVOID /*pv*/ \
		, size_t /*u*/) PURE; \
	\
	STDMETHOD##Imp##_(uint8_t, Prefix##EndianIndex) \
		( THIS0(Impl) ) PURE; \
	STDMETHOD##Imp##_(uint8_t, Prefix##EndianSwapIndex) \
		( THIS0(Impl) ) PURE

  #ifdef COBJMACROS

/*============================= "Regular" methods ============================*/

	#define treedb_allocator_impl_t_Init(This, AllocatorPtr, paysz, sz, pu) \
	  V3C_IFACE_CALL(Init, This, AllocatorPtr, paysz, sz, pu)
	#define treedb_allocator_impl_t_Check(This, AllocatorPtr) \
	  V3C_IFACE_CALL(Check, This, AllocatorPtr)
	#define treedb_allocator_impl_t_Dump(This, AllocatorPtr, pr, pd) \
	  V3C_IFACE_CALL(Dump, This, AllocatorPtr, pr, pd)
	#define treedb_allocator_impl_t_LargestFree(This, AllocatorPtr, poffs, psz) \
	  V3C_IFACE_CALL(LargestFree, This, AllocatorPtr, poffs, psz)
	#define treedb_allocator_impl_t_Size(This, AllocatorPtr) \
	  V3C_IFACE_CALL(Size, This, AllocatorPtr)
	#define treedb_allocator_impl_t_DumpSchema(This, AllocatorPtr, fd) \
	  V3C_IFACE_CALL(DumpSchema, This, AllocatorPtr, fd)

	#define treedb_allocator_impl_t_Alloc(This, AllocatorPtr, cb) \
	  V3C_IFACE_CALL(Alloc, This, AllocatorPtr, cb)
	#define treedb_allocator_impl_t_Calloc(This, AllocatorPtr, count, cb) \
	  V3C_IFACE_CALL(Calloc, This, AllocatorPtr, count, cb)
	#define treedb_allocator_impl_t_AlignedAlloc(This, AllocatorPtr, cb, align \
		, offs) \
	  V3C_IFACE_CALL(AlignedAlloc, This, AllocatorPtr, cb, align, offs)
	#define treedb_allocator_impl_t_AlignedCalloc(This, AllocatorPtr, count, cb \
		, align, offs) \
	  V3C_IFACE_CALL(AlignedCalloc, This, AllocatorPtr, count, cb, align, offs)

	#define treedb_allocator_impl_t_PointerAlloc(This, AllocatorPtr, cb) \
	  V3C_IFACE_CALL(PointerAlloc, This, AllocatorPtr, cb)
	#define treedb_allocator_impl_t_PointerCalloc(This, AllocatorPtr, count \
		, cb) \
	  V3C_IFACE_CALL(PointerCalloc, This, AllocatorPtr, count, cb)
	#define treedb_allocator_impl_t_PointerAlignedAlloc(This, AllocatorPtr, cb \
		, align, offs) \
	  V3C_IFACE_CALL(PointerAlignedAlloc, This, AllocatorPtr, cb, align, offs)
	#define treedb_allocator_impl_t_PointerAlignedCalloc(This, AllocatorPtr \
		, count, cb, align, offs) \
	  V3C_IFACE_CALL(PointerAlignedCalloc, This, AllocatorPtr, count, cb \
		, align, offs)

/*============================= "Handle" methods =============================*/

	#define treedb_allocator_impl_t_Realloc(This, AllocatorPtr, h, cb) \
	  V3C_IFACE_CALL(Realloc, This, AllocatorPtr, h, cb)
	#define treedb_allocator_impl_t_PointerRealloc(This, AllocatorPtr, h, cb) \
	  V3C_IFACE_CALL(PointerRealloc, This, AllocatorPtr, h, cb)
	#define treedb_allocator_impl_t_Free(This, AllocatorPtr, hloc) \
	  V3C_IFACE_CALL(Free, This, AllocatorPtr, hloc)
	#define treedb_allocator_impl_t_GetSize(This, AllocatorPtr, hloc) \
	  V3C_IFACE_CALL(GetSize, This, AllocatorPtr, hloc)
	#define treedb_allocator_impl_t_InHeap(This, AllocatorPtr, hloc) \
	  V3C_IFACE_CALL(InHeap, This, AllocatorPtr, hloc)
	#define treedb_allocator_impl_t_DidAlloc(This, AllocatorPtr, hloc) \
	  V3C_IFACE_CALL(DidAlloc, This, AllocatorPtr, hloc)
	#define treedb_allocator_impl_t_AlignedRealloc(This, AllocatorPtr, h, cb \
		, align, offs) \
	  V3C_IFACE_CALL(AlignedRealloc, This, AllocatorPtr, h, cb, align, offs)
	#define treedb_allocator_impl_t_PointerAlignedRealloc(This, AllocatorPtr \
		, h, cb, align, offs) \
	  V3C_IFACE_CALL(PointerAlignedRealloc, This, AllocatorPtr, h, cb, align \
		, offs)

/*============================= "Pointer" methods ============================*/

	#define treedb_allocator_impl_t_ReallocPtr(This, AllocatorPtr, pv, cb) \
	  V3C_IFACE_CALL(ReallocPtr, This, AllocatorPtr, pv, cb)
	#define treedb_allocator_impl_t_PointerReallocPtr(This, AllocatorPtr, pv \
		, cb) \
	  V3C_IFACE_CALL(PointerReallocPtr, This, AllocatorPtr, pv, cb)
	#define treedb_allocator_impl_t_FreePtr(This, AllocatorPtr, pv) \
	  V3C_IFACE_CALL(FreePtr, This, AllocatorPtr, pv)
	#define treedb_allocator_impl_t_GetSizePtr(This, AllocatorPtr, pv) \
	  V3C_IFACE_CALL(GetSizePtr, This, AllocatorPtr, pv)
	#define treedb_allocator_impl_t_InHeapPtr(This, AllocatorPtr, pv) \
	  V3C_IFACE_CALL(InHeapPtr, This, AllocatorPtr, pv)
	#define treedb_allocator_impl_t_DidAllocPtr(This, AllocatorPtr, pv) \
	  V3C_IFACE_CALL(DidAllocPtr, This, AllocatorPtr, pv)
	#define treedb_allocator_impl_t_AlignedReallocPtr(This, AllocatorPtr, h \
		, cb, align, offs) \
	  V3C_IFACE_CALL(AlignedReallocPtr, This, AllocatorPtr, h, cb, align, offs)
	#define treedb_allocator_impl_t_PointerAlignedReallocPtr(This \
		, AllocatorPtr, h, cb, align, offs) \
	  V3C_IFACE_CALL(PointerAlignedReallocPtr, This, AllocatorPtr, h, cb \
		, align, offs)

/*========================= Allocator-neutral methods ========================*/

	#define treedb_allocator_impl_t_Guid(This) \
	  V3C_IFACE_CALL(Guid, This)
	#define treedb_allocator_impl_t_PointerToOffset(This, pv) \
	  V3C_IFACE_CALL(PointerToOffset, This, pv)
	#define treedb_allocator_impl_t_OffsetToPointer(This, hloc) \
	  V3C_IFACE_CALL(OffsetToPointer, This, hloc)

/*------------------- These get the internal representation ------------------*/

	#define treedb_allocator_impl_t_PointerPack(This, pv) \
	  V3C_IFACE_CALL(PointerPack, This, pv)
	#define treedb_allocator_impl_t_PointerUnpack(This, hloc) \
	  V3C_IFACE_CALL(PointerUnpack, This, hloc)

/*===================== Allocator-neutral "Handle" methods ===================*/

	#define treedb_allocator_impl_t_Read(This, hloc) \
	  V3C_IFACE_CALL(Read, This, hloc)
	#define treedb_allocator_impl_t_PointerRead(This, hloc) \
	  V3C_IFACE_CALL(PointerRead, This, hloc)
	#define treedb_allocator_impl_t_Write(This, hloc, hvalue) \
	  V3C_IFACE_CALL(Write, This, hloc, hvalue)

/*------------------- My naming convention broke down here :) ----------------*/

	#define treedb_allocator_impl_t_PointerWrite(This, hloc, pvvalue) \
	  V3C_IFACE_CALL(PointerWrite, This, hloc, pvvalue)
	#define treedb_allocator_impl_t_AddTo(This, hloc, u) \
	  V3C_IFACE_CALL(AddTo, This, hloc, u)

/*===================== Allocator-neutral "Pointer" methods ==================*/

	#define treedb_allocator_impl_t_ReadPtr(This, pv) \
	  V3C_IFACE_CALL(ReadPtr, This, pv)
	#define treedb_allocator_impl_t_PointerReadPtr(This, pv) \
	  V3C_IFACE_CALL(PointerReadPtr, This, pv)
	#define treedb_allocator_impl_t_WritePtr(This, pv, hvalue) \
	  V3C_IFACE_CALL(WritePtr, This, pv, hvalue)

/*------------------- My naming convention broke down here :) ----------------*/

	#define treedb_allocator_impl_t_PointerWritePtr(This, pv, pvvalue) \
	  V3C_IFACE_CALL(PointerWritePtr, This, pv, pvvalue)

	#define treedb_allocator_impl_t_AddToPtr(This, pv, u) \
	  V3C_IFACE_CALL(AddToPtr, This, pv, u)

	#define treedb_allocator_impl_t_EndianIndex(This) \
	  V3C_IFACE_CALL(EndianIndex, This)
	#define treedb_allocator_impl_t_EndianSwapIndex(This) \
	  V3C_IFACE_CALL(EndianSwapIndex, This)

  #endif /* #ifdef COBJMACROS */

  #define treedb_allocator_impl_vtbl_t_entries_default(Prefix) \
/* Regular methods */ \
\
  & Prefix##Init \
, & Prefix##Check \
, & Prefix##Dump \
, & Prefix##LargestFree \
, & Prefix##Size \
, & Prefix##DumpSchema \
\
, & Prefix##Alloc \
, & Prefix##Calloc \
, & Prefix##AlignedAlloc \
, & Prefix##AlignedCalloc \
\
, & Prefix##PointerAlloc \
, & Prefix##PointerCalloc \
, & Prefix##PointerAlignedAlloc \
, & Prefix##PointerAlignedCalloc \
\
/* "Handle" methods */ \
\
, & Prefix##Realloc \
, & Prefix##PointerRealloc \
, & Prefix##Free \
, & Prefix##GetSize \
, & Prefix##InHeap \
, & Prefix##DidAlloc \
, & Prefix##AlignedRealloc \
, & Prefix##PointerAlignedRealloc \
\
/* "Pointer" methods */ \
\
, & Prefix##ReallocPtr \
, & Prefix##PointerReallocPtr \
, & Prefix##FreePtr \
, & Prefix##GetSizePtr \
, & Prefix##InHeapPtr \
, & Prefix##DidAllocPtr \
, & Prefix##AlignedReallocPtr \
, & Prefix##PointerAlignedReallocPtr \
\
/* Allocator-neutral methods */ \
\
, & Prefix##Guid \
, & Prefix##PointerToOffset \
, & Prefix##OffsetToPointer \
	\
	/* These get the internal representation. */ \
	\
, & Prefix##PointerPack \
, & Prefix##PointerUnpack \
\
/* Allocator-neutral "Handle" methods */ \
\
, & Prefix##Read \
, & Prefix##PointerRead \
, & Prefix##Write \
	\
	/* My naming convention broke down here :) */ \
	\
, & Prefix##PointerWrite \
, & Prefix##AddTo \
\
/* Allocator-neutral "Pointer" methods */ \
\
, & Prefix##ReadPtr \
, & Prefix##PointerReadPtr \
, & Prefix##WritePtr \
	\
	/* My naming convention broke down here :) */ \
	\
, & Prefix##PointerWritePtr \
, & Prefix##AddToPtr \
\
, & Prefix##EndianIndex \
, & Prefix##EndianSwapIndex

  #ifndef treedb_allocator_impl_vtbl_t_entries
	#define treedb_allocator_impl_vtbl_t_entries(x) \
	  treedb_allocator_impl_vtbl_t_entries_default(x)
  #endif

  #ifndef MetaTreedb_treedb_allocator_impl_t_DEFINED
	#define MetaTreedb_treedb_allocator_impl_t_DEFINED

	#define TreedbAllocator_impl_members \
	  TreedbAllocatorDescriptionConstPtr m_pDescription

	#define treedb_allocator_impl_t_members(vtbl_ptr_t) \
	  vtbl_ptr_t m_pVtbl; \
	  TreedbAllocator_impl_members

	#ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
	#define I3dbCLASS(AllocatorPtr) treedb_allocator_ptr_t,
	#define I3dbCLASS0(AllocatorPtr) treedb_allocator_ptr_t
struct treedb_allocator_impl_vtbl_t
{
	treedb_allocator_impl_t_methods
	(,, treedb_allocator_impl_t, treedb_allocator_ptr_t);
};
	#undef I3dbCLASS
	#undef I3dbCLASS0
	#ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_allocator_impl_t
{
  #ifdef __cplusplus
	#define DGTHIS0(x) this
	#define DGTHIS(x) this,
	#define V3C_DELEGATE(pInst, x) m_pVtbl->x

	#define A treedb_allocator_ptr_t pa,
	#define A0 treedb_allocator_ptr_t pa
	#define Ax pa,
	#define Ax0 pa
	#define A0x0 , pa
	TREEDB_Allocator_DELEGATE_TO();
	#undef DGTHIS0
	#undef DGTHIS
	#undef V3C_DELEGATE

	#undef A
	#undef A0
	#undef Ax
	#undef Ax0
	#undef A0x0
  #endif
	treedb_allocator_impl_t_members(treedb_allocator_impl_vtbl_ptr_t);
};

	#define META_TREEDB_ALLOCATOR_IMPL_INIT_BARE 0, 0
	#define META_TREEDB_ALLOCATOR_IMPL_INIT \
	  { META_TREEDB_ALLOCATOR_IMPL_INIT_BARE }

  #endif /* #ifndef MetaTreedb_treedb_allocator_t_DEFINED */

/******************************************************************************/
/* treedb_allocator_t                                                         */
/******************************************************************************/
/* TODO provide a pointer to the allocator that failed. */
typedef void (* MetaTreedbAllocatorAbortFn)(TreedbError);
  #define treedb_allocator_t_members(ImplPtr)  \
	ImplPtr m_pImpl; \
	MetaTreedbAllocatorAbortFn m_abort_fn; \
	int m_errno
struct treedb_allocator_t {
	treedb_allocator_t_members(treedb_allocator_impl_ptr_t);
  #ifdef __cplusplus
	#define DGTHIS0(x)
	#define DGTHIS(x)
	#define V3C_DELEGATE(pInst, x) (pInst)->x

	#define A
	#define A0
	#define Ax this,
	#define Ax0 this,
	#define A0x0 this
	TREEDB_Allocator_DELEGATE_TO(m_pImpl);
	#undef DGTHIS0
	#undef DGTHIS
	#undef V3C_DELEGATE

	#undef A
	#undef A0
	#undef Ax
	#undef Ax0
	#undef A0x0
  #endif
};
  #define META_TREEDB_ALLOCATOR_INIT_BARE 0, & v3c_treedb_allocator_abort, 0
  #define META_TREEDB_ALLOCATOR_INIT { META_TREEDB_ALLOCATOR_INIT_BARE }

  #ifdef COBJMACROS

/*============================= "Regular" methods ============================*/

	#define treedb_allocator_t_Init(This, paysz, sz, pu) \
	  treedb_allocator_impl_t_Init((This)->m_pImpl, This, paysz, sz, pu)
	#define treedb_allocator_t_Check(This) \
	  treedb_allocator_impl_t_Check((This)->m_pImpl, This)
	#define treedb_allocator_t_Dump(This, pr, pd) \
	  treedb_allocator_impl_t_Dump((This)->m_pImpl, This, pr, pd)
	#define treedb_allocator_t_LargestFree(This, poffs, psz) \
	  treedb_allocator_impl_t_LargestFree((This)->m_pImpl, This, poffs, psz)
	#define treedb_allocator_t_Size(This) \
	  treedb_allocator_impl_t_Size((This)->m_pImpl, This)
	#define treedb_allocator_t_DumpSchema(This, fd) \
	  treedb_allocator_impl_t_DumpSchema((This)->m_pImpl, This, fd)

	#define treedb_allocator_t_Alloc(This, cb) \
	  treedb_allocator_impl_t_Alloc((This)->m_pImpl, This, cb)
	#define treedb_allocator_t_Calloc(This, count, cb) \
	  treedb_allocator_impl_t_Calloc((This)->m_pImpl, This, count, cb)
	#define treedb_allocator_t_AlignedAlloc(This, cb, align, offs) \
	  treedb_allocator_impl_t_AlignedAlloc((This)->m_pImpl, This, cb, align \
		, offs)
	#define treedb_allocator_t_AlignedCalloc(This, count, cb, align, offs) \
	  treedb_allocator_impl_t_AlignedCalloc((This)->m_pImpl, This, count, cb \
		, align, offs)

	#define treedb_allocator_t_PointerAlloc(This, cb) \
	  treedb_allocator_impl_t_PointerAlloc((This)->m_pImpl, This, cb)
	#define treedb_allocator_t_PointerCalloc(This, count, cb) \
	  treedb_allocator_impl_t_PointerCalloc((This)->m_pImpl, This, count, cb)
	#define treedb_allocator_t_PointerAlignedAlloc(This, cb, align, offs) \
	  treedb_allocator_impl_t_PointerAlignedAlloc((This)->m_pImpl, This, cb \
		, align, offs)
	#define treedb_allocator_t_PointerAlignedCalloc(This, count, cb, align \
		, offs) \
	  treedb_allocator_impl_t_PointerAlignedCalloc((This)->m_pImpl, This, count \
		, cb, align, offs)

/*============================= "Handle" methods =============================*/

	#define treedb_allocator_t_Realloc(This, h, cb) \
	  treedb_allocator_impl_t_Realloc((This)->m_pImpl, This, h, cb)
	#define treedb_allocator_t_PointerRealloc(This, h, cb) \
	  treedb_allocator_impl_t_PointerRealloc((This)->m_pImpl, This, h, cb)
	#define treedb_allocator_t_Free(This, h) \
	  treedb_allocator_impl_t_Free((This)->m_pImpl, This, h)
	#define treedb_allocator_t_GetSize(This, h) \
	  treedb_allocator_impl_t_GetSize((This)->m_pImpl, This, h)
	#define treedb_allocator_t_InHeap(This, h) \
	  treedb_allocator_impl_t_InHeap((This)->m_pImpl, This, h)
	#define treedb_allocator_t_DidAlloc(This, h) \
	  treedb_allocator_impl_t_DidAlloc((This)->m_pImpl, This, h)
	#define treedb_allocator_t_AlignedRealloc(This, h, cb, align, offs) \
	  treedb_allocator_impl_t_AlignedRealloc((This)->m_pImpl, This, h, cb \
		, align, offs)
	#define treedb_allocator_t_PointerAlignedRealloc(This, h, cb, align, offs) \
	  treedb_allocator_impl_t_PointerAlignedRealloc((This)->m_pImpl, This, h \
		, cb, align, offs)

/*============================= "Pointer" methods ============================*/

	#define treedb_allocator_t_ReallocPtr(This, pv, cb) \
	  treedb_allocator_impl_t_ReallocPtr((This)->m_pImpl, This, pv, cb)
	#define treedb_allocator_t_PointerReallocPtr(This, pv, cb) \
	  treedb_allocator_impl_t_PointerReallocPtr((This)->m_pImpl, This, pv, cb)
	#define treedb_allocator_t_FreePtr(This, pv) \
	  treedb_allocator_impl_t_FreePtr((This)->m_pImpl, This, pv)
	#define treedb_allocator_t_GetSizePtr(This, pv) \
	  treedb_allocator_impl_t_GetSizePtr((This)->m_pImpl, This, pv)
	#define treedb_allocator_t_InHeapPtr(This, pv) \
	  treedb_allocator_impl_t_InHeapPtr((This)->m_pImpl, This, pv)
	#define treedb_allocator_t_DidAllocPtr(This, pv) \
	  treedb_allocator_impl_t_DidAllocPtr((This)->m_pImpl, This, pv)
	#define treedb_allocator_t_AlignedReallocPtr(This, pv, cb, align, offs) \
	  treedb_allocator_impl_t_AlignedReallocPtr((This)->m_pImpl, This, pv, cb \
		, align, offs)
	#define treedb_allocator_t_PointerAlignedReallocPtr(This, pv, cb, align \
		, offs) \
	  treedb_allocator_impl_t_PointerAlignedReallocPtr((This)->m_pImpl, This, pv \
		, cb, align, offs)

/*========================= Allocator-neutral methods ========================*/

	#define treedb_allocator_t_Guid(This) \
	  treedb_allocator_impl_t_Guid((This)->m_pImpl)
	#define treedb_allocator_t_PointerToOffset(This, pv) \
	  treedb_allocator_impl_t_PointerToOffset((This)->m_pImpl, pv)
	#define treedb_allocator_t_OffsetToPointer(This, u) \
	  treedb_allocator_impl_t_OffsetToPointer((This)->m_pImpl, u)

/*------------------- These get the internal representation ------------------*/

	#define treedb_allocator_t_PointerPack(This, pv) \
	  treedb_allocator_impl_t_PointerPack((This)->m_pImpl, pv)
	#define treedb_allocator_t_PointerUnpack(This, hloc) \
	  treedb_allocator_impl_t_PointerUnpack((This)->m_pImpl, hloc)

/*===================== Allocator-neutral "Handle" methods ===================*/

	#define treedb_allocator_t_Read(This, hloc) \
	  treedb_allocator_impl_t_Read((This)->m_pImpl, hloc)
	#define treedb_allocator_t_PointerRead(This, hloc) \
	  treedb_allocator_impl_t_PointerRead((This)->m_pImpl, hloc)
	#define treedb_allocator_t_Write(This, hloc, hvalue) \
	  treedb_allocator_impl_t_Write((This)->m_pImpl, hloc, hvalue)

/*------------------- My naming convention broke down here :) ----------------*/

	#define treedb_allocator_t_PointerWrite(This, hloc, pv) \
	  treedb_allocator_impl_t_PointerWrite((This)->m_pImpl, hloc, pv)
	#define treedb_allocator_t_AddTo(This, hloc, u) \
	  treedb_allocator_impl_t_AddTo((This)->m_pImpl, hloc, u)

/*===================== Allocator-neutral "Pointer" methods ==================*/

	#define treedb_allocator_t_ReadPtr(This, pv) \
	  treedb_allocator_impl_t_ReadPtr((This)->m_pImpl, pv)
	#define treedb_allocator_t_PointerReadPtr(This, pv) \
	  treedb_allocator_impl_t_PointerReadPtr((This)->m_pImpl, pv)
	#define treedb_allocator_t_WritePtr(This, pv, hvalue) \
	  treedb_allocator_impl_t_WritePtr((This)->m_pImpl, pv, hvalue)

/*------------------- My naming convention broke down here :) ----------------*/

	#define treedb_allocator_t_PointerWritePtr(This, pv, pvvalue) \
	  treedb_allocator_impl_t_PointerWritePtr((This)->m_pImpl, pv, pvvalue)
	#define treedb_allocator_t_AddToPtr(This, pv, u) \
	  treedb_allocator_impl_t_AddToPtr((This)->m_pImpl, pv, u)

	#define treedb_allocator_t_EndianIndex(This) \
	  treedb_allocator_impl_t_EndianIndex((This)->m_pImpl)

	#define treedb_allocator_t_EndianSwapIndex(This) \
	  treedb_allocator_impl_t_EndianSwapIndex((This)->m_pImpl)

	#define treedb_allocator_t_Good(This) ((This)->m_errno == 0)
	#define treedb_allocator_t_Error(This) ((This)->m_errno)

  #endif /* #ifdef COBJMACROS */

/******************************************************************************/
/* treedb_two_tree_allocator_impl_t                                           */
/******************************************************************************/
  #define treedb_two_tree_allocator_impl_t_members(vtbl_ptr_t) \
	treedb_allocator_impl_t_members(vtbl_ptr_t)

  #ifndef MetaTreedb_treedb_two_tree_allocator_impl_t_DEFINED
	#define MetaTreedb_treedb_two_tree_allocator_impl_t_DEFINED

	#define META_TREEDB_TWO_TREE_ALLOCATOR_IMPL_INIT_BARE \
	  META_TREEDB_ALLOCATOR_IMPL_INIT_BARE

	#define META_TREEDB_TWO_TREE_ALLOCATOR_IMPL_INIT \
	  { META_TREEDB_TWO_TREE_ALLOCATOR_IMPL_INIT_BARE }

struct treedb_two_tree_allocator_impl_t
  #ifdef __cplusplus
: treedb_allocator_impl_t
  #endif
{
  #ifdef __cplusplus
	#define DGTHIS0(x) this
	#define DGTHIS(x) this,
	#define V3C_DELEGATE(pInst, x) m_pVtbl->x

	#define A treedb_allocator_ptr_t pa,
	#define A0 treedb_allocator_ptr_t pa
	#define Ax pa,
	#define Ax0 pa
	#define A0x0 , pa
	TREEDB_Allocator_DELEGATE_TO();
	#undef DGTHIS0
	#undef DGTHIS
	#undef V3C_DELEGATE

	#undef A
	#undef A0
	#undef Ax
	#undef Ax0
	#undef A0x0
  #else
	treedb_two_tree_allocator_impl_t_members
		(treedb_allocator_impl_vtbl_ptr_t);
  #endif
};
  #endif /* #ifndef MetaTreedb_treedb_two_tree_allocator_t_DEFINED */

extern void treedb_two_tree_allocator_Setup
(treedb_two_tree_allocator_ptr_t p);

extern void treedb_allocator_t_check_result
	(treedb_allocator_ptr_t This, int res);

/******************************************************************************/
/* treedb_two_tree_allocator_t                                                */
/******************************************************************************/
  #define c_treedb_two_tree_allocator_t_members(Impl)  \
	treedb_allocator_t_members(Impl); \
	treedb_tree_t m_free, m_used

  #define cxx_treedb_two_tree_allocator_t_members(Impl)  \
	treedb_tree_t m_free, m_used

struct treedb_two_tree_allocator_t
  #ifdef __cplusplus
: treedb_allocator_t
  #endif
{
  #ifdef __cplusplus
	#define DGTHIS0(x)
	#define DGTHIS(x)
	#define V3C_DELEGATE(pInst, x) (pInst)->x

	#define A
	#define A0
	#define Ax this,
	#define Ax0 this,
	#define A0x0 this
	TREEDB_Allocator_DELEGATE_TO(m_pImpl);
	#undef DGTHIS0
	#undef DGTHIS
	#undef V3C_DELEGATE

	#undef A
	#undef A0
	#undef Ax
	#undef Ax0
	#undef A0x0
	cxx_treedb_two_tree_allocator_t_members
		(treedb_two_tree_allocator_impl_ptr_t);
  #else
	c_treedb_two_tree_allocator_t_members(treedb_two_tree_allocator_impl_ptr_t);
  #endif
};
  #define META_TREEDB_TWO_TREE_ALLOCATOR_INIT_BARE \
	META_TREEDB_ALLOCATOR_INIT_BARE, META_TREEDB_TREE_INIT \
	  , META_TREEDB_TREE_INIT

  #define META_TREEDB_TWO_TREE_ALLOCATOR_INIT \
	{ META_TREEDB_TWO_TREE_ALLOCATOR_INIT_BARE }

/******************************************************************************/
/* treedb_allocator_on_storage_impl_t                                         */
/******************************************************************************/
  #ifndef MetaTreedb_treedb_allocator_on_storage_t_DEFINED
	#define MetaTreedb_treedb_allocator_on_storage_t_DEFINED

	#ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
	#define I3dbCLASS(AllocatorPtr) treedb_allocator_on_storage_ptr_t pa,
	#define I3dbCLASS0(AllocatorPtr) treedb_allocator_on_storage_ptr_t pa
struct treedb_allocator_on_storage_impl_vtbl_t
{
	treedb_allocator_impl_t_methods
	(,,treedb_allocator_on_storage_impl_t, treedb_allocator_on_storage_ptr_t);
};
	#undef I3dbCLASS
	#undef I3dbCLASS0
	#ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_allocator_on_storage_impl_t
  #ifdef __cplusplus
: treedb_two_tree_allocator_impl_t
  #endif
{
  #ifdef __cplusplus
	#define DGTHIS0(x) this
	#define DGTHIS(x) this,
	#define V3C_DELEGATE(pInst, x) this->m_pVtbl->x

	#define A treedb_allocator_on_storage_ptr_t pa,
	#define A0 treedb_allocator_on_storage_ptr_t pa
	#define Ax (treedb_allocator_ptr_t)pa,
	#define Ax0 (treedb_allocator_ptr_t)pa
	#define A0x0 , (treedb_allocator_ptr_t)pa
	TREEDB_Allocator_DELEGATE_TO();
	#undef DGTHIS0
	#undef DGTHIS
	#undef V3C_DELEGATE

	#undef A
	#undef A0
	#undef Ax
	#undef Ax0
	#undef A0x0
  #else
	treedb_two_tree_allocator_impl_t_members
		(treedb_allocator_on_storage_impl_vtbl_ptr_t);
  #endif

	treedb_storage_ptr_t m_pStorage;
};

	#define META_TREEDB_ALLOCATOR_ON_STORAGE_IMPL_INIT_BARE \
	  META_TREEDB_TWO_TREE_ALLOCATOR_IMPL_INIT_BARE, 0

	#define META_TREEDB_ALLOCATOR_ON_STORAGE_IMPL_INIT \
	  { META_TREEDB_ALLOCATOR_ON_STORAGE_IMPL_INIT_BARE }

	#define treedb_allocator_on_storage_t_Setup(x) \
	  treedb_two_tree_allocator_Setup((treedb_two_tree_allocator_ptr_t)x);

/******************************************************************************/
/* treedb_allocator_on_storage_t                                              */
/******************************************************************************/
struct treedb_allocator_on_storage_t
  #ifdef __cplusplus
: treedb_two_tree_allocator_t
  #endif
{
  #ifdef __cplusplus
	#define DGTHIS0(x)
	#define DGTHIS(x)
	#define V3C_DELEGATE(pInst, x) (pInst)->x

	#define A
	#define A0
	#define Ax this,
	#define Ax0 this,
	#define A0x0 this
	TREEDB_Allocator_DELEGATE_TO(m_pImpl);
	#undef DGTHIS0
	#undef DGTHIS
	#undef V3C_DELEGATE

	#undef A
	#undef A0
	#undef Ax
	#undef Ax0
	#undef A0x0
  #else
	c_treedb_two_tree_allocator_t_members
		(treedb_allocator_on_storage_impl_ptr_t);
  #endif
};
  #define META_TREEDB_ALLOCATOR_ON_STORAGE_INIT_BARE \
	META_TREEDB_TWO_TREE_ALLOCATOR_INIT_BARE

  #define META_TREEDB_ALLOCATOR_ON_STORAGE_INIT \
	META_TREEDB_TWO_TREE_ALLOCATOR_INIT

  #endif /* #ifndef MetaTreedb_treedb_allocator_on_storage_t_DEFINED */

  #ifdef __cplusplus
} /* extern "C" { */
  #endif

#endif /* #ifndef v3c_meta_treedb_allocator_h_included */
