/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef meta_treedb_meta_array_defines_h_included
#define meta_treedb_meta_array_defines_h_included

#include <stdio.h>
#include "meta-treedb-array.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ARRAY_TMPL_size_t HTREEDB_HANDLE
#define ARRAY_TMPL_data_t char
#define ARRAY_TMPL_data_ptr_t PSTR
#define ARRAY_TMPL_input_t PCVOID
/******************************************************************************/
/* 16                                                                         */
/******************************************************************************/
#define ARRAY_TMPL_count_t uint16_t

#define ARRAY_TMPL_NS_ treedb_array_o16_

#ifdef DOXYGEN_processing
{
#endif

#define ARRAY_TMPL_omit_template_impl_defines
#include <treedb/array-template.h>

#ifdef DOXYGEN_processing
}
#endif

#undef ARRAY_TMPL_NS_

/******************************************************************************/
/* 32                                                                         */
/******************************************************************************/
/* 16->32 */
#undef ARRAY_TMPL_count_t

#define ARRAY_TMPL_count_t uint32_t

#define ARRAY_TMPL_NS_ treedb_array_o32_

#ifdef DOXYGEN_processing
{
#endif

#define ARRAY_TMPL_omit_template_impl_defines
#include <treedb/array-template.h>

#ifdef DOXYGEN_processing
}
#endif

#undef ARRAY_TMPL_NS_

#if HAVE_64_BITS

/******************************************************************************/
/* 64                                                                         */
/******************************************************************************/
/* 32->64 */
#undef ARRAY_TMPL_count_t

#define ARRAY_TMPL_count_t uint64_t

#define ARRAY_TMPL_NS_ treedb_array_o64_

#ifdef DOXYGEN_processing
{
#endif

#define ARRAY_TMPL_omit_template_impl_defines
#include <treedb/array-template.h>

#ifdef DOXYGEN_processing
}
#endif

#undef ARRAY_TMPL_NS_

#undef ARRAY_TMPL_count_t

#endif /* #if HAVE_64_BITS */
/******************************************************************************/
/* pointer                                                                    */
/******************************************************************************/
/* 64->pointer */
#undef ARRAY_TMPL_count_t

#undef ARRAY_TMPL_packed_array_ptr_t
#undef ARRAY_TMPL_packed_data_ptr_t

#define ARRAY_TMPL_count_t uintptr_t

#define ARRAY_TMPL_omit_unpack_array_DECLARE
#define ARRAY_TMPL_omit_pack_array_DECLARE
#define ARRAY_TMPL_omit_unpack_data_DECLARE
#define ARRAY_TMPL_omit_pack_data_DECLARE

#define ARRAY_TMPL_packed_array_ptr_t ARRAY_TMPL_array_ptr_t
#define ARRAY_TMPL_packed_data_ptr_t ARRAY_TMPL_data_ptr_t

#define ARRAY_TMPL_NS_ treedb_array_p_

#ifdef DOXYGEN_processing
{
#endif

#define ARRAY_TMPL_omit_template_impl_defines
#include <treedb/array-template.h>

#ifdef DOXYGEN_processing
}
#endif

#undef ARRAY_TMPL_NS_

#undef ARRAY_TMPL_count_t
#undef ARRAY_TMPL_packed_array_ptr_t
#undef ARRAY_TMPL_packed_data_ptr_t

#undef ARRAY_TMPL_omit_unpack_array_DECLARE
#undef ARRAY_TMPL_omit_pack_array_DECLARE
#undef ARRAY_TMPL_omit_unpack_data_DECLARE
#undef ARRAY_TMPL_omit_pack_data_DECLARE

#undef ARRAY_TMPL_omit_unpack_array
#undef ARRAY_TMPL_omit_pack_array
#undef ARRAY_TMPL_omit_unpack_data
#undef ARRAY_TMPL_omit_pack_data

#ifdef __cplusplus
} /* extern "C" { */
#endif

#endif /* #ifndef meta_treedb_meta_array_defines_h_included */
