/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#define ARRAY_TMPL_runtime_ptr_t treedb_array_runtime_ptr_t

#define ARRAY_TMPL_prefix static inline
#define ARRAY_TMPL_NS(x) V3C_INVOKE2(V3C_JOIN2,ARRAY_TMPL_NS_,x)
#define ARRAY_TMPL_root_size \
	runtime->m_pImpl->m_pBackend->m_pDescription->m_root.m_uSize
#define ARRAY_TMPL_entry_size \
	runtime->m_pImpl->m_pBackend->m_pDescription->m_entry.m_uSize
#define ARRAY_TMPL_entry_align \
	runtime->m_pImpl->m_pBackend->m_pDescription->m_entry.m_uAlign
#define ARRAY_TMPL_clear_entries(ha, begin, count) \
	  treedb_array_backend_t_FreeEntries(runtime->m_pImpl->m_pBackend \
		, runtime, ha, begin, count)

#define ARRAY_TMPL_data_t char
#define ARRAY_TMPL_input_t PCVOID

#define ARRAY_TMPL_size_t HTREEDB_HANDLE

#define ARRAY_TMPL_assign(to, from) memcpy(to, from, ARRAY_TMPL_entry_size)
#define ARRAY_TMPL_item(pa, n) \
	((char *)ARRAY_TMPL_unpack_data(pa->m_items) + n * ARRAY_TMPL_entry_size)
#define ARRAY_TMPL_item_ptr(pa, n) \
	((char *)ARRAY_TMPL_unpack_data(pa->m_items) + n * ARRAY_TMPL_entry_size)
#define ARRAY_TMPL_auto_data(x) char x[ARRAY_TMPL_entry_size]
#define ARRAY_TMPL_assign_to_auto(to, from)  ARRAY_TMPL_assign(to, from)
#define ARRAY_TMPL_assign_from_auto(to, from)  ARRAY_TMPL_assign(to, from)

#define ARRAY_TMPL_alloc(size) impl_alloc(runtime, size)
#define ARRAY_TMPL_realloc_packed(ha, count) \
	ARRAY_TMPL_NS(impl_realloc_packed)(runtime, ha, count)
#define ARRAY_TMPL_free(p) \
	treedb_allocator_t_FreePtr(runtime->m_pImpl->m_pAllocator, p)

#ifndef ARRAY_TMPL_pack_pointer
  #define ARRAY_TMPL_pack_pointer(x) \
	treedb_array_t_PointerToOffset(runtime, x)
  #define ARRAY_TMPL_unpack_pointer(x) \
	treedb_array_t_OffsetToPointer(runtime, x)
#endif

#define ARRAY_TMPL_memmove(to, from, size) \
	impl_memmove(runtime->m_pImpl->m_pAllocator, to, from, size)

#include <treedb/array-template-defines.h>

static int ARRAY_TMPL_NS(impl_realloc_packed)
( treedb_array_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, size_t count
);

#include <treedb/array-template-impl.h>

static int ARRAY_TMPL_NS(impl_realloc_packed)
( treedb_array_runtime_ptr_t runtime
, ARRAY_TMPL_packed_array_ptr_t ha
, size_t count
) {
	ARRAY_TMPL_array_ptr_t pa = ARRAY_TMPL_unpack_array(ha);
	if(!pa)
		return 1;
	size_t size = count * ARRAY_TMPL_entry_size;
	ARRAY_TMPL_data_ptr_t pd = (ARRAY_TMPL_data_ptr_t)treedb_allocator_t_PointerReallocPtr
		( runtime->m_pImpl->m_pAllocator, ARRAY_TMPL_unpack_data(pa->m_items), size);
	if(!pd)
		return 2;
	pa = ARRAY_TMPL_unpack_array(ha);
	pa->m_items = ARRAY_TMPL_pack_data(pd);
	return 0;
}

static int STDCALL ARRAY_TMPL_NS(Init)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t reserve
, uintptr_t increment
) {
	if(reserve >= (uintptr_t)((ARRAY_TMPL_count_t)-1))
		return 0;
	if(increment >= (uintptr_t)((ARRAY_TMPL_count_t)-1))
		return 0;
	return ! ARRAY_TMPL_NS(init)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha
		, (ARRAY_TMPL_count_t)reserve, (ARRAY_TMPL_count_t)increment);
}
static void STDCALL ARRAY_TMPL_NS(InitEmpty)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t increment
) {
	ARRAY_TMPL_NS(init_empty)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha, increment);
}
static void STDCALL ARRAY_TMPL_NS(InitEmptyPtr)
( treedb_array_runtime_ptr_t runtime
, PVOID pa
, uintptr_t increment
) {
	ARRAY_TMPL_NS(init_empty_ptr)(runtime, (ARRAY_TMPL_array_ptr_t)pa, increment);
}
static void STDCALL ARRAY_TMPL_NS(Reset)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
) {
	ARRAY_TMPL_NS(reset)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha);
}
static PVOID STDCALL ARRAY_TMPL_NS(Entries)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
) {
	(void)runtime;
	ARRAY_TMPL_array_ptr_t pa = ARRAY_TMPL_unpack_array(ha);
	if(!pa)
		return 0;
	return ARRAY_TMPL_unpack_data(pa->m_items);
}
static HTREEDB_ARRAY STDCALL ARRAY_TMPL_NS(Alloc)
( treedb_array_runtime_ptr_t runtime
, uintptr_t reserve
, uintptr_t increment
) {
	return (HTREEDB_ARRAY)
	( ARRAY_TMPL_NS(new)(runtime, reserve, increment) );
}
static void STDCALL ARRAY_TMPL_NS(Free)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
) {
	ARRAY_TMPL_NS(free)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha);
}
static void STDCALL ARRAY_TMPL_NS(Clear)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
) {
	ARRAY_TMPL_NS(clear)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha);
}
static BOOL STDCALL ARRAY_TMPL_NS(Clone)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha_to
, HTREEDB_ARRAY ha_from
) {
	return ARRAY_TMPL_NS(clone)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha_to
		, (ARRAY_TMPL_packed_array_ptr_t)ha_from);
}
static uintptr_t STDCALL ARRAY_TMPL_NS(Count)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
) {
	(void)runtime;
	ARRAY_TMPL_array_ptr_t pa = ARRAY_TMPL_unpack_array(ha);
	if(!pa)
		return 0;
	return pa->m_count;
}
static uintptr_t STDCALL ARRAY_TMPL_NS(Reserve)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
) {
	(void)runtime;
	ARRAY_TMPL_array_ptr_t pa = ARRAY_TMPL_unpack_array(ha);
	if(!pa)
		return 0;
	return pa->m_reserve;
}
static uintptr_t STDCALL ARRAY_TMPL_NS(Increment)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
) {
	(void)runtime;
	ARRAY_TMPL_array_ptr_t pa = ARRAY_TMPL_unpack_array(ha);
	if(!pa)
		return 0;
	return pa->m_increment;
}
static void STDCALL ARRAY_TMPL_NS(SetIncrement)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t u
) {
	(void)runtime;
	ARRAY_TMPL_array_ptr_t pa = ARRAY_TMPL_unpack_array(ha);
	if(!pa)
		return;
	pa->m_increment = (ARRAY_TMPL_count_t)u;
}
static BOOL STDCALL ARRAY_TMPL_NS(Insert)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, HTREEDB_ARRAYDATA pv
, uintptr_t where
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(insert)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha, where, pv);
}
static BOOL STDCALL ARRAY_TMPL_NS(InsertMany)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t where
, uintptr_t count
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(insert_many)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha, where
		, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(Remove)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t where
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(remove)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha, where);
}
static BOOL STDCALL ARRAY_TMPL_NS(RemoveMany)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t where
, uintptr_t count
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(remove_many)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha, where
		, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(PushBack)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, HTREEDB_ARRAYDATA pv
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(push_back)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha, pv);
}
static BOOL STDCALL ARRAY_TMPL_NS(PushBackMany)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t count
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(push_back_many)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha
		, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(PushFront)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, HTREEDB_ARRAYDATA pv
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(push_front)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha, pv);
}
static BOOL STDCALL ARRAY_TMPL_NS(PushFrontMany)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t count
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(push_front_many)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha
		, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(PopBack)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(pop_back)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha);
}
static BOOL STDCALL ARRAY_TMPL_NS(PopBackMany)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t count
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(pop_back_many)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha
		, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(PopFront)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(pop_front)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha);
}
static BOOL STDCALL ARRAY_TMPL_NS(PopFrontMany)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t count
) {
	(void)runtime;
	return ! ARRAY_TMPL_NS(pop_front_many)(runtime, (ARRAY_TMPL_packed_array_ptr_t)ha
		, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(ReverseSome)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
, uintptr_t where
, uintptr_t count
) {
	ARRAY_TMPL_array_ptr_t pa = ARRAY_TMPL_unpack_array(ha);
	if(!pa)
		return 0;
	return ! ARRAY_TMPL_NS(reverse_some)(runtime, pa, where, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(Reverse)
( treedb_array_runtime_ptr_t runtime
, HTREEDB_ARRAY ha
) {
	ARRAY_TMPL_array_ptr_t pa = ARRAY_TMPL_unpack_array(ha);
	if(!pa)
		return 1;
	ARRAY_TMPL_NS(reverse)(runtime, pa);
	return 0;
}

#if 0
#define ve(x) v->x = & ARRAY_TMPL_NS(x)
static void ARRAY_TMPL_NS(test)(treedb_array_impl_vtbl_t * v)
{
	ve(Init);
	ve(InitEmpty);
	ve(InitEmptyPtr);
	ve(Entries);
	ve(AllocArray);
	ve(FreeArray);
	ve(Clear);
	ve(Count);
	ve(Reserve);
	ve(Increment);
	ve(SetIncrement);
	ve(Insert);
	ve(InsertMany);
	ve(Remove);
	ve(RemoveMany);
	ve(PushBack);
	ve(PushBackMany);
	ve(PushFront);
	ve(PushFrontMany);
	ve(PopBack);
	ve(PopBackMany);
	ve(PopFront);
	ve(PopFrontMany);
	ve(ReverseSome);
	ve(Reverse);
}
#endif
treedb_array_impl_vtbl_t ARRAY_TMPL_NS(vtbl) = {
	V3C_INVOKE1(treedb_array_impl_vtbl_t_entries,ARRAY_TMPL_NS_)
};
static TreedbArrayDescription ARRAY_TMPL_NS(desc) = {
	{ sizeof(ARRAY_TMPL_count_t), sizeof(ARRAY_TMPL_count_t) },
	{ sizeof(ARRAY_TMPL_NS(array_t)), sizeof(ARRAY_TMPL_count_t) },
	{ sizeof(char), sizeof(char) } /* The default is a char array. */
	, ARRAY_TMPL_IS_POINTER
};

static treedb_array_backend_t ARRAY_TMPL_NS(backend) =
{ 0
, & ARRAY_TMPL_NS(desc)
};

static treedb_array_impl_t ARRAY_TMPL_NS(impl) =
{ & ARRAY_TMPL_NS(vtbl)
, 0
, & ARRAY_TMPL_NS(backend)
};
static treedb_array_t ARRAY_TMPL_NS(instance) =
{ & ARRAY_TMPL_NS(impl)
, 0
};
