/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_h_included
  #include "meta-treedb.h"
#endif

#ifndef v3c_meta_treedb_array_h_included
  #define v3c_meta_treedb_array_h_included

  #ifdef __cplusplus
extern "C" {
  #endif

/******************************************************************************/
/* Delegates                                                                  */
/******************************************************************************/
  #define TREEDB_IArray_DELEGATE_TO(x) \
inline bool STDCALL \
	Init \
	( uintptr_t reserve = 0 \
	, uintptr_t increment = 1\
	) { return V3C_DELEGATE(x, Init(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, reserve, increment)); } \
inline void STDCALL \
	InitEmpty \
	( uintptr_t increment = 1 \
	) { V3C_DELEGATE(x, InitEmpty(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, increment)); } \
inline PVOID STDCALL \
	Entries \
	() { return V3C_DELEGATE(x, Entries(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline void STDCALL \
	Clear \
	() { V3C_DELEGATE(x, Clear(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline void STDCALL \
	Reset \
	() { V3C_DELEGATE(x, Reset(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline bool STDCALL \
	Clone \
	( HTREEDB_ARRAY ha_from \
	) { return V3C_DELEGATE(x, Clone(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, ha_from)); } \
inline uintptr_t STDCALL \
	Count \
	() { return V3C_DELEGATE(x, Count(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline uintptr_t STDCALL \
	Reserve \
	() { return V3C_DELEGATE(x, Reserve(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline uintptr_t STDCALL \
	Increment \
	() { return V3C_DELEGATE(x, Increment(DGTHIS(x) DGTHIS_MEM(x, m_handle)));}\
inline void STDCALL \
	SetIncrement \
	( uintptr_t u \
	) { V3C_DELEGATE(x, SetIncrement(DGTHIS(x) DGTHIS_MEM(x, m_handle), u)); } \
inline bool STDCALL \
	Insert \
	( HTREEDB_ARRAYDATA pd \
	, uintptr_t where \
	) { return V3C_DELEGATE(x, Insert(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pd, where)); } \
inline bool STDCALL \
	InsertMany \
	( uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, InsertMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where, count)); } \
inline bool STDCALL \
	Remove \
	( uintptr_t where \
	) { return V3C_DELEGATE(x, Remove(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where)); } \
inline bool STDCALL \
	RemoveMany \
	( uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, RemoveMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where, count)); } \
inline bool STDCALL \
	PushBack \
	( HTREEDB_ARRAYDATA pd \
	) { return V3C_DELEGATE(x, PushBack(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pd)); } \
inline bool STDCALL \
	PushBackMany \
	( uintptr_t count \
	) { return V3C_DELEGATE(x, PushBackMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, count)); } \
inline bool STDCALL \
	PushFront \
	( HTREEDB_ARRAYDATA pd \
	) { return V3C_DELEGATE(x, PushFront(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pd)); } \
inline bool STDCALL \
	PushFrontMany \
	( uintptr_t count \
	) { return V3C_DELEGATE(x, PushFrontMany(DGTHIS(x) DGTHIS_MEM(x, m_handle)\
		, count)); } \
inline bool STDCALL \
	PopBack \
	() { return V3C_DELEGATE(x, PopBack(DGTHIS(x) DGTHIS_MEM(x, m_handle))); }\
inline bool STDCALL \
	PopBackMany \
	( uintptr_t count \
	) { return V3C_DELEGATE(x, PopBackMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, count)); } \
inline bool STDCALL \
	PopFront \
	() { return V3C_DELEGATE(x, PopFront(DGTHIS(x) DGTHIS_MEM(x, m_handle)));\
		} \
inline bool STDCALL \
	PopFrontMany \
	( uintptr_t count \
	) { return V3C_DELEGATE(x, PopFrontMany(DGTHIS(x) DGTHIS_MEM(x, m_handle)\
		, count)); } \
inline bool STDCALL \
	ReverseSome \
	( uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, ReverseSome(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where, count)); } \
inline void STDCALL \
	Reverse \
	() { V3C_DELEGATE(x, Reverse(DGTHIS(x) DGTHIS_MEM(x, m_handle))); }

  #define TREEDB_IArrayImpl_DELEGATE_TO(x) \
inline bool STDCALL \
	Init \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t reserve = 0 \
	, uintptr_t increment = 1 \
	) { return V3C_DELEGATE(x, Init(runtime, ha, reserve, increment)); } \
inline void STDCALL \
	InitEmpty \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t increment = 1 \
	) { V3C_DELEGATE(x, InitEmpty(runtime, ha, increment)); } \
inline void STDCALL \
	InitEmptyPtr \
	( treedb_array_runtime_ptr_t runtime \
	, PVOID pa \
	, uintptr_t increment = 1 \
	) { V3C_DELEGATE(x, InitEmptyPtr(runtime, pa, increment)); } \
inline PVOID STDCALL \
	Entries \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	) { return V3C_DELEGATE(x, Entries(runtime, ha)); } \
inline HTREEDB_ARRAY STDCALL \
	Alloc \
	( treedb_array_runtime_ptr_t runtime \
	, uintptr_t reserve \
	, uintptr_t increment \
	) { return V3C_DELEGATE(x, Alloc(runtime, reserve, increment));\
	} \
inline void STDCALL \
	Free \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	) { V3C_DELEGATE(x, Free(runtime, ha)); } \
inline void STDCALL \
	Clear \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	) { V3C_DELEGATE(x, Clear(runtime, ha)); } \
inline void STDCALL \
	Reset \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	) { V3C_DELEGATE(x, Reset(runtime, ha)); } \
inline bool STDCALL \
	Clone \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha_to \
	, HTREEDB_ARRAY ha_from \
	) { return V3C_DELEGATE(x, Clone(runtime, ha_to, ha_from)); } \
inline uintptr_t STDCALL \
	Count \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	) { return V3C_DELEGATE(x, Count(runtime, ha)); } \
inline uint64_t STDCALL \
	Reserve \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	) { return V3C_DELEGATE(x, Reserve(runtime, ha)); } \
inline uint64_t STDCALL \
	Increment \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	) { return V3C_DELEGATE(x, Increment(runtime, ha)); } \
inline void STDCALL \
	SetIncrement \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, SetIncrement(runtime, ha, u)); } \
inline bool STDCALL \
	Insert \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, HTREEDB_ARRAYDATA pd \
	, uintptr_t where \
	) { return V3C_DELEGATE(x, Insert(runtime, ha, pd, where)); } \
inline bool STDCALL \
	InsertMany \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, InsertMany(runtime, ha, where \
		, count)); } \
inline bool STDCALL \
	Remove \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t where \
	) { return V3C_DELEGATE(x, Remove(runtime, ha, where)); } \
inline bool STDCALL \
	RemoveMany \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, RemoveMany(runtime, ha, where, count)); } \
inline bool STDCALL \
	PushBack \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, HTREEDB_ARRAYDATA pd \
	) { return V3C_DELEGATE(x, PushBack(runtime, ha, pd)); } \
inline bool STDCALL \
	PushBackMany \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, PushBackMany(runtime, ha, count)); } \
inline bool STDCALL \
	PushFront \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, HTREEDB_ARRAYDATA pd \
	) { return V3C_DELEGATE(x, PushFront(runtime, ha, pd)); } \
inline bool STDCALL \
	PushFrontMany \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, PushFrontMany(runtime, ha, count)); } \
inline bool STDCALL \
	PopBack \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	) { return V3C_DELEGATE(x, PopBack(runtime, ha)); } \
inline bool STDCALL \
	PopBackMany \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, PopBackMany(runtime, ha, count)); } \
inline bool STDCALL \
	PopFront \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	) { return V3C_DELEGATE(x, PopFront(runtime, ha)); } \
inline bool STDCALL \
	PopFrontMany \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, PopFrontMany(runtime, ha, count)); } \
inline bool STDCALL \
	ReverseSome \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	, uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, ReverseSome(runtime, ha, where, count)); } \
inline bool STDCALL \
	Reverse \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha \
	) { return V3C_DELEGATE(x, Reverse(runtime, ha)); }

  #define TREEDB_IArrayBackend_DELEGATE_TO(x) \
inline bool STDCALL \
	FreeEntries \
	( treedb_array_runtime_ptr_t runtime \
	, HTREEDB_ARRAY ha  \
	, uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, FreeEntries(DGTHIS(x) runtime, ha, where \
		, count)); }

/******************************************************************************/
/* typedefs / forward declarations                                            */
/******************************************************************************/
  #ifndef MetaTreedb_array_typedefs_DEFINED
    #define MetaTreedb_array_typedefs_DEFINED

struct treedb_array_runtime_t;
typedef struct treedb_array_runtime_t treedb_array_runtime_t
, * treedb_array_runtime_ptr_t;

typedef struct treedb_array_t treedb_array_t, * treedb_array_ptr_t;
typedef const treedb_array_t * treedb_const_array_ptr_t;

	#ifdef __cplusplus
typedef treedb_array_t & treedb_array_ref_t;
	#else
	  #define treedb_array_ref_t treedb_array_ptr_t
	#endif

typedef struct treedb_array_backend_t treedb_array_backend_t
, * treedb_array_backend_ptr_t;

typedef struct treedb_array_impl_t treedb_array_impl_t
, * treedb_array_impl_ptr_t;
typedef const treedb_array_impl_t * treedb_const_array_impl_ptr_t;

/* v-table pointers should really be const pointers, but it's not a big deal.

NEVER,NEVER,NEVER think that you can omit this v-table in c++!!!
Why:
1. It causes a compile error when you try to instantiate an abstract class
2. We obtain the implementation (along with the v-table) with a function call
   and c++ doesn't copy over the (hidden) v-table with respect to c++ objects
*/
typedef struct treedb_array_impl_vtbl_t treedb_array_impl_vtbl_t;
typedef treedb_array_impl_vtbl_t * treedb_array_impl_vtbl_ptr_t;
typedef struct treedb_array_backend_vtbl_t treedb_array_backend_vtbl_t
, * treedb_array_backend_vtbl_ptr_t;

  #ifndef MetaTreedb_TreedbArrayDescription_DEFINED
	#define TreedbArrayDescription_members \
	  TreedbItemDescriptionEntry m_pointer, m_root, m_entry; \
	  uint16_t m_flags

  #define META_TREEDB_ARRAY_DESCRIPTION_INIT_BARE \
	{0,0}, {0,0}, {0,0}, 0

  #define META_TREEDB_ARRAY_DESCRIPTION_INIT \
	{ META_TREEDB_ARRAY_DESCRIPTION_INIT_BARE }

typedef struct TreedbArrayDescription_tag {
	TreedbArrayDescription_members;
} TreedbArrayDescription;
typedef const TreedbArrayDescription * TreedbArrayDescriptionConstPtr;
    #define MetaTreedb_TreedbArrayDescription_DEFINED
  #endif

  #endif /* #ifndef MetaTreedb_array_typedefs_DEFINED */

/******************************************************************************/
/* treedb_array_runtime_t                                                     */
/*                                                                            */
/* May supply additional information beyond the implementation pointer.       */
/*                                                                            */
/* By implementing the backend you will quickly find out if a                 */
/* treedb_array_ptr_t will do instead.                                        */
/*                                                                            */
/******************************************************************************/
struct treedb_array_runtime_t {
	treedb_array_impl_ptr_t m_pImpl;
};

/******************************************************************************/
/* treedb_array_impl_t                                                        */
/******************************************************************************/
  #define treedb_array_impl_t_methods(Imp, Prefix, Runtime) \
	STDMETHOD##Imp##_(int, Prefix##Init) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*reserve*/ \
		, size_t /*increment*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##InitEmpty) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*increment*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##InitEmptyPtr) \
		( THIS(Runtime) \
		  PVOID /*pa*/ \
		, size_t /*increment*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Reset) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##Entries) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_ARRAY, Prefix##Alloc) \
		( THIS(Runtime) \
		  size_t /*reserve*/ \
		, size_t /*increment*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Free) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Clear) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Clone) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha_to*/ \
		, HTREEDB_ARRAY /*ha_from*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##Count) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##Reserve) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##Increment) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##SetIncrement) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*u*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Insert) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, HTREEDB_ARRAYDATA /*pv*/ \
		, size_t /*where*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##InsertMany) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*where*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Remove) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*where*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##RemoveMany) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*where*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PushBack) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, HTREEDB_ARRAYDATA /*pv*/\
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PushBackMany) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PushFront) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, HTREEDB_ARRAYDATA /*pv*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PushFrontMany) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopBack) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopBackMany) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopFront) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopFrontMany) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##ReverseSome) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		, size_t /*where*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Reverse) \
		( THIS(Runtime) \
		  HTREEDB_ARRAY /*ha*/ \
		) PURE; \

  #ifdef COBJMACROS

	#define treedb_array_impl_t_Init(Runtime, ha, Reserve, Increment) \
	  TREEDB_IFACE_IMPL_CCALL(Init, Runtime, ha, Reserve, Increment)
	#define treedb_array_impl_t_InitEmpty(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(InitEmpty, Runtime, ha)
	#define treedb_array_impl_t_InitEmptyPtr(Runtime, pa) \
	  TREEDB_IFACE_IMPL_CCALL(InitEmptyPtr, Runtime, pa)
	#define treedb_array_impl_t_Reset(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(Reset, Runtime, ha)
	#define treedb_array_impl_t_Entries(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(Entries, Runtime, ha)
	#define treedb_array_impl_t_Alloc(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(Alloc, Runtime, ha)
	#define treedb_array_impl_t_Free(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(Free, Runtime, ha)
	#define treedb_array_impl_t_Clear(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(Clear, Runtime, ha)
	#define treedb_array_impl_t_Clone(Runtime, ha_to, ha_from) \
	  TREEDB_IFACE_IMPL_CCALL(Clone, Runtime, ha_to, ha_from)
	#define treedb_array_impl_t_Count(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(Count, Runtime, ha)
	#define treedb_array_impl_t_Reserve(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(Reserve, Runtime, ha)
	#define treedb_array_impl_t_Increment(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(Increment, Runtime, ha)
	#define treedb_array_impl_t_SetIncrement(Runtime, ha, u) \
	  TREEDB_IFACE_IMPL_CCALL(SetIncrement, Runtime, ha, u)
	#define treedb_array_impl_t_Insert(Runtime, ha, pv, where) \
	  TREEDB_IFACE_IMPL_CCALL(Insert, Runtime, ha, pv, where)
	#define treedb_array_impl_t_InsertMany(Runtime, ha, where, count) \
	  TREEDB_IFACE_IMPL_CCALL(InsertMany, Runtime, ha, where, count)
	#define treedb_array_impl_t_Remove(Runtime, ha, where) \
	  TREEDB_IFACE_IMPL_CCALL(Remove, Runtime, ha, where)
	#define treedb_array_impl_t_RemoveMany(Runtime, ha, where, count) \
	  TREEDB_IFACE_IMPL_CCALL(RemoveMany, Runtime, ha, where, count)
	#define treedb_array_impl_t_PushBack(Runtime, ha, pv) \
	  TREEDB_IFACE_IMPL_CCALL(PushBack, Runtime, ha, pv)
	#define treedb_array_impl_t_PushBackMany(Runtime, ha, count) \
	  TREEDB_IFACE_IMPL_CCALL(PushBackMany, Runtime, ha, count)
	#define treedb_array_impl_t_PushFront(Runtime, ha, pv) \
	  TREEDB_IFACE_IMPL_CCALL(PushFront, Runtime, ha, pv)
	#define treedb_array_impl_t_PushFrontMany(Runtime, ha, count) \
	  TREEDB_IFACE_IMPL_CCALL(PushFrontMany, Runtime, ha, count)
	#define treedb_array_impl_t_PopBack(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(PopBack, Runtime, ha)
	#define treedb_array_impl_t_PopBackMany(Runtime, ha, count) \
	  TREEDB_IFACE_IMPL_CCALL(PopBackMany, Runtime, ha, count)
	#define treedb_array_impl_t_PopFront(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(PopFront, Runtime, ha)
	#define treedb_array_impl_t_PopFrontMany(Runtime, ha, count) \
	  TREEDB_IFACE_IMPL_CCALL(PopFrontMany, Runtime, ha, count)
	#define treedb_array_impl_t_ReverseSome(Runtime, ha, where, count) \
	  TREEDB_IFACE_IMPL_CCALL(ReverseSome, Runtime, ha, where, count)
	#define treedb_array_impl_t_Reverse(Runtime, ha) \
	  TREEDB_IFACE_IMPL_CCALL(Reverse, Runtime, ha)

/* Allocator convenience macros --------------------------------------------- */
	#define treedb_array_impl_t_PointerToOffset(This, u) \
	  treedb_allocator_t_PointerToOffset((This)->m_pAllocator, u)
	#define treedb_array_impl_t_OffsetToPointer(This, u) \
	  treedb_allocator_t_OffsetToPointer((This)->m_pAllocator, u)
	#define treedb_array_impl_t_PointerPack(This, p) \
	  treedb_allocator_t_PointerPack((This)->m_pAllocator, p)
	#define treedb_array_impl_t_PointerUnpack(This, u) \
	  treedb_allocator_t_PointerUnpack((This)->m_pAllocator, u)

/* Allocator convenience handle macros -------------------------------------- */
	#define treedb_array_impl_t_Read(This, hloc) \
	  treedb_allocator_t_Read((This)->m_pAllocator, hloc)
	#define treedb_array_impl_t_Write(This, hloc, hvalue) \
	  treedb_allocator_t_Write((This)->m_pAllocator, hloc, hvalue)
	#define treedb_array_impl_t_PointerRead(This, hloc) \
	  treedb_allocator_t_PointerRead((This)->m_pAllocator, hloc)
	#define treedb_array_impl_t_PointerWrite(This, hloc, pv) \
	  treedb_allocator_t_PointerWrite((This)->m_pAllocator, hloc, pv)
	#define treedb_array_impl_t_PointerAddTo(This, hloc, u) \
	  treedb_allocator_t_PointerAddTo((This)->m_pAllocator, hloc, u)

/* Allocator convenience pointer macros ------------------------------------- */
	#define treedb_array_impl_t_ReadPtr(This, pv) \
	  treedb_allocator_t_ReadPtr((This)->m_pAllocator, p)
	#define treedb_array_impl_t_WritePtr(This, pv, hvalue) \
	  treedb_allocator_t_WritePtr((This)->m_pAllocator, pv, hvalue)
	#define treedb_array_impl_t_PointerReadPtr(This, pv) \
	  treedb_allocator_t_PointerReadPtr((This)->m_pAllocator, pv)
	#define treedb_array_impl_t_PointerWritePtr(This, pv, pvvalue) \
	  treedb_allocator_t_PointerWritePtr((This)->m_pAllocator, pv, pvvalue)
	#define treedb_array_impl_t_PointerAddToPtr(This, pv, u) \
	  treedb_allocator_t_PointerAddToPtr((This)->m_pAllocator, pv, u)

/* More convenience macros -------------------------------------------------- */
	#define treedb_array_impl_t_offset_size(This) \
	  (This)->m_pDescription.m_pointer.m_uSize
	#define treedb_array_impl_t_offset_alignment(This) \
	  (This)->m_pDescription.m_pointer.m_uAlign

	#define treedb_array_impl_t_root_size(This) \
	  (This)->m_pDescription.m_root.m_uSize
	#define treedb_array_impl_t_root_alignment(This) \
	  (This)->m_pDescription.m_root.m_uAlign

  #endif /* #ifdef COBJMACROS */

  #define treedb_array_impl_vtbl_t_entries_default(Prefix) \
	  & Prefix##Init \
	, & Prefix##InitEmpty \
	, & Prefix##InitEmptyPtr \
	, & Prefix##Reset \
	, & Prefix##Entries \
	, & Prefix##Alloc \
	, & Prefix##Free \
	, & Prefix##Clear \
	, & Prefix##Clone \
	, & Prefix##Count \
	, & Prefix##Reserve \
	, & Prefix##Increment \
	, & Prefix##SetIncrement \
	, & Prefix##Insert \
	, & Prefix##InsertMany \
	, & Prefix##Remove \
	, & Prefix##RemoveMany \
	, & Prefix##PushBack \
	, & Prefix##PushBackMany \
	, & Prefix##PushFront \
	, & Prefix##PushFrontMany \
	, & Prefix##PopBack \
	, & Prefix##PopBackMany \
	, & Prefix##PopFront \
	, & Prefix##PopFrontMany \
	, & Prefix##ReverseSome \
	, & Prefix##Reverse

  #ifndef treedb_array_impl_vtbl_t_entries
	#define treedb_array_impl_vtbl_t_entries(x) \
	  treedb_array_impl_vtbl_t_entries_default(x)
  #endif

  #define treedb_array_impl_t_members(vtbl_ptr_t) \
	vtbl_ptr_t m_pVtbl; \
	treedb_allocator_ptr_t m_pAllocator; \
	treedb_array_backend_ptr_t m_pBackend

  #ifndef MetaTreedb_treedb_array_impl_t_DEFINED
	#define MetaTreedb_treedb_array_impl_t_DEFINED

    #ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
struct treedb_array_impl_vtbl_t
{
	treedb_array_impl_t_methods(,,treedb_array_runtime_t);
};
	#ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_array_impl_t
{
	treedb_array_impl_t_members(treedb_array_impl_vtbl_ptr_t);
};

  #endif /* #ifndef MetaTreedb_treedb_array_impl_t_DEFINED */

extern void treedb_array_impl_t_Setup
( treedb_array_impl_ptr_t pm
, treedb_allocator_on_storage_ptr_t pa
, treedb_array_backend_ptr_t pb
, TreedbArrayDescription * pd
, treedb_const_array_impl_ptr_t ptemplate
);
/******************************************************************************/
/* treedb_array_t                                                            */
/******************************************************************************/
struct treedb_array_t {
	treedb_array_impl_ptr_t m_pImpl;
	HTREEDB_ARRAY m_handle;
};

static inline
treedb_array_runtime_ptr_t
treedb_array_t_to_runtime(treedb_array_ptr_t p)
{
	return (treedb_array_runtime_ptr_t)p;
}

extern
void treedb_array_t_Setup
( treedb_array_ptr_t p
, treedb_array_impl_ptr_t pImpl
, size_t uPayload
);

  #ifdef COBJMACROS

	#define treedb_array_t_Init(This, Reserve, Increment) \
	  treedb_array_impl_t_Init(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, Reserve, Increment)
    #define treedb_array_t_Clear(This) \
	  treedb_array_impl_t_Clear(treedb_array_t_to_runtime(This) \
		, (This)->m_handle)
    #define treedb_array_t_Clone(This, ha_from) \
	  treedb_array_impl_t_Clone(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, ha_from)
	#define treedb_array_t_Count(This) \
	  treedb_array_impl_t_Count(treedb_array_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_array_t_Reserve(This) \
	  treedb_array_impl_t_Reserve(treedb_array_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_array_t_Increment(This) \
	  treedb_array_impl_t_Increment(treedb_array_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_array_t_SetIncrement(This, u) \
	  treedb_array_impl_t_SetIncrement(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, u)
	#define treedb_array_t_Insert(This, pv, where) \
	  treedb_array_impl_t_Insert(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, pv, where)
	#define treedb_array_t_InsertMany(This, where, count) \
	  treedb_array_impl_t_InsertMany(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, where, count)
	#define treedb_array_t_Remove(This, ha, where) \
	  treedb_array_impl_t_Remove(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, where)
	#define treedb_array_t_RemoveMany(This, ha, where, count) \
	  treedb_array_impl_t_RemoveMany(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, where, count)
	#define treedb_array_t_PushBack(This, pv) \
	  treedb_array_impl_t_PushBack(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, pv)
	#define treedb_array_t_PushBackMany(This, count) \
	  treedb_array_impl_t_PushBackMany(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, count)
	#define treedb_array_t_PushFront(This, pv) \
	  treedb_array_impl_t_PushFront(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, pv)
	#define treedb_array_t_PushFrontMany(This, count) \
	  treedb_array_impl_t_PushFrontMany(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, count)
	#define treedb_array_t_PopBack(This) \
	  treedb_array_impl_t_PopBack(treedb_array_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_array_t_PopBackMany(This, count) \
	  treedb_array_impl_t_PopBackMany(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, count)
	#define treedb_array_t_PopFront(This) \
	  treedb_array_impl_t_PopFront(treedb_array_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_array_t_PopFrontMany(This, count) \
	  treedb_array_impl_t_PopFrontMany(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, count)
	#define treedb_array_t_ReverseSome(This, count) \
	  treedb_array_impl_t_ReverseSome(treedb_array_t_to_runtime(This) \
		, (This)->m_handle, count)
	#define treedb_array_t_Reverse(This) \
	  treedb_array_impl_t_Reverse(treedb_array_t_to_runtime(This) \
		, (This)->m_handle)

/* Allocator convenience macros --------------------------------------------- */
	#define treedb_array_t_PointerToOffset(This, u) \
	  treedb_array_impl_t_PointerToOffset((This)->m_pImpl, u)
	#define treedb_array_t_OffsetToPointer(This, u) \
	  treedb_array_impl_t_OffsetToPointer((This)->m_pImpl, u)
	#define treedb_array_t_PointerPack(This, p) \
	  treedb_array_impl_t_PointerPack((This)->m_pImpl, p)
	#define treedb_array_t_PointerUnpack(This, u) \
	  treedb_array_impl_t_PointerUnpack((This)->m_pImpl, u)

/* Allocator convenience handle macros -------------------------------------- */
	#define treedb_array_t_Read(This, hloc) \
	  treedb_array_impl_t_Read((This)->m_pImpl, hloc)
	#define treedb_array_t_Write(This, hloc, hvalue) \
	  treedb_array_impl_t_Write((This)->m_pImpl, hloc, hvalue)
	#define treedb_array_t_PointerRead(This, hloc) \
	  treedb_array_impl_t_PointerRead((This)->m_pImpl, hloc)
	#define treedb_array_t_PointerWrite(This, hloc, pv) \
	  treedb_array_impl_t_PointerWrite((This)->m_pImpl, hloc, pv)
	#define treedb_array_t_PointerAddTo(This, hloc, u) \
	  treedb_array_impl_t_PointerAddTo((This)->m_pImpl, hloc, u)

/* Allocator convenience pointer macros ------------------------------------- */
	#define treedb_array_t_ReadPtr(This, pv) \
	  treedb_array_impl_t_ReadPtr((This)->m_pImpl, p)
	#define treedb_array_t_WritePtr(This, pv, hvalue) \
	  treedb_array_impl_t_WritePtr((This)->m_pImpl, pv, hvalue)
	#define treedb_array_t_PointerReadPtr(This, pv) \
	  treedb_array_impl_t_PointerReadPtr((This)->m_pImpl, pv)
	#define treedb_array_t_PointerWritePtr(This, pv, pvvalue) \
	  treedb_array_impl_t_PointerWritePtr((This)->m_pImpl, pv \
		, pvvalue)
	#define treedb_array_t_PointerAddToPtr(This, pv, u) \
	  treedb_array_impl_t_PointerAddToPtr((This)->m_pImpl, pv, u)

/* Backend convenience macros ----------------------------------------------- */
	#define treedb_array_t_backend_FreeEntries(This, begin, count) \
	  treedb_array_backend_t_FreeEntries((This)->m_pImpl->m_pBackend \
		, treedb_array_t_to_runtime(This), (This)->m_handle, begin, count)

/* More convenience macros -------------------------------------------------- */
	#define treedb_array_t_offset_size(This) \
	  treedb_array_impl_t_offset_size((This)->m_pImpl)
	#define treedb_array_t_offset_alignment(This) \
	  treedb_array_impl_t_offset_alignment((This)->m_pImpl)

	#define treedb_array_t_root_size(This) \
	  treedb_array_impl_t_root_size((This)->m_pImpl)
	#define treedb_array_t_root_alignment(This) \
	  treedb_array_impl_t_root_alignment((This)->m_pImpl)

  #endif /* #ifdef COBJMACROS */

/******************************************************************************/
/* treedb_array_backend_t                                                     */
/******************************************************************************/
  #define treedb_array_backend_t_methods(Imp, Prefix, Class, Runtime) \
	STDMETHOD##Imp##_(BOOL, Prefix##FreeEntries) \
		( THIS(Class) \
		  Runtime * /*runtime*/ \
		, HTREEDB_ARRAY /*ha*/ \
		, size_t /*where*/ \
		, size_t /*count*/ \
		) PURE

  #ifdef COBJMACROS

	#define treedb_array_backend_t_FreeEntries(This, Runtime, ha, where \
		, count) \
	  V3C_IFACE_CALL(FreeEntries, This, Runtime, ha, where, count)

  #endif /* #ifdef COBJMACROS */

  #define treedb_array_backend_vtbl_t_entries_default(Prefix) \
	& Prefix##FreeEntries

  #ifndef treedb_array_backend_vtbl_t_entries
	#define treedb_array_backend_vtbl_t_entries(x) \
	  treedb_array_backend_vtbl_t_entries_default(x)
  #endif

  #define treedb_array_backend_t_members(vtbl_ptr_t) \
	vtbl_ptr_t m_pVtbl; \
	TreedbArrayDescriptionConstPtr m_pDescription

  #ifndef MetaTreedb_treedb_array_backend_t_DEFINED
	#define MetaTreedb_treedb_array_backend_t_DEFINED

	#ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
struct treedb_array_backend_vtbl_t
{
	treedb_array_backend_t_methods(,,treedb_array_backend_t
		, treedb_array_runtime_t);
};
	#ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_array_backend_t
{
	treedb_array_backend_t_members(treedb_array_backend_vtbl_ptr_t);
};

  #endif /* #ifndef MetaTreedb_treedb_array_backend_t_DEFINED */

extern void treedb_array_backend_t_Setup
( treedb_array_backend_ptr_t pb
, PVOID pVtbl
, TreedbArrayDescriptionConstPtr pDescription
);

extern treedb_const_array_ptr_t
treedb_get_array_template_for
( uint16_t uBytes /* 2, 4, 8 */
, uint16_t flags /* flags & eTreedbContainerIsPointer means ignore uBytes */
);

extern treedb_const_array_ptr_t
treedb_get_array_template_using_allocator
( treedb_allocator_ptr_t pallocator
);

  #ifdef __cplusplus
} // extern "C" {
  #endif

#endif /* #ifndef v3c_meta_treedb_array_h_included */
