/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_handle_array_defines_h_included
#define v3c_meta_treedb_handle_array_defines_h_included

#include <stdio.h>
#include "meta-treedb-handle-array.h"

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/
/* 16                                                                         */
/******************************************************************************/
#define ARRAY_TMPL_count_t uint16_t

#define ARRAY_TMPL_NS_ treedb_handle_array_o16_

#ifdef DOXYGEN_processing
{
#endif

#define ARRAY_TMPL_omit_template_impl_defines
#include <treedb/handle-array-template.h>

#ifdef DOXYGEN_processing
}
#endif

#undef ARRAY_TMPL_NS_

/******************************************************************************/
/* 32                                                                         */
/******************************************************************************/
/* 16->32 */
#undef ARRAY_TMPL_count_t

#define ARRAY_TMPL_count_t uint32_t

#define ARRAY_TMPL_NS_ treedb_handle_array_o32_

#ifdef DOXYGEN_processing
{
#endif

#define ARRAY_TMPL_omit_template_impl_defines
#include <treedb/handle-array-template.h>

#ifdef DOXYGEN_processing
}
#endif

#undef ARRAY_TMPL_NS_

#if HAVE_64_BITS
/******************************************************************************/
/* 64                                                                         */
/******************************************************************************/
/* 32->64 */
#undef ARRAY_TMPL_count_t

#define ARRAY_TMPL_count_t uint64_t

#define ARRAY_TMPL_NS_ treedb_handle_array_o64_

#ifdef DOXYGEN_processing
{
#endif

#define ARRAY_TMPL_omit_template_impl_defines
#include <treedb/handle-array-template.h>

#ifdef DOXYGEN_processing
}
#endif

#undef ARRAY_TMPL_NS_

#endif /* #if HAVE_64_BITS */

/******************************************************************************/
/* pointer                                                                    */
/******************************************************************************/
/* 64->pointer */
#undef ARRAY_TMPL_count_t

#undef ARRAY_TMPL_packed_ptr_t
#undef ARRAY_TMPL_packed2_ptr_t

#define ARRAY_TMPL_count_t uintptr_t

#define ARRAY_TMPL_omit_unpack_DECLARE
#define ARRAY_TMPL_omit_pack_DECLARE
#define ARRAY_TMPL_omit_unpack2_DECLARE

#define ARRAY_TMPL_pack
#define ARRAY_TMPL_unpack
#define ARRAY_TMPL_unpack2
#define ARRAY_TMPL_packed_ptr_t ARRAY_TMPL_ptr_t
#define ARRAY_TMPL_packed2_ptr_t ARRAY_TMPL_ptr_ptr_t

#define ARRAY_TMPL_NS_ treedb_handle_array_p_

#ifdef DOXYGEN_processing
{
#endif

#define ARRAY_TMPL_omit_template_impl_defines
#include <treedb/handle-array-template.h>

#ifdef DOXYGEN_processing
}
#endif

#undef ARRAY_TMPL_NS_

#undef ARRAY_TMPL_count_t
#undef ARRAY_TMPL_packed_ptr_t
#undef ARRAY_TMPL_packed2_ptr_t

#undef ARRAY_TMPL_omit_unpack_DECLARE
#undef ARRAY_TMPL_omit_pack_DECLARE
#undef ARRAY_TMPL_omit_unpack2_DECLARE

#undef ARRAY_TMPL_omit_unpack
#undef ARRAY_TMPL_omit_pack
#undef ARRAY_TMPL_omit_unpack2

#ifdef __cplusplus
} /* extern "C" { */
#endif

#undef ARRAY_TMPL_omit_template_impl_defines

#endif /* #ifndef v3c_meta_treedb_handle_array_defines_h_included */
