/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#define ARRAY_TMPL_runtime_ptr_t treedb_handle_array_runtime_ptr_t

#define ARRAY_TMPL_NS(x) V3C_INVOKE2(V3C_JOIN2,ARRAY_TMPL_NS_,x)
#define ARRAY_TMPL_root_size \
	runtime->m_pImpl->m_pBackend->m_pDescription->m_root.m_uSize
#define ARRAY_TMPL_entry_size \
	runtime->m_pImpl->m_pBackend->m_pDescription->m_entry.m_uSize
#define ARRAY_TMPL_entry_align \
	runtime->m_pImpl->m_pBackend->m_pDescription->m_entry.m_uAlign
#define ARRAY_TMPL_clear_entries(ha, begin, size) \
	treedb_handle_array_backend_t_FreeEntries(runtime->m_pImpl->m_pBackend \
		, runtime, ha, begin, size)
#define ARRAY_TMPL_free(x) \
	treedb_allocator_t_FreePtr(runtime->m_pImpl->m_pAllocator, x)

#define ARRAY_TMPL_data_t char
#define ARRAY_TMPL_input_t PCVOID

#define ARRAY_TMPL_assign(to, from) memcpy(to, from, ARRAY_TMPL_entry_size)
#define ARRAY_TMPL_item(pa, n) \
	((char *)pa + runtime->m_pImpl->m_pBackend->m_pDescription->m_entry_offset \
		+ (n) * ARRAY_TMPL_entry_size)
#define ARRAY_TMPL_item_ptr(pa, n) \
	((char *)pa + runtime->m_pImpl->m_pBackend->m_pDescription->m_entry_offset \
		+ (n) * ARRAY_TMPL_entry_size)
#define ARRAY_TMPL_auto_data(x) char x[ARRAY_TMPL_entry_size]
#define ARRAY_TMPL_assign_to_auto(to, from) ARRAY_TMPL_assign(to, from)
#define ARRAY_TMPL_assign_from_auto(to, from) ARRAY_TMPL_assign(to, from)

#define ARRAY_TMPL_pack_t HTREEDB_HANDLE
#define ARRAY_TMPL_alloc(count) impl_alloc(runtime, count)
#define ARRAY_TMPL_realloc_packed(hha, count) \
	ARRAY_TMPL_NS(impl_realloc_packed)(runtime, hha, count)

#ifndef ARRAY_TMPL_pack_pointer
  #define ARRAY_TMPL_pack_pointer(x) \
	treedb_handle_array_t_PointerToOffset(runtime, x)
  #define ARRAY_TMPL_unpack_pointer(x) \
	treedb_handle_array_t_OffsetToPointer(runtime, x)
#endif

#ifdef DOXYGEN_processing
{
#endif

#include <treedb/handle-array-template-defines.h>

#ifdef DOXYGEN_processing
}
#endif

static int ARRAY_TMPL_NS(impl_realloc_packed)
( treedb_handle_array_runtime_ptr_t runtime
, ARRAY_TMPL_packed2_ptr_t hha
, size_t count
);

#ifdef DOXYGEN_processing
{
#endif

#include <treedb/handle-array-template-impl.h>

#ifdef DOXYGEN_processing
}
#endif

static int ARRAY_TMPL_NS(impl_realloc_packed)
( treedb_handle_array_runtime_ptr_t runtime
, ARRAY_TMPL_packed2_ptr_t hha
, size_t count
) {
	uintptr_t size
		= runtime->m_pImpl->m_pBackend->m_pDescription->m_entry_offset
			+ count * ARRAY_TMPL_entry_size;

	ARRAY_TMPL_ptr_t pa =
		treedb_allocator_t_PointerAlignedReallocPtr
		( runtime->m_pImpl->m_pAllocator, ARRAY_TMPL_unpack2(hha)
		, size
		, runtime->m_pImpl->m_pBackend->m_pDescription->m_max_align
		, runtime->m_pImpl->m_pBackend->m_pDescription->m_entry_offset);
	if(!pa)
		return 1;
	*(ARRAY_TMPL_packed_ptr_t *)ARRAY_TMPL_unpack_pointer(hha) = ARRAY_TMPL_pack(pa);
	return 0;
}

/* We call ARRAY_TMPL_unpack(), not treedb_handle_array_impl_t_PointerUnpack(),
as we may be in a pointer allocator.
*/
static PVOID STDCALL ARRAY_TMPL_NS(Entries)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
) {
	ARRAY_TMPL_ptr_t pa = ARRAY_TMPL_unpack2(hha);
	if(!pa)
		return 0;
	return (char *)pa
		+ runtime->m_pImpl->m_pBackend->m_pDescription->m_entry_offset;
}
static BOOL STDCALL ARRAY_TMPL_NS(Alloc)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, uintptr_t reserve
, uintptr_t increment
) {
	return ! ARRAY_TMPL_NS(new)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha, reserve
		, increment);
}
static BOOL STDCALL ARRAY_TMPL_NS(Free)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
) {
	ARRAY_TMPL_packed_ptr_t * pha = (ARRAY_TMPL_packed_ptr_t *)ARRAY_TMPL_unpack_pointer(hha);
	if(!pha)
		return 0;
	ARRAY_TMPL_NS(free)(runtime, *pha);
	return 1;
}
static void STDCALL ARRAY_TMPL_NS(Clear)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
) {
	ARRAY_TMPL_NS(clear)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha);
}
static BOOL STDCALL ARRAY_TMPL_NS(Clone)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha_to
, HHTREEDB_ARRAY hha_from
) {
	return ! ARRAY_TMPL_NS(clone)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha_to
		, (ARRAY_TMPL_packed2_ptr_t)hha_from);
}
static uintptr_t STDCALL ARRAY_TMPL_NS(Count)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
) {
	(void)runtime;
	ARRAY_TMPL_ptr_t pa = ARRAY_TMPL_unpack2(hha);
	if(!pa)
		return 0;
	return pa->m_count;
}
static uintptr_t STDCALL ARRAY_TMPL_NS(Reserve)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
) {
	(void)runtime;
	ARRAY_TMPL_ptr_t pa = ARRAY_TMPL_unpack2(hha);
	if(!pa)
		return 0;
	return pa->m_reserve;
}
static uintptr_t STDCALL ARRAY_TMPL_NS(Increment)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
) {
	(void)runtime;
	ARRAY_TMPL_ptr_t pa = ARRAY_TMPL_unpack2(hha);
	if(!pa)
		return 0;
	return pa->m_increment;
}
static void STDCALL ARRAY_TMPL_NS(SetIncrement)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, uintptr_t u
) {
	(void)runtime;
	ARRAY_TMPL_ptr_t pa = ARRAY_TMPL_unpack2(hha);
	if(!pa)
		return;
	pa->m_increment = (ARRAY_TMPL_count_t)u;
}
static BOOL STDCALL ARRAY_TMPL_NS(Insert)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, HTREEDB_ARRAYDATA pv
, uintptr_t where
) {
	return ! ARRAY_TMPL_NS(insert)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha, where, pv);
}
static BOOL STDCALL ARRAY_TMPL_NS(InsertMany)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, uintptr_t where
, uintptr_t count
) {
	return ! ARRAY_TMPL_NS(insert_many)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha, where
		, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(Remove)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, uintptr_t where
) {
	return ! ARRAY_TMPL_NS(remove)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha, where);
}
static BOOL STDCALL ARRAY_TMPL_NS(RemoveMany)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, uintptr_t where
, uintptr_t count
) {
	return ! ARRAY_TMPL_NS(remove_many)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha, where
		, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(PushBack)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, HTREEDB_ARRAYDATA pv
) {
	return ! ARRAY_TMPL_NS(push_back)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha, pv);
}
static BOOL STDCALL ARRAY_TMPL_NS(PushBackMany)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, uintptr_t count
) {
	return ! ARRAY_TMPL_NS(push_back_many)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(PushFront)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, HTREEDB_ARRAYDATA pv
) {
	return ! ARRAY_TMPL_NS(push_front)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha, pv);
}
static BOOL STDCALL ARRAY_TMPL_NS(PushFrontMany)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, uintptr_t count
) {
	return ! ARRAY_TMPL_NS(push_front_many)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha
		, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(PopBack)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
) {
	return ! ARRAY_TMPL_NS(pop_back)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha);
}
static BOOL STDCALL ARRAY_TMPL_NS(PopBackMany)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, uintptr_t count
) {
	return ! ARRAY_TMPL_NS(pop_back_many)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(PopFront)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
) {
	return ! ARRAY_TMPL_NS(pop_front)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha);
}
static BOOL STDCALL ARRAY_TMPL_NS(PopFrontMany)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, uintptr_t count
) {
	return ! ARRAY_TMPL_NS(pop_front_many)(runtime, (ARRAY_TMPL_packed2_ptr_t)hha, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(ReverseSome)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
, uintptr_t where
, uintptr_t count
) {
	ARRAY_TMPL_ptr_t pa = ARRAY_TMPL_unpack2(hha);
	if(!pa)
		return 0;
	return ! ARRAY_TMPL_NS(reverse_some)(runtime, pa, where, count);
}
static BOOL STDCALL ARRAY_TMPL_NS(Reverse)
( treedb_handle_array_runtime_ptr_t runtime
, HHTREEDB_ARRAY hha
) {
	ARRAY_TMPL_ptr_t pa = ARRAY_TMPL_unpack2(hha);
	if(!pa)
		return 0;
	ARRAY_TMPL_NS(reverse)(runtime, pa);
	return 1;
}

#if 0
#define ve(x) v->x = & ARRAY_TMPL_NS(x)
static void ARRAY_TMPL_NS(test)(treedb_handle_array_impl_vtbl_t * v)
{
	ve(Entries);
	ve(Alloc);
	ve(Free);
	ve(Clear);
	ve(Count);
	ve(Clone);
	ve(Reserve);
	ve(Increment);
	ve(SetIncrement);
	ve(Insert);
	ve(InsertMany);
	ve(Remove);
	ve(RemoveMany);
	ve(PushBack);
	ve(PushBackMany);
	ve(PushFront);
	ve(PushFrontMany);
	ve(PopBack);
	ve(PopBackMany);
	ve(PopFront);
	ve(PopFrontMany);
	ve(ReverseSome);
	ve(Reverse);
}
#endif
treedb_handle_array_impl_vtbl_t ARRAY_TMPL_NS(vtbl) = {
	V3C_INVOKE1(treedb_handle_array_impl_vtbl_t_entries,ARRAY_TMPL_NS_)
};
static TreedbHandleArrayDescription ARRAY_TMPL_NS(desc) = {
	{ sizeof(ARRAY_TMPL_count_t), sizeof(ARRAY_TMPL_count_t) },
	{ sizeof(ARRAY_TMPL_NS(array_t)), sizeof(ARRAY_TMPL_count_t) },
	{ sizeof(char), sizeof(char) } /* The default is a char array. */
	, sizeof(ARRAY_TMPL_count_t), sizeof(ARRAY_TMPL_count_t), ARRAY_TMPL_IS_POINTER
};

static treedb_handle_array_backend_t ARRAY_TMPL_NS(backend) =
{ 0
, & ARRAY_TMPL_NS(desc)
};

static treedb_handle_array_impl_t ARRAY_TMPL_NS(impl) =
{ & ARRAY_TMPL_NS(vtbl)
, 0
, & ARRAY_TMPL_NS(backend)
};
static treedb_handle_array_t ARRAY_TMPL_NS(instance) =
{ & ARRAY_TMPL_NS(impl)
, 0
};
