/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_h_included
  #include "meta-treedb.h"
#endif

#ifndef v3c_meta_treedb_handle_array_h_included
  #define v3c_meta_treedb_handle_array_h_included

  #ifdef __cplusplus
extern "C" {
  #endif

/******************************************************************************/
/* Delegates                                                                  */
/******************************************************************************/
  #define TREEDB_IHandleArray_DELEGATE_TO(x) \
inline PVOID STDCALL \
	Entries \
	() { return V3C_DELEGATE(x, Entries(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline void STDCALL \
	Clear \
	() { V3C_DELEGATE(x, Clear(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline bool STDCALL \
	Clone \
	( HHTREEDB_ARRAY hha_from \
	) { return V3C_DELEGATE(x, Clone(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hha_from)); } \
inline uintptr_t STDCALL \
	Count \
	() { return V3C_DELEGATE(x, Count(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline uintptr_t STDCALL \
	Reserve \
	() { return V3C_DELEGATE(x, Reserve(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline uintptr_t STDCALL \
	Increment \
	() { return V3C_DELEGATE(x, Increment(DGTHIS(x) DGTHIS_MEM(x, m_handle)));}\
inline void STDCALL \
	SetIncrement \
	( uintptr_t u \
	) { return V3C_DELEGATE(x, SetIncrement(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, u)); } \
inline bool STDCALL \
	Insert \
	( HTREEDB_ARRAYDATA pd \
	, uintptr_t where \
	) { return V3C_DELEGATE(x, Insert(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pd, where)); } \
inline bool STDCALL \
	InsertMany \
	( uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, InsertMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where, count)); } \
inline bool STDCALL \
	Remove \
	( uintptr_t where \
	) { return V3C_DELEGATE(x, Remove(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where));\
	} \
inline bool STDCALL \
	RemoveMany \
	( uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, RemoveMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where, count)); } \
inline bool STDCALL \
	PushBack \
	( HTREEDB_ARRAYDATA pd \
	) { return V3C_DELEGATE(x, PushBack(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pd)); } \
inline bool STDCALL \
	PushBackMany \
	( uintptr_t count \
	) { return V3C_DELEGATE(x, PushBackMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, count)); } \
inline bool STDCALL \
	PushFront \
	( HTREEDB_ARRAYDATA pd \
	) { return V3C_DELEGATE(x, PushFront(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pd));\
	} \
inline bool STDCALL \
	PushFrontMany \
	( uintptr_t count \
	) { return V3C_DELEGATE(x, PushFrontMany(DGTHIS(x) DGTHIS_MEM(x, m_handle)\
		, count)); } \
inline bool STDCALL \
	PopBack \
	() { return V3C_DELEGATE(x, PopBack(DGTHIS(x) DGTHIS_MEM(x, m_handle))); }\
inline bool STDCALL \
	PopBackMany \
	( uintptr_t count \
	) { return V3C_DELEGATE(x, PopBackMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, count)); } \
inline bool STDCALL \
	PopFront \
	() { return V3C_DELEGATE(x, PopFront(DGTHIS(x) DGTHIS_MEM(x, m_handle)));\
	} \
inline bool STDCALL \
	PopFrontMany \
	( uintptr_t count \
	) { return V3C_DELEGATE(x, PopFrontMany(DGTHIS(x) DGTHIS_MEM(x, m_handle)\
		, count)); } \
inline bool STDCALL \
	ReverseSome \
	( uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, ReverseSome(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where, count)); } \
inline bool STDCALL \
	Reverse \
	() { return V3C_DELEGATE(x, Reverse(DGTHIS(x) DGTHIS_MEM(x, m_handle))); }

  #define TREEDB_IHandleArrayImpl_DELEGATE_TO(x) \
inline PVOID STDCALL \
	Entries \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	) { return V3C_DELEGATE(x, Entries(runtime, hha)); } \
inline BOOL STDCALL \
	Alloc \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, uintptr_t reserve \
	, uintptr_t increment \
	) { return V3C_DELEGATE(x, Alloc(runtime, hha, reserve \
			, increment)); \
	} \
inline void STDCALL \
	Free \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	) { V3C_DELEGATE(x, Free(runtime, hha)); } \
inline void STDCALL \
	Clear \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	) { V3C_DELEGATE(x, Clear(runtime, hha)); } \
inline bool STDCALL \
	Clone \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha_to \
	, HHTREEDB_ARRAY hha_from \
	) { return V3C_DELEGATE(x, Clone(runtime, hha_to, hha_from)); } \
inline uintptr_t STDCALL \
	Count \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	) { return V3C_DELEGATE(x, Count(runtime, hha)); } \
inline uintptr_t STDCALL \
	Reserve \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	) { return V3C_DELEGATE(x, Reserve(runtime, hha)); } \
inline uintptr_t STDCALL \
	Increment \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	) { return V3C_DELEGATE(x, Increment(runtime, hha)); } \
inline void STDCALL \
	SetIncrement \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, uintptr_t u \
	) { V3C_DELEGATE(x, SetIncrement(runtime, hha, u)); } \
inline bool STDCALL \
	Insert \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, HTREEDB_ARRAYDATA pd \
	, uintptr_t where \
	) { return V3C_DELEGATE(x, Insert(runtime, hha, pd, where)); } \
inline bool STDCALL \
	InsertMany \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, InsertMany(runtime, hha, where \
		, count)); } \
inline bool STDCALL \
	Remove \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, uintptr_t where \
	) { return V3C_DELEGATE(x, Remove(runtime, hha, where)); } \
inline bool STDCALL \
	RemoveMany \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, RemoveMany(runtime, hha, where, count)); } \
inline bool STDCALL \
	PushBack \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, HTREEDB_ARRAYDATA pd \
	) { return V3C_DELEGATE(x, PushBack(runtime, hha, pd)); } \
inline bool STDCALL \
	PushBackMany \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, PushBackMany(runtime, hha, count)); } \
inline bool STDCALL \
	PushFront \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, HTREEDB_ARRAYDATA pd \
	) { return V3C_DELEGATE(x, PushFront(runtime, hha, pd)); } \
inline bool STDCALL \
	PushFrontMany \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, PushFrontMany(runtime, hha, count)); } \
inline bool STDCALL \
	PopBack \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	) { return V3C_DELEGATE(x, PopBack(runtime, hha)); } \
inline bool STDCALL \
	PopBackMany \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, PopBackMany(runtime, hha, count)); } \
inline bool STDCALL \
	PopFront \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	) { return V3C_DELEGATE(x, PopFront(runtime, hha)); } \
inline bool STDCALL \
	PopFrontMany \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, PopFrontMany(runtime, hha, count)); } \
inline bool STDCALL \
	ReverseSome \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	, uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, ReverseSome(runtime, hha, where, count)); } \
inline bool STDCALL \
	Reverse \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha \
	) { return V3C_DELEGATE(x, Reverse(runtime, hha)); }

  #define TREEDB_IHandleArrayBackend_DELEGATE_TO(x) \
inline bool STDCALL \
	FreeEntries \
	( treedb_handle_array_runtime_ptr_t runtime \
	, HHTREEDB_ARRAY hha  \
	, uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, FreeEntries(DGTHIS(x) runtime, hha, where \
		, count)); }

/******************************************************************************/
/* typedefs / forward declarations                                            */
/******************************************************************************/
  #ifndef MetaTreedb_TreedbHandleArrayDescription_DEFINED
	#define TreedbHandleArrayDescription_members \
	  TreedbItemDescriptionEntry m_pointer, m_root, m_entry; \
	  uint16_t m_max_align, m_entry_offset, m_flags

  #define META_TREEDB_HANDLE_ARRAY_DESCRIPTION_INIT_BARE \
	{0,0}, {0,0}, {0,0}, 0, 0, 0

  #define META_TREEDB_HANDLE_ARRAY_DESCRIPTION_INIT \
	{ META_TREEDB_HANDLE_ARRAY_DESCRIPTION_INIT_BARE }

typedef struct TreedbHandleArrayDescription_tag {
	TreedbHandleArrayDescription_members;
} TreedbHandleArrayDescription;
    #define MetaTreedb_TreedbHandleArrayDescription_DEFINED
  #endif

  #ifndef MetaTreedb_handle_array_typedefs_DEFINED
    #define MetaTreedb_handle_array_typedefs_DEFINED

/* Because handle arrays use realloc() to resize, they can move around.
Plus, the heap as a whole can move in memory when resized.
To deal with this, the HHTREEDB_ARRAY is the offset of the array's storage
offset, which doesn't change.
The value stored at the offset is updated when the array is resized.
*/

typedef const TreedbHandleArrayDescription *
TreedbHandleArrayDescriptionConstPtr;

struct treedb_handle_array_runtime_t;
typedef struct treedb_handle_array_runtime_t treedb_handle_array_runtime_t
, * treedb_handle_array_runtime_ptr_t;

typedef struct treedb_handle_array_t treedb_handle_array_t
, * treedb_handle_array_ptr_t;
typedef const treedb_handle_array_t * treedb_const_handle_array_ptr_t;
	#ifdef __cplusplus
typedef treedb_handle_array_t & treedb_handle_array_ref_t;
	#else
	  #define treedb_handle_array_ref_t treedb_handle_array_ptr_t
	#endif

typedef struct treedb_handle_array_backend_t treedb_handle_array_backend_t
, * treedb_handle_array_backend_ptr_t;

typedef struct treedb_handle_array_impl_t treedb_handle_array_impl_t
, * treedb_handle_array_impl_ptr_t;
typedef const treedb_handle_array_impl_t * treedb_const_handle_array_impl_ptr_t;

/* v-table pointers should really be const pointers, but it's not a big deal.

NEVER,NEVER,NEVER think that you can omit this v-table in c++!!!
Why:
1. It causes a compile error when you try to instantiate an abstract class
2. We obtain the implementation (along with the v-table) with a function call
   and c++ doesn't copy over the (hidden) v-table with respect to c++ objects
*/
typedef struct treedb_handle_array_impl_vtbl_t treedb_handle_array_impl_vtbl_t;
typedef treedb_handle_array_impl_vtbl_t * treedb_handle_array_impl_vtbl_ptr_t;
typedef struct treedb_handle_array_backend_vtbl_t
treedb_handle_array_backend_vtbl_t, * treedb_handle_array_backend_vtbl_ptr_t;

  #endif /* #ifndef MetaTreedb_handle_array_typedefs_DEFINED */

/******************************************************************************/
/* treedb_handle_array_runtime_t                                              */
/*                                                                            */
/* May supply additional information beyond the implementation pointer.       */
/*                                                                            */
/* By implementing the backend you will quickly find out if a                 */
/* treedb_handle_array_ptr_t will do instead.                                 */
/*                                                                            */
/******************************************************************************/
struct treedb_handle_array_runtime_t {
	treedb_handle_array_impl_ptr_t m_pImpl;
};

/******************************************************************************/
/* treedb_handle_array_impl_t                                                 */
/******************************************************************************/
  #define treedb_handle_array_impl_t_methods(Imp, Prefix, Runtime) \
	STDMETHOD##Imp##_(PVOID, Prefix##Entries) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Alloc) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, size_t /*reserve*/ \
		, size_t /*increment*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Free) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Clear) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Clone) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha_to*/ \
		, HHTREEDB_ARRAY /*hha_from*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##Count) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##Reserve) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##Increment) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##SetIncrement) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, size_t /*u*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Insert) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, HTREEDB_ARRAYDATA /*pv*/ \
		, size_t /*where*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##InsertMany) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, size_t /*where*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Remove) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, size_t /*where*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##RemoveMany) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, size_t /*where*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PushBack) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, HTREEDB_ARRAYDATA /*pv*/\
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PushBackMany) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PushFront) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, HTREEDB_ARRAYDATA /*pv*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PushFrontMany) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopBack) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopBackMany) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopFront) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopFrontMany) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##ReverseSome) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		, size_t /*where*/ \
		, size_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Reverse) \
		( THIS(Runtime) \
		  HHTREEDB_ARRAY /*hha*/ \
		) PURE; \

  #ifdef COBJMACROS

	#define treedb_handle_array_impl_t_Entries(Runtime, hha) \
	  TREEDB_IFACE_IMPL_CCALL(Entries, Runtime, hha)
	#define treedb_handle_array_impl_t_Alloc(Runtime, hha, reserve, increment) \
	  TREEDB_IFACE_IMPL_CCALL(Alloc, Runtime, hha, reserve, increment)
	#define treedb_handle_array_impl_t_Free(Runtime, hha) \
	  TREEDB_IFACE_IMPL_CCALL(Free, Runtime, hha)
	#define treedb_handle_array_impl_t_Clear(Runtime, hha) \
	  TREEDB_IFACE_IMPL_CCALL(Clear, Runtime, hha)
	#define treedb_handle_array_impl_t_Clone(Runtime, hha_to, hha_from) \
	  TREEDB_IFACE_IMPL_CCALL(Clone, Runtime, hha_to, hha_from)
	#define treedb_handle_array_impl_t_Count(Runtime, hha) \
	  TREEDB_IFACE_IMPL_CCALL(Count, Runtime, hha)
	#define treedb_handle_array_impl_t_Reserve(Runtime, hha) \
	  TREEDB_IFACE_IMPL_CCALL(Reserve, Runtime, hha)
	#define treedb_handle_array_impl_t_Increment(Runtime, hha) \
	  TREEDB_IFACE_IMPL_CCALL(Increment, Runtime, hha)
	#define treedb_handle_array_impl_t_SetIncrement(Runtime, hha, u) \
	  TREEDB_IFACE_IMPL_CCALL(SetIncrement, Runtime, hha, u)
	#define treedb_handle_array_impl_t_Insert(Runtime, hha, where, pv) \
	  TREEDB_IFACE_IMPL_CCALL(Insert, Runtime, hha, pv, where)
	#define treedb_handle_array_impl_t_InsertMany(Runtime, hha, where, count) \
	  TREEDB_IFACE_IMPL_CCALL(InsertMany, Runtime, hha, where, count)
	#define treedb_handle_array_impl_t_Remove(Runtime, hha, where) \
	  TREEDB_IFACE_IMPL_CCALL(Remove, Runtime, hha, where)
	#define treedb_handle_array_impl_t_RemoveMany(Runtime, hha, where, count) \
	  TREEDB_IFACE_IMPL_CCALL(RemoveMany, Runtime, hha, where, count)
	#define treedb_handle_array_impl_t_PushBack(Runtime, hha, pv) \
	  TREEDB_IFACE_IMPL_CCALL(PushBack, Runtime, hha, pv)
	#define treedb_handle_array_impl_t_PushBackMany(Runtime, hha, count) \
	  TREEDB_IFACE_IMPL_CCALL(PushBackMany, Runtime, hha, count)
	#define treedb_handle_array_impl_t_PushFront(Runtime, hha, pv) \
	  TREEDB_IFACE_IMPL_CCALL(PushFront, Runtime, hha, pv)
	#define treedb_handle_array_impl_t_PushFrontMany(Runtime, hha, count) \
	  TREEDB_IFACE_IMPL_CCALL(PushFrontMany, Runtime, hha, count)
	#define treedb_handle_array_impl_t_PopBack(Runtime, hha) \
	  TREEDB_IFACE_IMPL_CCALL(PopBack, Runtime, hha)
	#define treedb_handle_array_impl_t_PopBackMany(Runtime, hha, count) \
	  TREEDB_IFACE_IMPL_CCALL(PopBackMany, Runtime, hha, count)
	#define treedb_handle_array_impl_t_PopFront(Runtime, hha) \
	  TREEDB_IFACE_IMPL_CCALL(PopFront, Runtime, hha)
	#define treedb_handle_array_impl_t_PopFrontMany(Runtime, hha, count) \
	  TREEDB_IFACE_IMPL_CCALL(PopFrontMany, Runtime, hha, count)
	#define treedb_handle_array_impl_t_ReverseSome(Runtime, hha, where, count) \
	  TREEDB_IFACE_IMPL_CCALL(ReverseSome, Runtime, hha, where, count)
	#define treedb_handle_array_impl_t_Reverse(Runtime, hha) \
	  TREEDB_IFACE_IMPL_CCALL(Reverse, Runtime, hha)

	#define treedb_handle_array_impl_t_has_allocator(This) \
	  ((This)->m_pAllocator != 0)

/* Allocator convenience macros --------------------------------------------- */
	#define treedb_handle_array_impl_t_PointerToOffset(This, u) \
	  treedb_allocator_t_PointerToOffset((This)->m_pAllocator, u)
	#define treedb_handle_array_impl_t_OffsetToPointer(This, u) \
	  treedb_allocator_t_OffsetToPointer((This)->m_pAllocator, u)
	#define treedb_handle_array_impl_t_PointerPack(This, p) \
	  treedb_allocator_t_PointerPack((This)->m_pAllocator, p)
	#define treedb_handle_array_impl_t_PointerUnpack(This, u) \
	  treedb_allocator_t_PointerUnpack((This)->m_pAllocator, u)

/* Allocator convenience handle macros -------------------------------------- */
	#define treedb_handle_array_impl_t_Read(This, hloc) \
	  treedb_allocator_t_Read((This)->m_pAllocator, hloc)
	#define treedb_handle_array_impl_t_Write(This, hloc, hvalue) \
	  treedb_allocator_t_Write((This)->m_pAllocator, hloc, hvalue)
	#define treedb_handle_array_impl_t_PointerRead(This, hloc) \
	  treedb_allocator_t_PointerRead((This)->m_pAllocator, hloc)
	#define treedb_handle_array_impl_t_PointerWrite(This, hloc, pv) \
	  treedb_allocator_t_PointerWrite((This)->m_pAllocator, hloc, pv)
	#define treedb_handle_array_impl_t_PointerAddTo(This, hloc, u) \
	  treedb_allocator_t_PointerAddTo((This)->m_pAllocator, hloc, u)

/* Allocator convenience pointer macros ------------------------------------- */
	#define treedb_handle_array_impl_t_ReadPtr(This, pv) \
	  treedb_allocator_t_ReadPtr((This)->m_pAllocator, p)
	#define treedb_handle_array_impl_t_WritePtr(This, pv, hvalue) \
	  treedb_allocator_t_WritePtr((This)->m_pAllocator, pv, hvalue)
	#define treedb_handle_array_impl_t_PointerReadPtr(This, pv) \
	  treedb_allocator_t_PointerReadPtr((This)->m_pAllocator, pv)
	#define treedb_handle_array_impl_t_PointerWritePtr(This, pv, pvvalue) \
	  treedb_allocator_t_PointerWritePtr((This)->m_pAllocator, pv, pvvalue)
	#define treedb_handle_array_impl_t_PointerAddToPtr(This, pv, u) \
	  treedb_allocator_t_PointerAddToPtr((This)->m_pAllocator, pv, u)


/* Backend convenience macros ----------------------------------------------- */
	#define treedb_handle_array_impl_t_backend_FreeEntries(This, hha, begin \
		, count) \
	  treedb_handle_array_backend_t_FreeEntries((This)->m_pBackend, This, hha \
		, begin, count)

/* More convenience macros -------------------------------------------------- */
	#define treedb_handle_array_impl_t_offset_size(This) \
	  (This)->m_pDescription.m_pointer.m_uSize
	#define treedb_handle_array_impl_t_offset_alignment(This) \
	  (This)->m_pDescription.m_pointer.m_uAlign

	#define treedb_handle_array_impl_t_root_size(This) \
	  (This)->m_pDescription.m_root.m_uSize
	#define treedb_handle_array_impl_t_root_alignment(This) \
	  (This)->m_pDescription.m_root.m_uAlign

  #endif /* #ifdef COBJMACROS */

  #define treedb_handle_array_impl_vtbl_t_entries_default(Prefix) \
	  & Prefix##Entries \
	, & Prefix##Alloc \
	, & Prefix##Free \
	, & Prefix##Clear \
	, & Prefix##Clone \
	, & Prefix##Count \
	, & Prefix##Reserve \
	, & Prefix##Increment \
	, & Prefix##SetIncrement \
	, & Prefix##Insert \
	, & Prefix##InsertMany \
	, & Prefix##Remove \
	, & Prefix##RemoveMany \
	, & Prefix##PushBack \
	, & Prefix##PushBackMany \
	, & Prefix##PushFront \
	, & Prefix##PushFrontMany \
	, & Prefix##PopBack \
	, & Prefix##PopBackMany \
	, & Prefix##PopFront \
	, & Prefix##PopFrontMany \
	, & Prefix##ReverseSome \
	, & Prefix##Reverse

  #ifndef treedb_handle_array_impl_vtbl_t_entries
	#define treedb_handle_array_impl_vtbl_t_entries(x) \
	  treedb_handle_array_impl_vtbl_t_entries_default(x)
  #endif

  #define treedb_handle_array_impl_t_members(vtbl_ptr_t) \
	vtbl_ptr_t m_pVtbl; \
	treedb_allocator_ptr_t m_pAllocator; \
	treedb_handle_array_backend_ptr_t m_pBackend

  #ifndef MetaTreedb_treedb_handle_array_impl_t_DEFINED
	#define MetaTreedb_treedb_handle_array_impl_t_DEFINED

    #ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
struct treedb_handle_array_impl_vtbl_t
{
	treedb_handle_array_impl_t_methods(,,treedb_handle_array_runtime_t);
};
	#ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_handle_array_impl_t
{
	treedb_handle_array_impl_t_members(treedb_handle_array_impl_vtbl_ptr_t);
};

  #endif /* #ifndef MetaTreedb_treedb_handle_array_impl_t_DEFINED */

extern void treedb_handle_array_impl_t_Setup
( treedb_handle_array_impl_ptr_t pm
, treedb_allocator_on_storage_ptr_t pa
, treedb_handle_array_backend_ptr_t pb
, TreedbHandleArrayDescription * pd
, treedb_const_handle_array_impl_ptr_t ptemplate
);
/******************************************************************************/
/* treedb_handle_array_t                                                      */
/******************************************************************************/
struct treedb_handle_array_t {
	treedb_handle_array_impl_ptr_t m_pImpl;
	HHTREEDB_ARRAY m_handle; /* Double indirection. */
};

static inline
treedb_handle_array_runtime_ptr_t
treedb_handle_array_t_to_runtime(treedb_handle_array_ptr_t p)
{
	return (treedb_handle_array_runtime_ptr_t)p;
}

extern
void treedb_handle_array_t_Setup
( treedb_handle_array_ptr_t p
, treedb_handle_array_impl_ptr_t pImpl
, size_t uPayload
);

  #ifdef COBJMACROS

    #define treedb_handle_array_t_Clear(This) \
	  treedb_handle_array_impl_t_Clear(treedb_handle_array_t_to_runtime(This) \
		, (This)->m_handle)
    #define treedb_handle_array_t_Clone(This, hha_from) \
	  treedb_handle_array_impl_t_Clone(treedb_handle_array_t_to_runtime(This) \
		, (This)->m_handle, hha_from)
	#define treedb_handle_array_t_Count(This) \
	  treedb_handle_array_impl_t_Count(treedb_handle_array_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_handle_array_t_Reserve(This) \
	  treedb_handle_array_impl_t_Reserve(treedb_handle_array_t_to_runtime(This)\
		, (This)->m_handle)
	#define treedb_handle_array_t_Increment(This) \
	  treedb_handle_array_impl_t_Increment( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle)
	#define treedb_handle_array_t_SetIncrement(This, u) \
	  treedb_handle_array_impl_t_SetIncrement( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle, u)
	#define treedb_handle_array_t_Insert(This, pv, where) \
	  treedb_handle_array_impl_t_Insert(treedb_handle_array_t_to_runtime(This) \
		, (This)->m_handle, pv, where)
	#define treedb_handle_array_t_InsertMany(This, where, count) \
	  treedb_handle_array_impl_t_InsertMany( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle, where, count)
	#define treedb_handle_array_t_Remove(This, ha, where) \
	  treedb_handle_array_impl_t_Remove(treedb_handle_array_t_to_runtime(This) \
		, (This)->m_handle, where)
	#define treedb_handle_array_t_RemoveMany(This, ha, where, count) \
	  treedb_handle_array_impl_t_RemoveMany( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle, where, count)
	#define treedb_handle_array_t_PushBack(This, pv) \
	  treedb_handle_array_impl_t_PushBack( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle, pv)
	#define treedb_handle_array_t_PushBackMany(This, count) \
	  treedb_handle_array_impl_t_PushBackMany( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle, count)
	#define treedb_handle_array_t_PushFront(This, pv) \
	  treedb_handle_array_impl_t_PushFront( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle, pv)
	#define treedb_handle_array_t_PushFrontMany(This, count) \
	  treedb_handle_array_impl_t_PushFrontMany( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle, count)
	#define treedb_handle_array_t_PopBack(This) \
	  treedb_handle_array_impl_t_PopBack( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle)
	#define treedb_handle_array_t_PopBackMany(This, count) \
	  treedb_handle_array_impl_t_PopBackMany( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle, count)
	#define treedb_handle_array_t_PopFront(This) \
	  treedb_handle_array_impl_t_PopFront( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle)
	#define treedb_handle_array_t_PopFrontMany(This, count) \
	  treedb_handle_array_impl_t_PopFrontMany( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle, count)
	#define treedb_handle_array_t_ReverseSome(This, count) \
	  treedb_handle_array_impl_t_ReverseSome( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle, count)
	#define treedb_handle_array_t_Reverse(This) \
	  treedb_handle_array_impl_t_Reverse( \
		treedb_handle_array_t_to_runtime(This), (This)->m_handle)

/* Allocator convenience macros --------------------------------------------- */
	#define treedb_handle_array_t_PointerToOffset(This, u) \
	  treedb_handle_array_impl_t_PointerToOffset((This)->m_pImpl, u)
	#define treedb_handle_array_t_OffsetToPointer(This, u) \
	  treedb_handle_array_impl_t_OffsetToPointer((This)->m_pImpl, u)
	#define treedb_handle_array_t_PointerPack(This, p) \
	  treedb_handle_array_impl_t_PointerPack((This)->m_pImpl, p)
	#define treedb_handle_array_t_PointerUnpack(This, u) \
	  treedb_handle_array_impl_t_PointerUnpack((This)->m_pImpl, u)

/* Allocator convenience handle macros -------------------------------------- */
	#define treedb_handle_array_t_Read(This, hloc) \
	  treedb_handle_array_impl_t_Read((This)->m_pImpl, hloc)
	#define treedb_handle_array_t_Write(This, hloc, hvalue) \
	  treedb_handle_array_impl_t_Write((This)->m_pImpl, hloc, hvalue)
	#define treedb_handle_array_t_PointerRead(This, hloc) \
	  treedb_handle_array_impl_t_PointerRead((This)->m_pImpl, hloc)
	#define treedb_handle_array_t_PointerWrite(This, hloc, pv) \
	  treedb_handle_array_impl_t_PointerWrite((This)->m_pImpl, hloc, pv)
	#define treedb_handle_array_t_PointerAddTo(This, hloc, u) \
	  treedb_handle_array_impl_t_PointerAddTo((This)->m_pImpl, hloc, u)

/* Allocator convenience pointer macros ------------------------------------- */
	#define treedb_handle_array_t_ReadPtr(This, pv) \
	  treedb_handle_array_impl_t_ReadPtr((This)->m_pImpl, p)
	#define treedb_handle_array_t_WritePtr(This, pv, hvalue) \
	  treedb_handle_array_impl_t_WritePtr((This)->m_pImpl, pv, hvalue)
	#define treedb_handle_array_t_PointerReadPtr(This, pv) \
	  treedb_handle_array_impl_t_PointerReadPtr((This)->m_pImpl, pv)
	#define treedb_handle_array_t_PointerWritePtr(This, pv, pvvalue) \
	  treedb_handle_array_impl_t_PointerWritePtr((This)->m_pImpl, pv \
		, pvvalue)
	#define treedb_handle_array_t_PointerAddToPtr(This, pv, u) \
	  treedb_handle_array_impl_t_PointerAddToPtr((This)->m_pImpl, pv, u)

/* Backend convenience macros ----------------------------------------------- */
	#define treedb_handle_array_t_backend_FreeEntries(This, begin, count) \
	  treedb_handle_array_backend_t_FreeEntries((This)->m_pImpl->m_pBackend \
		, treedb_handle_array_t_to_runtime(This), (This)->m_handle, begin \
		, count)

/* More convenience macros -------------------------------------------------- */
	#define treedb_handle_array_t_offset_size(This) \
	  treedb_handle_array_impl_t_offset_size((This)->m_pImpl)
	#define treedb_handle_array_t_offset_alignment(This) \
	  treedb_handle_array_impl_t_offset_alignment((This)->m_pImpl)

	#define treedb_handle_array_t_root_size(This) \
	  treedb_handle_array_impl_t_root_size((This)->m_pImpl)
	#define treedb_handle_array_t_root_alignment(This) \
	  treedb_handle_array_impl_t_root_alignment((This)->m_pImpl)

  #endif /* #ifdef COBJMACROS */

/******************************************************************************/
/* treedb_handle_array_backend_t                                              */
/******************************************************************************/
  #define treedb_handle_array_backend_t_methods(Imp, Prefix, Class, Runtime) \
	STDMETHOD##Imp##_(BOOL, Prefix##FreeEntries) \
		( THIS(Class) \
		  Runtime * /*runtime*/ \
		, HHTREEDB_ARRAY /*hha*/ \
		, size_t /*where*/ \
		, size_t /*count*/ \
		) PURE

  #ifdef COBJMACROS

	#define treedb_handle_array_backend_t_FreeEntries(This, Runtime, hha \
		, where, count) \
	  V3C_IFACE_CALL(FreeEntries, This, Runtime, hha, where, count)

  #endif /* #ifdef COBJMACROS */

  #define treedb_handle_array_backend_vtbl_t_entries_default(Prefix) \
	& Prefix##FreeEntries

  #ifndef treedb_handle_array_backend_vtbl_t_entries
	#define treedb_handle_array_backend_vtbl_t_entries(x) \
	  treedb_handle_array_backend_vtbl_t_entries_default(x)
  #endif

  #define treedb_handle_array_backend_t_members(vtbl_ptr_t) \
	vtbl_ptr_t m_pVtbl; \
	TreedbHandleArrayDescriptionConstPtr m_pDescription

  #ifndef MetaTreedb_treedb_handle_array_backend_t_DEFINED
	#define MetaTreedb_treedb_handle_array_backend_t_DEFINED

	#ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
struct treedb_handle_array_backend_vtbl_t
{
	treedb_handle_array_backend_t_methods(,,treedb_handle_array_backend_t
		, treedb_handle_array_runtime_t);
};
	#ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_handle_array_backend_t
{
	treedb_handle_array_backend_t_members(
		treedb_handle_array_backend_vtbl_ptr_t);
};

  #endif /* #ifndef MetaTreedb_treedb_handle_array_backend_t_DEFINED */

extern void treedb_handle_array_backend_t_Setup
( treedb_handle_array_backend_ptr_t pb
, PVOID pVtbl
, TreedbHandleArrayDescriptionConstPtr pDescription
);

extern treedb_const_handle_array_ptr_t
treedb_get_handle_array_template_for
( uint16_t uBytes /* 2, 4, 8 */
, uint16_t flags /* flags & eTreedbContainerIsPointer means ignore uBytes */
);

extern treedb_const_handle_array_ptr_t
treedb_get_handle_array_template_using_allocator
( treedb_allocator_ptr_t pallocator
);

  #ifdef __cplusplus
} // extern "C" {
  #endif

#endif /* #ifndef v3c_meta_treedb_handle_array_h_included */
