/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_h_included
  #include "meta-treedb.h"
#endif

#ifndef v3c_meta_treedb_list_h_included
  #define v3c_meta_treedb_list_h_included

  #ifdef __cplusplus
extern "C" {
  #endif

/******************************************************************************/
/* Delegates                                                                  */
/******************************************************************************/
#define TREEDB_IListImpl_DELEGATE_TO(x) \
inline void STDCALL \
	Init \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { V3C_DELEGATE(x, Init(runtime, hl)); } \
inline void STDCALL \
	Clear \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { V3C_DELEGATE(x, Clear(runtime, hl)); } \
inline HTREEDB_LIST STDCALL \
	Alloc \
	(treedb_list_runtime_ptr_t runtime \
	) { return V3C_DELEGATE(x, Alloc(runtime)); } \
inline void STDCALL \
	Free \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { V3C_DELEGATE(x, Free(runtime, hl)); } \
inline uint64_t STDCALL \
	Count \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { return V3C_DELEGATE(x, Count(runtime, hl)); } \
inline HTREEDB_LISTNODE STDCALL \
	PushFront \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, HTREEDB_LISTDATA pd \
	) { return V3C_DELEGATE(x, PushFront(runtime, hl, pd)); } \
inline HTREEDB_LISTNODE STDCALL \
	PushBack \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, HTREEDB_LISTDATA pd \
	) { return V3C_DELEGATE(x, PushBack(runtime, hl, pd)); } \
inline BOOL STDCALL \
	RemoveNodes \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, HTREEDB_LISTNODE hstart \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, RemoveNodes(runtime, hl, hstart, count)); } \
inline BOOL STDCALL \
	RemoveMany \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, RemoveMany(runtime, hl, where, count)); } \
inline BOOL STDCALL \
	Remove \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, uintptr_t where \
	) { return V3C_DELEGATE(x, Remove(runtime, hl, where)); } \
inline BOOL STDCALL \
	PopFront \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { return V3C_DELEGATE(x, PopFront(runtime, hl)); } \
inline BOOL STDCALL \
	PopBack \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { return V3C_DELEGATE(x, PopBack(runtime, hl)); } \
inline void STDCALL \
	Reverse \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { V3C_DELEGATE(x, Reverse(runtime, hl)); } \
inline HTREEDB_LISTNODE STDCALL \
	Head \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { return V3C_DELEGATE(x, Head(runtime, hl)); } \
inline HTREEDB_LISTNODE STDCALL \
	Tail \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { return V3C_DELEGATE(x, Tail(runtime, hl)); } \
inline PVOID STDCALL \
	PointerHead \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { return V3C_DELEGATE(x, PointerHead(runtime, hl)); } \
inline PVOID STDCALL \
	PointerTail \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	) { return V3C_DELEGATE(x, PointerTail(runtime, hl)); } \
\
/* "Handle" methods */ \
\
inline HTREEDB_LISTNODE STDCALL \
	PushFrontNode \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, PushFrontNode(runtime, hl, hn)); } \
inline HTREEDB_LISTNODE STDCALL \
	PushBackNode \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, PushBackNode(runtime, hl, hn)); } \
inline void STDCALL \
	InsertNodeBefore \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, HTREEDB_LISTNODE hn \
	, HTREEDB_LISTNODE hn_new \
	) { V3C_DELEGATE(x, InsertNodeBefore(runtime, hl, hn \
		, hn_new)); } \
inline void STDCALL \
	InsertNodeAfter \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, HTREEDB_LISTNODE hn \
	, HTREEDB_LISTNODE hn_new \
	) { V3C_DELEGATE(x, InsertNodeAfter(runtime, hl, hn \
		, hn_new)); } \
inline void STDCALL \
	RelinkNode \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, HTREEDB_LISTNODE hn \
	) { V3C_DELEGATE(x, RelinkNode(runtime, hl, hn)); } \
inline void STDCALL \
	UnlinkNode \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, HTREEDB_LISTNODE hn \
	) { V3C_DELEGATE(x, UnlinkNode(runtime, hl, hn)); } \
inline void STDCALL \
	DeleteNode \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, HTREEDB_LISTNODE hn \
	) { V3C_DELEGATE(x, DeleteNode(runtime, hl, hn)); } \
inline BOOL STDCALL \
	NodeHasNext \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, NodeHasNext(runtime, hn)); } \
inline HTREEDB_LISTNODE STDCALL \
	NodeNext \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, NodeNext(runtime, hn)); } \
inline PVOID STDCALL \
	PointerNodeNext \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, PointerNodeNext(runtime, hn)); } \
inline BOOL STDCALL \
	NodeHasPrev \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, NodeHasPrev(runtime, hn)); } \
inline HTREEDB_LISTNODE STDCALL \
	NodePrev \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, NodePrev(runtime, hn)); } \
inline PVOID STDCALL \
	PointerNodePrev \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, PointerNodePrev(runtime, hn)); } \
\
/* "Pointer" methods */ \
\
inline PVOID STDCALL \
	PushFrontNodePtr \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, PVOID pn \
	) { return V3C_DELEGATE(x, PushFrontNodePtr(runtime, hl, pn)); } \
inline PVOID STDCALL \
	PushBackNodePtr \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, PVOID pn \
	) { return V3C_DELEGATE(x, PushBackNodePtr(runtime, hl, pn)); } \
inline void STDCALL \
	InsertNodeBeforePtr \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, PVOID pn \
	, PVOID pn_new \
	) { V3C_DELEGATE(x, InsertNodeBeforePtr(runtime, hl, pn \
		, pn_new)); } \
inline void STDCALL \
	InsertNodeAfterPtr \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, PVOID pn \
	, PVOID pn_new \
	) { V3C_DELEGATE(x, InsertNodeAfterPtr(runtime, hl, pn \
		, pn_new)); } \
inline void STDCALL \
	RelinkNodePtr \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, PVOID pn \
	) { V3C_DELEGATE(x, RelinkNodePtr(runtime, hl, pn)); } \
inline void STDCALL \
	UnlinkNodePtr \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, PVOID pn \
	) { V3C_DELEGATE(x, UnlinkNodePtr(runtime, hl, pn)); } \
inline void STDCALL \
	DeleteNodePtr \
	( treedb_list_runtime_ptr_t runtime \
	, HTREEDB_LIST hl \
	, PVOID pn \
	) { V3C_DELEGATE(x, DeleteNodePtr(runtime, hl, pn)); } \
inline BOOL STDCALL \
	NodeHasNextPtr \
	( treedb_list_runtime_ptr_t runtime \
	, PVOID pn \
	) { return V3C_DELEGATE(x, NodeHasNextPtr(runtime, pn)); } \
inline HTREEDB_LISTNODE STDCALL \
	NodeNextPtr \
	( treedb_list_runtime_ptr_t runtime \
	, PVOID pn \
	) { return V3C_DELEGATE(x, NodeNextPtr(runtime, pn)); } \
inline PVOID STDCALL \
	PointerNodeNextPtr \
	( treedb_list_runtime_ptr_t runtime \
	, PVOID pn \
	) { return V3C_DELEGATE(x, PointerNodeNextPtr(runtime, pn)); } \
inline BOOL STDCALL \
	NodeHasPrevPtr \
	( treedb_list_runtime_ptr_t runtime \
	, PVOID pn \
	) { return V3C_DELEGATE(x, NodeHasPrevPtr(runtime, pn)); } \
inline HTREEDB_LISTNODE STDCALL \
	NodePrevPtr \
	( treedb_list_runtime_ptr_t runtime \
	, PVOID pn \
	) { return V3C_DELEGATE(x, NodePrevPtr(runtime, pn)); } \
inline PVOID STDCALL \
	PointerNodePrevPtr \
	( treedb_list_runtime_ptr_t runtime \
	, PVOID pn \
	) { return V3C_DELEGATE(x, PointerNodePrevPtr(runtime, pn)); }

#define TREEDB_IListBackend_DELEGATE_TO(x) \
inline PVOID STDCALL \
	AllocNode(treedb_list_runtime_ptr_t runtime, HTREEDB_LISTDATA data) \
		{ return V3C_DELEGATE(x, AllocNode(DGTHIS(x) runtime, data)); } \
inline void STDCALL \
	FreeNode(treedb_list_runtime_ptr_t runtime, PVOID pn) \
		{ return V3C_DELEGATE(x, FreeNode(DGTHIS(x) runtime, pn)); }

/******************************************************************************/
/* typedefs / forward declarations                                            */
/******************************************************************************/
  #ifndef MetaTreedb_list_typedefs_DEFINED
	#define MetaTreedb_list_typedefs_DEFINED

typedef uintptr_t HTREEDB_LIST;
typedef uintptr_t HTREEDB_LISTNODE;
typedef PCVOID HTREEDB_LISTDATA;

struct treedb_list_runtime_t;
typedef struct treedb_list_runtime_t treedb_list_runtime_t
	, * treedb_list_runtime_ptr_t;

typedef struct treedb_list_t treedb_list_t, * treedb_list_ptr_t;
typedef const treedb_list_t * treedb_const_list_ptr_t;
	#ifdef __cplusplus
typedef treedb_list_t & treedb_list_ref_t;
	#else
	  #define treedb_list_ref_t treedb_list_ptr_t
	#endif

typedef struct treedb_list_backend_t treedb_list_backend_t
	, * treedb_list_backend_ptr_t;

typedef struct treedb_list_impl_t treedb_list_impl_t
	, * treedb_list_impl_ptr_t;
typedef const treedb_list_impl_t * treedb_const_list_impl_ptr_t;

/* v-table pointers should really be const pointers, but it's not a big deal.

NEVER,NEVER,NEVER think that you can omit this v-table in c++!!!
Why:
1. It causes a compile error when you try to instantiate an abstract class
2. We obtain the implementation (along with the v-table) with a function call
   and c++ doesn't copy over the (hidden) v-table with respect to c++ objects
*/
typedef struct treedb_list_impl_vtbl_t treedb_list_impl_vtbl_t;
typedef treedb_list_impl_vtbl_t * treedb_list_impl_vtbl_ptr_t;
typedef struct treedb_list_backend_vtbl_t treedb_list_backend_vtbl_t
	, * treedb_list_backend_vtbl_ptr_t;

  #endif /* #ifndef MetaTreedb_list_typedefs_DEFINED */

/******************************************************************************/
/* treedb_list_runtime_t                                                    */
/*                                                                            */
/* May supply additional information beyond the implementation pointer.       */
/*                                                                            */
/* By implementing the backend you will quickly find out if a                 */
/* treedb_list_ptr_t will do instead.                                       */
/*                                                                            */
/******************************************************************************/
struct treedb_list_runtime_t {
	treedb_list_impl_ptr_t m_pImpl;
};

/******************************************************************************/
/* treedb_list_impl_t                                                       */
/******************************************************************************/
  #define treedb_list_impl_t_methods(Imp, Prefix, Runtime) \
	STDMETHOD##Imp##_(void, Prefix##Init) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Clear) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_LIST, Prefix##Alloc) \
		( THIS0(Runtime) \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Free) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	STDMETHOD##Imp##_(uint64_t, Prefix##Count) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_LISTNODE, Prefix##PushFront) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, HTREEDB_LISTDATA /*pv*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_LISTNODE, Prefix##PushBack) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, HTREEDB_LISTDATA /*pv*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##RemoveNodes) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, HTREEDB_LISTNODE /*hstart*/ \
		, uintptr_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##RemoveMany) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, uintptr_t /*where*/ \
		, uintptr_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Remove) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, uintptr_t /*where*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopFront) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopFrontMany) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, uintptr_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopBack) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##PopBackMany) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, uintptr_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##ReverseSome) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, uintptr_t /*where*/ \
		, uintptr_t /*count*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Reverse) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	\
	STDMETHOD##Imp##_(HTREEDB_LISTNODE, Prefix##Head) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_LISTNODE, Prefix##Tail) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerHead) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerTail) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		) PURE; \
	\
	/* "Handle" methods */ \
	STDMETHOD##Imp##_(HTREEDB_LISTNODE, Prefix##PushFrontNode) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, HTREEDB_LISTNODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_LISTNODE, Prefix##PushBackNode) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, HTREEDB_LISTNODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##InsertNodeBefore) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, HTREEDB_LISTNODE /*hn*/ \
		, HTREEDB_LISTNODE /*hn_new*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##InsertNodeAfter) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, HTREEDB_LISTNODE /*hn*/ \
		, HTREEDB_LISTNODE /*hn_new*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##RelinkNode) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, HTREEDB_LISTNODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##UnlinkNode) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, HTREEDB_LISTNODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##DeleteNode) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, HTREEDB_LISTNODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##NodeHasNext) \
		( THIS(Runtime) \
		  HTREEDB_LISTNODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_LISTNODE, Prefix##NodeNext) \
		( THIS(Runtime) \
		  HTREEDB_LISTNODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerNodeNext) \
		( THIS(Runtime) \
		  HTREEDB_LISTNODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##NodeHasPrev) \
		( THIS(Runtime) \
		  HTREEDB_LISTNODE /*hl*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_LISTNODE, Prefix##NodePrev) \
		( THIS(Runtime) \
		  HTREEDB_LISTNODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerNodePrev) \
		( THIS(Runtime) \
		  HTREEDB_LISTNODE /*hn*/ \
		) PURE; \
	\
	\
	/* "Pointer" methods */ \
	STDMETHOD##Imp##_(PVOID, Prefix##PushFrontNodePtr) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PushBackNodePtr) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##InsertNodeBeforePtr) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, PVOID /*pn*/ \
		, PVOID /*pn_new*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##InsertNodeAfterPtr) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, PVOID /*pn*/ \
		, PVOID /*pn_new*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##RelinkNodePtr) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##UnlinkNodePtr) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##DeleteNodePtr) \
		( THIS(Runtime) \
		  HTREEDB_LIST /*hl*/ \
		, PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##NodeHasNextPtr) \
		( THIS(Runtime) \
		  PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_LISTNODE, Prefix##NodeNextPtr) \
		( THIS(Runtime) \
		  PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerNodeNextPtr) \
		( THIS(Runtime) \
		  PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##NodeHasPrevPtr) \
		( THIS(Runtime) \
		  PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_LISTNODE, Prefix##NodePrevPtr) \
		( THIS(Runtime) \
		  PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerNodePrevPtr) \
		( THIS(Runtime) \
		  PVOID /*pn*/ \
		) PURE

  #ifdef COBJMACROS

	#define treedb_list_impl_t_Init(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(Init, Runtime, hlist)
	#define treedb_list_impl_t_Clear(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(Clear, Runtime, hlist)
	#define treedb_list_impl_t_Alloc(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(Alloc, Runtime, hlist)
	#define treedb_list_impl_t_Free(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(Free, Runtime, hlist)
	#define treedb_list_impl_t_Count(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(Count, Runtime, hlist)
	#define treedb_list_impl_t_PushFront(Runtime, hlist, pv) \
	  TREEDB_IFACE_IMPL_CCALL(PushFront, Runtime, hlist, pv)
	#define treedb_list_impl_t_PushBack(Runtime, hlist, pv) \
	  TREEDB_IFACE_IMPL_CCALL(PushBack, Runtime, hlist, pv)
	#define treedb_list_impl_t_RemoveNodes(Runtime, hlist, hstart, count) \
	  TREEDB_IFACE_IMPL_CCALL(RemoveNodes, Runtime, hlist, hstart, count)
	#define treedb_list_impl_t_RemoveMany(Runtime, hlist, where, count) \
	  TREEDB_IFACE_IMPL_CCALL(RemoveMany, Runtime, hlist, where, count)
	#define treedb_list_impl_t_Remove(Runtime, hlist, where) \
	  TREEDB_IFACE_IMPL_CCALL(Remove, Runtime, hlist, where)
	#define treedb_list_impl_t_PopFront(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(PopFront, Runtime, hlist)
	#define treedb_list_impl_t_PopFrontMany(Runtime, hlist, count) \
	  TREEDB_IFACE_IMPL_CCALL(PopFrontMany, Runtime, hlist, count)
	#define treedb_list_impl_t_PopBack(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(PopBack, Runtime, hlist)
	#define treedb_list_impl_t_PopBackMany(Runtime, hlist, count) \
	  TREEDB_IFACE_IMPL_CCALL(PopBackMany, Runtime, hlist, count)
	#define treedb_list_impl_t_ReverseSome(Runtime, hlist, where, count) \
	  TREEDB_IFACE_IMPL_CCALL(ReverseSome, Runtime, hlist, where, count)
	#define treedb_list_impl_t_Reverse(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(Reverse, Runtime, hlist)

	#define treedb_list_impl_t_Head(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(Head, Runtime, hlist)
	#define treedb_list_impl_t_Tail(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(Tail, Runtime, hlist)
	#define treedb_list_impl_t_PointerHead(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(PointerHead, Runtime, hlist)
	#define treedb_list_impl_t_PointerTail(Runtime, hlist) \
	  TREEDB_IFACE_IMPL_CCALL(PointerTail, Runtime, hlist)

/* "Handle" methods */
	#define treedb_list_impl_t_PushFrontNode(Runtime, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(PushFrontNode, Runtime, hlist, pn)
	#define treedb_list_impl_t_PushBackNode(Runtime, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(PushBackNode, Runtime, hlist, pn)
	#define treedb_list_impl_t_InsertNodeBefore(Runtime, hlist, hn, hn_new) \
	  TREEDB_IFACE_IMPL_CCALL(InsertBefore, Runtime, hlist, hn, hn_new)
	#define treedb_list_impl_t_InsertNodeAfter(Runtime, hlist, hn, hn_new) \
	  TREEDB_IFACE_IMPL_CCALL(InsertAfter, Runtime, hlist, hn, hn_new)
	#define treedb_list_impl_t_RelinkNode(Runtime, hlist, hn) \
	  TREEDB_IFACE_IMPL_CCALL(RelinkNode, Runtime, hlist, hn)
	#define treedb_list_impl_t_UnlinkNode(Runtime, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(UnlinkNode, Runtime, hlist, pn)
	#define treedb_list_impl_t_DeleteNode(Runtime, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(DeleteNode, Runtime, hlist, pv)
	#define treedb_list_impl_t_NodeHasNext(Runtime, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeHasNext, Runtime, hlist, pn)
	#define treedb_list_impl_t_NodeNext(Runtime, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeNext, Runtime, hlist, pn)
	#define treedb_list_impl_t_NodeHasPrev(Runtime, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeHasPrev, Runtime, hlist, pn)
	#define treedb_list_impl_t_NodePrev(Runtime, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodePrev, Runtime, hlist, pn)

/* "Pointer" methods */
	#define treedb_list_impl_t_PushFrontNodePtr(This, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(PushFrontNodePtr, This, hlist, pn)
	#define treedb_list_impl_t_PushBackNodePtr(This, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(PushBackNodePtr, This, hlist, pn)
	#define treedb_list_impl_t_InsertNodeBeforePtr(This, hlist, pn, pn_new) \
	  TREEDB_IFACE_IMPL_CCALL(InsertBeforePtr, This, hlist, pn, pn_new)
	#define treedb_list_impl_t_InsertNodeAfterPtr(This, hlist, pn, pn_new) \
	  TREEDB_IFACE_IMPL_CCALL(InsertAfterPtr, This, hlist, pn, pn_new)
	#define treedb_list_impl_t_RelinkNodePtr(This, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(RelinkNodePtr, This, hlist, pn)
	#define treedb_list_impl_t_UnlinkNodePtr(This, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(UnlinkNodePtr, This, hlist, pn)
	#define treedb_list_impl_t_DeleteNodePtr(This, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(DeleteNodePtr, This, hlist, pn)
	#define treedb_list_impl_t_NodeHasNextPtr(This, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeHasNextPtr, This, hlist, pn)
	#define treedb_list_impl_t_NodeNextPtr(This, hlist, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeNextPtr, This, hlist, pn)
	#define treedb_list_impl_t_PointerNodeNextPtr(This, pn) \
	  TREEDB_IFACE_IMPL_CCALL(PointerNodeNextPtr, This, pn)
	#define treedb_list_impl_t_NodeHasPrevPtr(This, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeHasPrevPtr, This, pn)
	#define treedb_list_impl_t_NodePrevPtr(This, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodePrevPtr, This, pn)
	#define treedb_list_impl_t_PointerNodePrevPtr(This, pn) \
	  TREEDB_IFACE_IMPL_CCALL(PointerNodePrevPtr, This, pn)

	#define treedb_list_impl_t_NodeToData(This, p) \
	  (p + (This)->m_pDescription->m_aligned_node_size)
	#define treedb_list_impl_t_DataToNode(This, p) \
	  (p - (This)->m_pDescription->m_aligned_node_size)

	#define treedb_list_impl_t_NodeToDataPtr(This, p) \
	  ((char *)(p) + (This)->m_pDescription->m_aligned_node_size)
	#define treedb_list_impl_t_DataToNodePtr(This, p) \
	  ((char *)(p) - (This)->m_pDescription->m_aligned_node_size)

/* Allocator convenience macros --------------------------------------------- */
	#define treedb_list_impl_t_PointerToOffset(This, u) \
	  treedb_allocator_t_PointerToOffset((This)->m_pAllocator, u)
	#define treedb_list_impl_t_OffsetToPointer(This, u) \
	  treedb_allocator_t_OffsetToPointer((This)->m_pAllocator, u)
	#define treedb_list_impl_t_PointerPack(This, p) \
	  treedb_allocator_t_PointerPack((This)->m_pAllocator, p)
	#define treedb_list_impl_t_PointerUnpack(This, u) \
	  treedb_allocator_t_PointerUnpack((This)->m_pAllocator, u)

/* Allocator convenience handle macros -------------------------------------- */
	#define treedb_list_impl_t_Read(This, hloc) \
	  treedb_allocator_t_Read((This)->m_pAllocator, hloc)
	#define treedb_list_impl_t_Write(This, hloc, hvalue) \
	  treedb_allocator_t_Write((This)->m_pAllocator, hloc, hvalue)
	#define treedb_list_impl_t_PointerRead(This, hloc) \
	  treedb_allocator_t_PointerRead((This)->m_pAllocator, hloc)
	#define treedb_list_impl_t_PointerWrite(This, hloc, pv) \
	  treedb_allocator_t_PointerWrite((This)->m_pAllocator, hloc, pv)
	#define treedb_list_impl_t_PointerAddTo(This, hloc, u) \
	  treedb_allocator_t_PointerAddTo((This)->m_pAllocator, hloc, u)

/* Allocator convenience pointer macros ------------------------------------- */
	#define treedb_list_impl_t_ReadPtr(This, pv) \
	  treedb_allocator_t_ReadPtr((This)->m_pAllocator, p)
	#define treedb_list_impl_t_WritePtr(This, pv, hvalue) \
	  treedb_allocator_t_WritePtr((This)->m_pAllocator, pv, hvalue)
	#define treedb_list_impl_t_PointerReadPtr(This, pv) \
	  treedb_allocator_t_PointerReadPtr((This)->m_pAllocator, pv)
	#define treedb_list_impl_t_PointerWritePtr(This, pv, pvvalue) \
	  treedb_allocator_t_PointerWritePtr((This)->m_pAllocator, pv, pvvalue)
	#define treedb_list_impl_t_PointerAddToPtr(This, pv, u) \
	  treedb_allocator_t_PointerAddToPtr((This)->m_pAllocator, pv, u)

/* Backend convenience macros ----------------------------------------------- */

	#define treedb_list_impl_t_backend_AllocNode(This, pv) \
	  treedb_list_backend_t_AllocNode((This)->m_pBackend, This, pv)
	#define treedb_list_impl_t_backend_FreeNode(This, pv) \
	  treedb_meta_list_backend_t_FreeNode((This)->m_pBackend, This, pv)

	#define treedb_list_impl_t_offset_size(This) \
	  (This)->m_pDescription.m_pointer.m_uSize
	#define treedb_list_impl_t_offset_alignment(This) \
	  (This)->m_pDescription.m_pointer.m_uAlign

	#define treedb_list_impl_t_root_size(This) \
	  (This)->m_pDescription.m_root.m_uSize
	#define treedb_list_impl_t_root_alignment(This) \
	  (This)->m_pDescription.m_root.m_uAlign

	#define treedb_list_impl_t_node_size(This) \
	  (This)->m_pDescription->m_node.m_uSize
	#define treedb_list_impl_t_aligned_node_size(This) \
	  (This)->m_pDescription->m_aligned_node_size
	#define treedb_list_impl_t_node_alignment(This) \
	  (This)->m_pDescription->m_node.m_uAlign

	#define treedb_list_impl_t_is_pointer(This) \
	  ((This)->m_flags & eTreedbContainerIsPointer)
	#define treedb_list_impl_t_is_offset(This) \
	  (!treedb_list_impl_t_is_pointer(This))

	#define treedb_list_impl_t_has_count(This) \
	  ((This)->m_flags & eTreedbContainerHasCount)

  #endif /* #ifdef COBJMACROS */

  #define treedb_list_impl_vtbl_t_entries_default(Prefix) \
	  & Prefix##Init \
	, & Prefix##Clear \
	, & Prefix##Alloc \
	, & Prefix##Free \
	, & Prefix##Count \
	, & Prefix##PushFront \
	, & Prefix##PushBack \
	, & Prefix##RemoveNodes \
	, & Prefix##RemoveMany \
	, & Prefix##Remove \
	, & Prefix##PopFront \
	, & Prefix##PopFrontMany \
	, & Prefix##PopBack \
	, & Prefix##PopBackMany \
	, & Prefix##ReverseSome \
	, & Prefix##Reverse \
	\
	, & Prefix##Head \
	, & Prefix##Tail \
	, & Prefix##PointerHead \
	, & Prefix##PointerTail \
	\
	, & Prefix##PushFrontNode \
	, & Prefix##PushBackNode \
	, & Prefix##InsertNodeBefore \
	, & Prefix##InsertNodeAfter \
	, & Prefix##RelinkNode \
	, & Prefix##UnlinkNode \
	, & Prefix##DeleteNode \
	, & Prefix##NodeHasNext \
	, & Prefix##NodeNext \
	, & Prefix##PointerNodeNext \
	, & Prefix##NodeHasPrev \
	, & Prefix##NodePrev \
	, & Prefix##PointerNodePrev \
	\
	, & Prefix##PushFrontNodePtr \
	, & Prefix##PushBackNodePtr \
	, & Prefix##InsertNodeBeforePtr \
	, & Prefix##InsertNodeAfterPtr \
	, & Prefix##RelinkNodePtr \
	, & Prefix##UnlinkNodePtr \
	, & Prefix##DeleteNodePtr \
	, & Prefix##NodeHasNextPtr \
	, & Prefix##NodeNextPtr \
	, & Prefix##PointerNodeNextPtr \
	, & Prefix##NodeHasPrevPtr \
	, & Prefix##NodePrevPtr \
	, & Prefix##PointerNodePrevPtr

  #ifndef treedb_list_impl_vtbl_t_entries
	#define treedb_list_impl_vtbl_t_entries(x) \
	  treedb_list_impl_vtbl_t_entries_default(x)
  #endif

  #define treedb_list_impl_t_members \
	treedb_allocator_ptr_t m_pAllocator; \
	treedb_list_backend_ptr_t m_pBackend; \
	TreedbItemDescriptionConstPtr m_pDescription

  #define c_treedb_list_impl_t_members(vtbl_ptr_t) \
	vtbl_ptr_t m_pVtbl; \
	treedb_list_impl_t_members

  #ifndef MetaTreedb_treedb_list_impl_t_DEFINED
	#define MetaTreedb_treedb_list_impl_t_DEFINED

	#ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
struct treedb_list_impl_vtbl_t
{
	treedb_list_impl_t_methods(,,treedb_list_runtime_t);
};
	#ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_list_impl_t
{
	c_treedb_list_impl_t_members(treedb_list_impl_vtbl_ptr_t);
};

  #endif /* #ifndef MetaTreedb_treedb_list_impl_t_DEFINED */

extern void treedb_list_impl_t_Setup
( treedb_list_impl_ptr_t pm
, treedb_allocator_on_storage_ptr_t pa
, treedb_list_backend_ptr_t pb
, TreedbItemDescription * pd
, treedb_const_list_impl_ptr_t ptemplate
);

/******************************************************************************/
/* treedb_list_t                                                            */
/******************************************************************************/
  #define TREEDB_IList_DELEGATE_TO(x) \
inline void STDCALL \
	Init \
	() { V3C_DELEGATE(x, Init(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline void STDCALL \
	Clear \
	() { V3C_DELEGATE(x, Clear(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline uint64_t STDCALL \
	Count \
	() { return V3C_DELEGATE(x, Count(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline HTREEDB_LISTNODE STDCALL \
	PushFront \
	( HTREEDB_LISTDATA pd \
	) { return V3C_DELEGATE(x, PushFront(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pd)); } \
inline HTREEDB_LISTNODE STDCALL \
	PushBack \
	( HTREEDB_LISTDATA pd \
	) { return V3C_DELEGATE(x, PushBack(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pd)); } \
inline BOOL STDCALL \
	RemoveNodes \
	( HTREEDB_LISTNODE hstart \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, RemoveNodes(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hstart, count)); } \
inline BOOL STDCALL \
	RemoveMany \
	( uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, RemoveMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where, count)); } \
inline BOOL STDCALL \
	Remove \
	( uintptr_t where \
	) { return V3C_DELEGATE(x, Remove(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where)); } \
inline BOOL STDCALL \
	PopFront \
	() { return V3C_DELEGATE(x, PopFront(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline BOOL STDCALL \
	PopFrontMany \
	( uintptr_t count \
	) { return V3C_DELEGATE(x, PopFrontMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, count)); } \
inline BOOL STDCALL \
	PopBack \
	() { return V3C_DELEGATE(x, PopBack(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline BOOL STDCALL \
	PopBackMany \
	( uintptr_t count \
	) { return V3C_DELEGATE(x, PopBackMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, count)); } \
inline BOOL STDCALL \
	ReverseSome \
	( uintptr_t where \
	, uintptr_t count \
	) { return V3C_DELEGATE(x, ReverseSome(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, where, count)); } \
inline void STDCALL \
	Reverse \
	() { V3C_DELEGATE(x, Reverse(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline HTREEDB_LISTNODE STDCALL \
	Head \
	() { return V3C_DELEGATE(x, Head(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline HTREEDB_LISTNODE STDCALL \
	Tail \
	() { return V3C_DELEGATE(x, Tail(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline PVOID STDCALL \
	PointerHead \
	() { return V3C_DELEGATE(x, PointerHead(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline PVOID STDCALL \
	PointerTail \
	() { return V3C_DELEGATE(x, PointerTail(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
\
/* "Handle" methods */ \
\
inline HTREEDB_LISTNODE STDCALL \
	PushFrontNode \
	( HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, PushFrontNode(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hn)); } \
inline HTREEDB_LISTNODE STDCALL \
	PushBackNode \
	( HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, PushBackNode(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hn)); } \
inline void STDCALL \
	InsertNodeBefore \
	( HTREEDB_LISTNODE hn \
	, HTREEDB_LISTNODE hn_new \
	) { V3C_DELEGATE(x, InsertNodeBefore(DGTHIS(x) DGTHIS_MEM(x, m_handle), hn \
		, hn_new)); } \
inline void STDCALL \
	InsertNodeAfter \
	( HTREEDB_LISTNODE hn \
	, HTREEDB_LISTNODE hn_new \
	) { V3C_DELEGATE(x, InsertNodeAfter(DGTHIS(x) DGTHIS_MEM(x, m_handle), hn \
		, hn_new)); } \
inline void STDCALL \
	RelinkNode \
	( HTREEDB_LISTNODE hn \
	) { V3C_DELEGATE(x, RelinkNode(DGTHIS(x) DGTHIS_MEM(x, m_handle), hn)); } \
inline void STDCALL \
	UnlinkNode \
	( HTREEDB_LISTNODE hn \
	) { V3C_DELEGATE(x, UnlinkNode(DGTHIS(x) DGTHIS_MEM(x, m_handle), hn)); } \
inline void STDCALL \
	DeleteNode \
	( HTREEDB_LISTNODE hn \
	) { V3C_DELEGATE(x, DeleteNode(DGTHIS(x) DGTHIS_MEM(x, m_handle), hn)); } \
inline BOOL STDCALL \
	NodeHasNext \
	( HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, NodeHasNext(DGTHIS(x) hn)); } \
inline HTREEDB_LISTNODE STDCALL \
	NodeNext \
	( HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, NodeNext(DGTHIS(x) hn)); } \
inline PVOID STDCALL \
	PointerNodeNext \
	( HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, PointerNodeNext(DGTHIS(x) hn)); } \
inline BOOL STDCALL \
	NodeHasPrev \
	( HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, NodeHasPrev(DGTHIS(x) hn)); } \
inline HTREEDB_LISTNODE STDCALL \
	NodePrev \
	( HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, NodePrev(DGTHIS(x) hn)); } \
inline PVOID STDCALL \
	PointerNodePrev \
	( HTREEDB_LISTNODE hn \
	) { return V3C_DELEGATE(x, PointerNodePrev(DGTHIS(x) hn)); } \
\
/* "Pointer" methods */ \
\
inline PVOID STDCALL \
	PushFrontNodePtr \
	( PVOID pn \
	) { return V3C_DELEGATE(x, PushFrontNodePtr(DGTHIS(x) \
		DGTHIS_MEM(x, m_handle), pn)); } \
inline PVOID STDCALL \
	PushBackNodePtr \
	( PVOID pn \
	) { return V3C_DELEGATE(x, PushBackNodePtr(DGTHIS(x) \
		DGTHIS_MEM(x, m_handle), pn)); } \
inline void STDCALL \
	InsertNodeBeforePtr \
	( PVOID pn \
	, PVOID pn_new \
	) { V3C_DELEGATE(x, InsertNodeBeforePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pn, pn_new)); } \
inline void STDCALL \
	InsertNodeAfterPtr \
	( PVOID pn \
	, PVOID pn_new \
	) { V3C_DELEGATE(x, InsertNodeAfterPtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pn, pn_new)); } \
inline void STDCALL \
	RelinkNodePtr \
	( PVOID pn \
	) { V3C_DELEGATE(x, RelinkNodePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pn)); } \
inline void STDCALL \
	UnlinkNodePtr \
	( PVOID pn \
	) { V3C_DELEGATE(x, UnlinkNodePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pn)); } \
inline void STDCALL \
	DeleteNodePtr \
	( PVOID pn \
	) { V3C_DELEGATE(x, DeleteNodePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pn)); } \
inline BOOL STDCALL \
	NodeHasNextPtr \
	( PVOID pn \
	) { return V3C_DELEGATE(x, NodeHasNextPtr(DGTHIS(x) pn)); } \
inline HTREEDB_LISTNODE STDCALL \
	NodeNextPtr \
	( PVOID pn \
	) { return V3C_DELEGATE(x, NodeNextPtr(DGTHIS(x) pn)); } \
inline PVOID STDCALL \
	PointerNodeNextPtr \
	( PVOID pn \
	) { return V3C_DELEGATE(x, PointerNodeNextPtr(DGTHIS(x) pn)); } \
inline BOOL STDCALL \
	NodeHasPrevPtr \
	( PVOID pn \
	) { return V3C_DELEGATE(x, NodeHasPrevPtr(DGTHIS(x) pn)); } \
inline HTREEDB_LISTNODE STDCALL \
	NodePrevPtr \
	( PVOID pn \
	) { return V3C_DELEGATE(x, NodePrevPtr(DGTHIS(x) pn)); } \
inline PVOID STDCALL \
	PointerNodePrevPtr \
	( PVOID pn \
	) { return V3C_DELEGATE(x, PointerNodePrevPtr(DGTHIS(x) pn)); }

struct treedb_list_t {
	treedb_list_impl_ptr_t m_pImpl;
	HTREEDB_LIST m_handle;
};

static inline
treedb_list_runtime_ptr_t
treedb_list_t_to_runtime(treedb_list_ptr_t p)
{
	return (treedb_list_runtime_ptr_t)p;
}

extern
void treedb_list_t_Setup
( treedb_list_ptr_t p
, treedb_list_impl_ptr_t pImpl
, size_t uPayload
);

  #ifdef COBJMACROS

	#define treedb_list_t_Init(This) \
	  treedb_list_impl_t_Init(treedb_list_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_list_t_Clear(This) \
	  treedb_list_impl_t_Clear(treedb_list_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_list_t_Count(This) \
	  treedb_list_impl_t_Count(treedb_list_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_list_t_PushFront(This, pv) \
	  treedb_list_impl_t_PushFront(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pv)
	#define treedb_list_t_PushBack(This, pv) \
	  treedb_list_impl_t_PushBack(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pv)
	#define treedb_list_t_RemoveNodes(This, start, count) \
	  treedb_list_impl_t_RemoveNodes(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, start, count)
	#define treedb_list_t_RemoveMany(This, where, count) \
	  treedb_list_impl_t_RemoveMany(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, where, count)
	#define treedb_list_t_Remove(This, where) \
	  treedb_list_impl_t_Remove(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, where)
	#define treedb_list_t_PopFront(This) \
	  treedb_list_impl_t_PopFront(treedb_list_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_list_t_PopFrontMany(This, count) \
	  treedb_list_impl_t_PopFrontMany(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, count)
	#define treedb_list_t_PopBack(This) \
	  treedb_list_impl_t_PopBack(treedb_list_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_list_t_PopBackMany(This, count) \
	  treedb_list_impl_t_PopBackMany(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, count)
	#define treedb_list_t_ReverseSome(This, where, count) \
	  treedb_list_impl_t_ReverseSome(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, where, count)
	#define treedb_list_t_Reverse(This) \
	  treedb_list_impl_t_Reverse(treedb_list_t_to_runtime(This) \
		, (This)->m_handle)

	#define treedb_list_t_Head(This) \
	  treedb_list_impl_t_Head(treedb_list_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_list_t_Tail(This) \
	  treedb_list_impl_t_Tail(treedb_list_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_list_t_PointerHead(This) \
	  treedb_list_impl_t_PointerHead(treedb_list_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_list_t_PointerTail(This) \
	  treedb_list_impl_t_PointerTail(treedb_list_t_to_runtime(This) \
		, (This)->m_handle)

/* "Handle" macros ---------------------------------------------------------- */
	#define treedb_list_t_PushFrontNode(This, hnode) \
	  treedb_list_impl_t_PushFrontNode(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, hnode)
	#define treedb_list_t_PushBackNode(This, hnode) \
	  treedb_list_impl_t_PushBackNode(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, hnode)
	#define treedb_list_t_InsertBefore(This, hnode, hnode_new) \
	  treedb_list_impl_t_InsertBefore((treedb_list_t_to_runtime(This) \
		, (This)->m_handle, hnode, hnode_new)
	#define treedb_list_t_InsertAfter(This, hnode, hnode_new) \
	  treedb_list_impl_t_InsertAfter(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, hnode, hnode_new)
	#define treedb_list_t_RelinkNode(This, hnode) \
	  treedb_list_impl_t_RelinkNode(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, hnode)
	#define treedb_list_t_UnlinkNode(This, hnode) \
	  treedb_list_impl_t_UnlinkNode(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, hnode)
	#define treedb_list_t_DeleteNode(This, hnode) \
	  treedb_list_impl_t_DeleteNode(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, hnode)
	#define treedb_list_t_NodeHasNext(This, hnode) \
	  treedb_list_impl_t_NodeHasNext(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, hnode)
	#define treedb_list_t_NodeNext(This, hnode) \
	  treedb_list_impl_t_NodeNext(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, hnode)
	#define treedb_list_t_PointerNodeNext(This, hnode) \
	  treedb_list_impl_t_PointerNodeNext(treedb_list_t_to_runtime(This) \
		, hnode)
	#define treedb_list_t_NodeHasPrev(This, hnode) \
	  treedb_list_impl_t_NodeHasPrev(treedb_list_t_to_runtime(This) \
		, hnode)
	#define treedb_list_t_NodePrev(This, hnode) \
	  treedb_list_impl_t_NodePrev(treedb_list_t_to_runtime(This) \
		, hnode)
	#define treedb_list_t_PointerNodePrev(This, hnode) \
	  treedb_list_impl_t_PointerNodePrev(treedb_list_t_to_runtime(This) \
		, hnode)

	#define treedb_list_t_NodeToData(This, hnode) \
	  (hnode + (This)->m_pImpl->m_pDescription->m_aligned_node_size)
	#define treedb_list_t_DataToNode(This, h) \
	  (h - (This)->m_pImpl->m_pDescription->m_aligned_node_size)

/* "Pointer" macros --------------------------------------------------------  */
	#define treedb_list_t_PushFrontNodePtr(This, pn) \
	  treedb_list_impl_t_PushFrontNodePtr(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pn)
	#define treedb_list_t_PushBackNodePtr(This, pn) \
	  treedb_list_impl_t_PushBackNodePtr(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pn)
	#define treedb_list_t_InsertBeforePtr(This, pn, pn_new) \
	  treedb_list_impl_t_InsertBeforePtr(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pn, pn_new)
	#define treedb_list_t_InsertAfterPtr(This, pn, pn_new) \
	  treedb_list_impl_t_InsertAfterPtr(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pn, pn_new)
	#define treedb_list_t_RelinkNodePtr(This, pn) \
	  treedb_list_impl_t_RelinkNodePtr(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pn)
	#define treedb_list_t_UnlinkNodePtr(This, pv) \
	  treedb_list_impl_t_UnlinkNodePtr(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pv)
	#define treedb_list_t_DeleteNodePtr(This, pv) \
	  treedb_list_impl_t_DeleteNodePtr(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pv)
	#define treedb_list_t_NodeHasNextPtr(This, pn) \
	  treedb_list_impl_t_NodeHasNextPtr(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pn)
	#define treedb_list_t_NodeNextPtr(This, pn) \
	  treedb_list_impl_t_NodeNextPtr(treedb_list_t_to_runtime(This) \
		, (This)->m_handle, pn)
	#define treedb_list_t_PointerNodeNextPtr(This, pn) \
	  treedb_list_impl_t_PointerNodeNextPtr(treedb_list_t_to_runtime(This) \
		, pn)
	#define treedb_list_t_NodeHasPrevPtr(This, pn) \
	  treedb_list_impl_t_NodeHasPrevPtr(treedb_list_t_to_runtime(This), pn)
	#define treedb_list_t_NodePrevPtr(This, pn) \
	  treedb_list_impl_t_NodePrevPtr(treedb_list_t_to_runtime(This), pn)
	#define treedb_list_t_PointerNodePrevPtr(This, pn) \
	  treedb_list_impl_t_PointerNodePrevPtr(treedb_list_t_to_runtime(This) \
		, pn)

	#define treedb_list_t_NodeToDataPtr(This, p) \
	  ((char *)(p) + (This)->m_pImpl->m_pDescription->m_aligned_node_size)
	#define treedb_list_t_DataToNodePtr(This, p) \
	  ((char *)(p) - (This)->m_pImpl->m_pDescription->m_aligned_node_size)

/* Allocator convenience macros --------------------------------------------- */
	#define treedb_list_t_PointerToOffset(This, u) \
	  treedb_allocator_t_PointerToOffset((This)->m_pImpl->m_pAllocator, u)
	#define treedb_list_t_OffsetToPointer(This, u) \
	  treedb_allocator_t_OffsetToPointer((This)->m_pImpl->m_pAllocator, u)
	#define treedb_list_t_PointerPack(This, p) \
	  treedb_allocator_t_PointerPack((This)->m_pImpl->m_pAllocator, p)
	#define treedb_list_t_PointerUnpack(This, u) \
	  treedb_allocator_t_PointerUnpack((This)->m_pImpl->m_pAllocator, u)

/* Allocator convenience handle macros -------------------------------------- */
	#define treedb_list_t_Read(This, hloc) \
	  treedb_allocator_t_Read((This)->m_pImpl->m_pAllocator, hloc)
	#define treedb_list_t_Write(This, hloc, hvalue) \
	  treedb_allocator_t_Write((This)->m_pImpl->m_pAllocator, hloc, hvalue)
	#define treedb_list_t_PointerRead(This, hloc) \
	  treedb_allocator_t_PointerRead((This)->m_pImpl->m_pAllocator, hloc)
	#define treedb_list_t_PointerWrite(This, hloc, pv) \
	  treedb_allocator_t_PointerWrite((This)->m_pImpl->m_pAllocator, hloc, pv)
	#define treedb_list_t_PointerAddTo(This, hloc, u) \
	  treedb_allocator_t_PointerAddTo((This)->m_pImpl->m_pAllocator, hloc, u)

/* Allocator convenience pointer macros ------------------------------------- */
	#define treedb_list_t_ReadPtr(This, pv) \
	  treedb_allocator_t_ReadPtr((This)->m_pImpl->m_pAllocator, p)
	#define treedb_list_t_WritePtr(This, pv, hvalue) \
	  treedb_allocator_t_WritePtr((This)->m_pImpl->m_pAllocator, pv, hvalue)
	#define treedb_list_t_PointerReadPtr(This, pv) \
	  treedb_allocator_t_PointerReadPtr((This)->m_pImpl->m_pAllocator, pv)
	#define treedb_list_t_PointerWritePtr(This, pv, pvvalue) \
	  treedb_allocator_t_PointerWritePtr((This)->m_pImpl->m_pAllocator, pv \
		, pvvalue)
	#define treedb_list_t_PointerAddToPtr(This, pv, u) \
	  treedb_allocator_t_PointerAddToPtr((This)->m_pImpl->m_pAllocator, pv, u)

/* Backend convenience handle macros ---------------------------------------- */
	#define treedb_list_t_backend_AllocNode(This, pv) \
	  treedb_list_backend_t_AllocNode((This)->m_pImpl->m_pBackend \
		, treedb_list_t_to_runtime(This), pv)
	#define treedb_list_t_backend_FreeNode(This, pv) \
	  treedb_meta_list_backend_t_FreeNode((This)->m_pImpl->m_pBackend \
		, treedb_list_t_to_runtime(This), pv)

/* More convenience macros -------------------------------------------------- */
	#define treedb_list_t_offset_size(This) \
	  (This)->m_pImpl->m_pDescription.m_pointer.m_uSize
	#define treedb_list_t_offset_alignment(This) \
	  (This)->m_pImpl->m_pDescription.m_pointer.m_uAlign

	#define treedb_list_t_root_size(This) \
	  (This)->m_pImpl->m_pDescription.m_root.m_uSize
	#define treedb_list_t_root_alignment(This) \
	  (This)->m_pImpl->m_pDescription.m_root.m_uAlign

	#define treedb_list_t_node_size(This) \
	  (This)->m_pImpl->m_pDescription->m_node.m_uSize
	#define treedb_list_t_aligned_node_size(This) \
	  (This)->m_pImpl->m_pDescription->m_aligned_node_size
	#define treedb_list_t_node_alignment(This) \
	  (This)->m_pImpl->m_pDescription->m_node.m_uAlign

	#define treedb_list_t_is_pointer(This) \
	  ((This)->m_pImpl->m_flags & eTreedbContainerIsPointer)
	#define treedb_list_t_is_offset(This) \
	  (!treedb_list_t_is_pointer(This))

	#define treedb_list_t_has_count(This) \
	  ((This)->m_pImpl->m_flags & eTreedbContainerHasCount)

  #endif /* #ifdef COBJMACROS */

/******************************************************************************/
/* treedb_list_backend_t                                                    */
/******************************************************************************/
extern void treedb_list_backend_t_Setup
( treedb_list_backend_ptr_t pb
, PVOID pVtbl
);
  #define treedb_list_backend_t_methods(Imp, Prefix, Class, Runtime) \
	STDMETHOD##Imp##_(PVOID, Prefix##AllocNode) \
		( THIS(Class) \
		  Runtime * /*runtime*/ \
		, HTREEDB_LISTDATA /*pv*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##FreeNode) \
		( THIS(Class) \
		  Runtime * /*runtime*/ \
		, PVOID /*pv*/ \
		) PURE

  #ifdef COBJMACROS

	#define treedb_list_backend_t_AllocNode(This, lh, pv) \
	  V3C_IFACE_CALL(AllocNode, This, lh, pv)
	#define treedb_list_backend_t_FreeNode(This, lh, pv) \
	  V3C_IFACE_CALL(FreeNode, This, lh, pv)

  #endif /* #ifdef COBJMACROS */

  #define treedb_list_backend_vtbl_t_entries_default(Prefix) \
	  & Prefix##AllocNode \
	, & Prefix##FreeNode

  #ifndef treedb_list_backend_vtbl_t_entries
	#define treedb_list_backend_vtbl_t_entries(x) \
	  treedb_list_backend_vtbl_t_entries_default(x)
  #endif

  #define treedb_list_backend_t_members(vtbl_ptr_t) \
	vtbl_ptr_t m_pVtbl

  #ifndef MetaTreedb_treedb_list_backend_t_DEFINED
	#define MetaTreedb_treedb_list_backend_t_DEFINED

    #ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
struct treedb_list_backend_vtbl_t
{
	treedb_list_backend_t_methods(,,treedb_list_backend_t
		, treedb_list_runtime_t);
};
    #ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_list_backend_t
{
	treedb_list_backend_t_members(treedb_list_backend_vtbl_ptr_t);
};

  #endif /* #ifndef MetaTreedb_treedb_list_backend_t_DEFINED */

extern treedb_const_list_ptr_t
treedb_get_list_template_for
( int16_t uBytesPerOffset /* 2, 4, 8 */
, uint16_t flags
);

extern treedb_const_list_ptr_t
treedb_get_list_template_using_allocator
( treedb_allocator_ptr_t pallocator
);

  #ifdef __cplusplus
} // extern "C" {
  #endif /* #ifdef __cplusplus */

#endif /* #ifndef v3c_meta_treedb_list_h_included */
