/* Copyright (C) 2010  Philip Ashmore (contact@philipashmore.com)             */
/* License: LGPLv3.  See LICENSE.txt for the full license.                    */

#ifndef v3c_meta_treedb_h_included
  #include "meta-treedb.h"
#endif

#ifndef v3c_meta_treedb_tree_h_included
  #define v3c_meta_treedb_tree_h_included

  #include <v3c/tree-printer.h>

  #ifdef __cplusplus
extern "C" {
  #endif

/******************************************************************************/
/* Delegates                                                                  */
/******************************************************************************/
  #define TREEDB_ITree_DELEGATE_TO(x) \
inline void STDCALL \
	Clear \
	() { V3C_DELEGATE(x, Clear(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline bool STDCALL \
	Clone \
	(HTREEDB_TREE ht_from \
	) { return V3C_DELEGATE(x, Clone(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, ht_from)); } \
inline uintptr_t STDCALL \
	Count \
	() { return V3C_DELEGATE(x, Count(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline TreedbInsertResult STDCALL \
	Insert \
	( HTREEDB_TREEKEY hkey \
	, PVOID * ppn \
	) { return V3C_DELEGATE(x, Insert(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey, ppn)); } \
inline BOOL STDCALL \
	Remove \
	( HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, Remove(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey)); } \
inline BOOL STDCALL \
	RemoveBetween \
	( HTREEDB_TREENODE hn_lower \
	, HTREEDB_TREENODE hn_upper \
	, TreedbNodeDistanceFlags flags \
	) { return V3C_DELEGATE(x, RemoveBetween(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hn_lower, hn_upper, flags)); } \
inline BOOL STDCALL \
	RemoveMany \
	( HTREEDB_TREEKEY hk_lower \
	, HTREEDB_TREEKEY hk_upper \
	, TreedbKeyDistanceFlags flags \
	) { return V3C_DELEGATE(x, RemoveMany(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hk_lower, hk_upper, flags)); } \
inline intptr_t STDCALL \
	NodeDistance \
	( HTREEDB_TREENODE hlower \
	, HTREEDB_TREENODE hupper \
	, TreedbNodeDistanceFlags flags \
	) { return V3C_DELEGATE(x, NodeDistance(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hlower, hupper, flags)); } \
inline intptr_t STDCALL \
	KeyDistance \
	( HTREEDB_TREEKEY hk_lower \
	, HTREEDB_TREEKEY hk_upper \
	, TreedbKeyDistanceFlags flags \
	, intptr_t * pres \
	) { return V3C_DELEGATE(x, KeyDistance(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hk_lower, hk_upper, flags, pres)); } \
inline void STDCALL \
	Dump \
	( treedb_tree_renderer_ptr_t pr \
	, treedb_tree_data_renderer_ptr_t pd \
	) { V3C_DELEGATE(x, Dump(DGTHIS(x) DGTHIS_MEM(x, m_handle), pr, pd)); } \
inline HTREEDB_TREENODE STDCALL \
	Head \
	() { return V3C_DELEGATE(x, Head(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline HTREEDB_TREENODE STDCALL \
	Tail \
	() { return V3C_DELEGATE(x, Tail(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline HTREEDB_TREENODE STDCALL \
	Top \
	() { return V3C_DELEGATE(x, Top(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline HTREEDB_TREENODE STDCALL \
	Index \
	( uintptr_t u \
	) { return V3C_DELEGATE(x, Index(DGTHIS(x) DGTHIS_MEM(x, m_handle), u)); } \
inline PVOID STDCALL \
	PointerHead \
	() { return V3C_DELEGATE(x, PointerHead(DGTHIS(x) \
		DGTHIS_MEM(x, m_handle))); } \
inline PVOID STDCALL \
	PointerTail \
	() { return V3C_DELEGATE(x, PointerTail(DGTHIS(x) \
		DGTHIS_MEM(x, m_handle))); } \
inline PVOID STDCALL \
	PointerTop \
	() { return V3C_DELEGATE(x, PointerTop(DGTHIS(x) \
		DGTHIS_MEM(x, m_handle))); } \
inline PVOID STDCALL \
	PointerIndex \
	( uintptr_t u \
	) { return V3C_DELEGATE(x, PointerIndex(DGTHIS(x) \
		DGTHIS_MEM(x, m_handle), u)); } \
\
/* "Handle" methods */ \
\
inline void STDCALL \
	Init \
	() { V3C_DELEGATE(x, Init(DGTHIS(x) DGTHIS_MEM(x, m_handle))); } \
inline void STDCALL \
	DumpNode \
	( treedb_tree_renderer_ptr_t pr \
	, treedb_tree_data_renderer_ptr_t pd \
	, HTREEDB_TREENODE pn \
	) { return V3C_DELEGATE(x, DumpNode(DGTHIS(x) pn, pr, pd)); } \
inline bool STDCALL \
	InsertNode \
	( HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, InsertNode(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hn)); } \
inline void STDCALL \
	InsertNodeBefore \
	( HTREEDB_TREENODE hn_ref \
	, HTREEDB_TREENODE hn \
	) { V3C_DELEGATE(x, InsertNodeBefore(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hn_ref, hn)); } \
inline void STDCALL \
	InsertNodeAfter \
	( HTREEDB_TREENODE hn_ref \
	, HTREEDB_TREENODE hn \
	) { V3C_DELEGATE(x, InsertNodeAfter(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hn_ref, hn)); } \
inline void STDCALL \
	RelinkNode \
	( HTREEDB_TREENODE hn \
	) { V3C_DELEGATE(x, RelinkNode(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hn)); } \
inline void STDCALL \
	UnlinkNode \
	( HTREEDB_TREENODE hn \
	) { V3C_DELEGATE(x, UnlinkNode(DGTHIS(x) DGTHIS_MEM(x, m_handle), hn)); } \
inline void STDCALL \
	DeleteNode \
	( HTREEDB_TREENODE hn \
	) { V3C_DELEGATE(x, DeleteNode(DGTHIS(x) DGTHIS_MEM(x, m_handle), hn)); } \
inline TreedbSearchResult STDCALL \
	SearchClosest \
	( HTREEDB_TREEKEY hkey \
	, HTREEDB_TREENODE * phn \
	) { return V3C_DELEGATE(x, SearchClosest(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey, phn)); } \
inline TreedbSearchResult STDCALL \
	SearchLe \
	( HTREEDB_TREEKEY hkey \
	, HTREEDB_TREENODE * phn \
	) { return V3C_DELEGATE(x, SearchLe(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey, phn)); } \
inline TreedbSearchResult STDCALL \
	SearchGe \
	( HTREEDB_TREEKEY hkey \
	, HTREEDB_TREENODE * phn \
	) { return V3C_DELEGATE(x, SearchGe(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey, phn)); } \
inline HTREEDB_TREENODE STDCALL \
	Search \
	( HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, Search(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey)); } \
inline HTREEDB_TREENODE STDCALL \
	SearchLt \
	( HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, SearchLt(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey)); } \
inline HTREEDB_TREENODE STDCALL \
	SearchGt \
	( HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, SearchGt(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey)); } \
inline BOOL STDCALL \
	NodeHasNext \
	( HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodeHasNext(DGTHIS(x) hn)); } \
inline HTREEDB_TREENODE STDCALL \
	NodeNext \
	( HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodeNext(DGTHIS(x) hn)); } \
inline PVOID STDCALL \
	PointerNodeNext \
	( HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, PointerNodeNext(DGTHIS(x) hn)); } \
inline BOOL STDCALL \
	NodeHasPrev \
	( HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodeHasPrev(DGTHIS(x) hn)); } \
inline HTREEDB_TREENODE STDCALL \
	NodePrev \
	( HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodePrev(DGTHIS(x) hn)); } \
inline PVOID STDCALL \
	PointerNodePrev \
	( HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, PointerNodePrev(DGTHIS(x) hn)); } \
inline uintptr_t STDCALL \
	NodeIndex \
	( HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodeIndex(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hn)); } \
inline HTREEDB_TREENODE STDCALL \
	NodeAtIndex \
	( HTREEDB_TREENODE hn \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, NodeAtIndex(DGTHIS(x) hn, u)); } \
inline PVOID STDCALL \
	PointerNodeAtIndex \
	( HTREEDB_TREENODE hn \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, PointerNodeAtIndex(DGTHIS(x) hn, u)); } \
inline uintptr_t STDCALL \
	NodeCount \
	( HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodeCount(DGTHIS(x) hn)); } \
\
/* "Pointer" methods */ \
\
inline void STDCALL \
	DumpNodePtr \
	( PCVOID pn \
	, treedb_tree_renderer_ptr_t pr \
	, treedb_tree_data_renderer_ptr_t pd \
	) { V3C_DELEGATE(x, DumpNodePtr(DGTHIS(x) pn, pr, pd)); } \
inline bool STDCALL \
	InsertNodePtr \
	( PVOID pn \
	) { return V3C_DELEGATE(x, InsertNodePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pn)); } \
inline void STDCALL \
	InsertNodeBeforePtr \
	( PVOID pn \
	, PVOID pn_new \
	) { V3C_DELEGATE(x, InsertNodeBeforePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pn, pn_new)); } \
inline void STDCALL \
	InsertNodeAfterPtr \
	( PVOID pn \
	, PVOID pn_new \
	) { V3C_DELEGATE(x, InsertNodeAfterPtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pn, pn_new)); } \
inline void STDCALL \
	RelinkNodePtr \
	( PVOID pn \
	) { V3C_DELEGATE(x, RelinkNodePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pn)); } \
inline void STDCALL \
	UnlinkNodePtr \
	( PVOID pn \
	) { V3C_DELEGATE(x, UnlinkNodePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle), pn)); \
		 } \
inline void STDCALL \
	DeleteNodePtr \
	( PVOID pn \
	) { V3C_DELEGATE(x, DeleteNodePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle), pn)); \
		 } \
\
inline TreedbSearchResult STDCALL \
	SearchClosestPtr \
	( HTREEDB_TREEKEY hkey \
	, PVOID * ppn \
	) { return V3C_DELEGATE(x, SearchClosestPtr(DGTHIS(x) \
		DGTHIS_MEM(x, m_handle), hkey, ppn)); } \
inline TreedbSearchResult STDCALL \
	SearchLePtr \
	( HTREEDB_TREEKEY hkey \
	, PVOID * ppn \
	) { return V3C_DELEGATE(x, SearchLePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey, ppn)); } \
inline TreedbSearchResult STDCALL \
	SearchGePtr \
	( HTREEDB_TREEKEY hkey \
	, PVOID * ppn \
	) { return V3C_DELEGATE(x, SearchGePtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey, ppn)); } \
inline PVOID STDCALL \
	PointerSearch \
	( HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, PointerSearch(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, hkey)); } \
inline PVOID STDCALL \
	PointerSearchLt \
	( HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, PointerSearchLt(DGTHIS(x) \
		DGTHIS_MEM(x, m_handle), hkey)); } \
inline PVOID STDCALL \
	PointerSearchGt \
	( HTREEDB_TREEKEY pkey \
	) { return V3C_DELEGATE(x, PointerSearchGt(DGTHIS(x) \
		DGTHIS_MEM(x, m_handle), pkey)); } \
inline BOOL STDCALL \
	NodeHasNextPtr \
	( PCVOID pn \
	) { return V3C_DELEGATE(x, NodeHasNextPtr(DGTHIS(x) pn)); } \
inline HTREEDB_TREENODE STDCALL \
	NodeNextPtr \
	( PCVOID pn \
	) { return V3C_DELEGATE(x, NodeNextPtr(DGTHIS(x) pn)); } \
inline PVOID STDCALL \
	PointerNodeNextPtr \
	( PCVOID pn \
	) { return V3C_DELEGATE(x, PointerNodeNextPtr(DGTHIS(x) pn)); } \
inline BOOL STDCALL \
	NodeHasPrevPtr \
	( PCVOID pn \
	) { return V3C_DELEGATE(x, NodeHasPrevPtr(DGTHIS(x) pn)); } \
inline HTREEDB_TREENODE STDCALL \
	NodePrevPtr \
	( PCVOID pn \
	) { return V3C_DELEGATE(x, NodePrevPtr(DGTHIS(x) pn)); } \
inline PVOID STDCALL \
	PointerNodePrevPtr \
	( PCVOID pn \
	) { return V3C_DELEGATE(x, PointerNodePrevPtr(DGTHIS(x) pn)); } \
inline uintptr_t STDCALL \
	NodeIndexPtr \
	( PCVOID pn \
	) { return V3C_DELEGATE(x, NodeIndexPtr(DGTHIS(x) DGTHIS_MEM(x, m_handle) \
		, pn)); } \
inline HTREEDB_TREENODE STDCALL \
	NodeAtIndexPtr \
	( PCVOID pn \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, NodeAtIndexPtr(DGTHIS(x) pn, u)); } \
inline PVOID STDCALL \
	PointerNodeAtIndexPtr \
	( PCVOID pn \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, PointerNodeAtIndexPtr(DGTHIS(x) pn, u)); } \
inline uintptr_t STDCALL \
	NodeCountPtr \
	( PCVOID pn \
	) { return V3C_DELEGATE(x, NodeCountPtr(DGTHIS(x) pn)); }

#define TREEDB_ITreeImpl_DELEGATE_TO(x) \
inline void STDCALL \
	Clear \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	) { V3C_DELEGATE(x, Clear(runtime, ht)); } \
inline bool STDCALL \
	Clone \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht_to \
	, HTREEDB_TREE ht_from \
	) { return V3C_DELEGATE(x, Clone(runtime, ht_to, ht_from)); } \
inline HTREEDB_TREE STDCALL \
	Alloc \
	(treedb_tree_runtime_ptr_t runtime \
	) { return V3C_DELEGATE(x, Alloc(runtime)); } \
inline void STDCALL \
	Free \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	) { V3C_DELEGATE(x, Free(runtime, ht)); } \
inline uintptr_t STDCALL \
	Count \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	) { return V3C_DELEGATE(x, Count(runtime, ht)); } \
inline TreedbInsertResult STDCALL \
	Insert \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	, PVOID * ppn \
	) { return V3C_DELEGATE(x, Insert(runtime, ht, hkey, ppn)); } \
inline BOOL STDCALL \
	Remove \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, Remove(runtime, ht, hkey)); } \
inline BOOL STDCALL \
	RemoveBetween \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREENODE hn_lower \
	, HTREEDB_TREENODE hn_upper \
	, TreedbNodeDistanceFlags flags \
	) { return V3C_DELEGATE(x, RemoveBetween(runtime, ht, hn_lower, hn_upper \
		, flags)); } \
inline BOOL STDCALL \
	RemoveMany \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hk_lower \
	, HTREEDB_TREEKEY hk_upper \
	, TreedbKeyDistanceFlags flags \
	) { return V3C_DELEGATE(x, RemoveMany(runtime, ht, hk_lower, hk_upper \
		, flags)); } \
inline intptr_t STDCALL \
	NodeDistance \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREENODE hlower \
	, HTREEDB_TREENODE hupper \
	, TreedbNodeDistanceFlags flags \
	) { return V3C_DELEGATE(x, NodeDistance(runtime, ht, hlower, hupper \
		, flags)); } \
inline BOOL STDCALL \
	KeyDistance \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hk_lower \
	, HTREEDB_TREEKEY hk_upper \
	, TreedbKeyDistanceFlags flags \
	, intptr_t * pres \
	) { return V3C_DELEGATE(x, KeyDistance(runtime, ht, hk_lower, hk_upper \
		, flags, pres)); } \
inline void STDCALL \
	Dump \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, treedb_tree_renderer_ptr_t pr \
	, treedb_tree_data_renderer_ptr_t pd \
	) { V3C_DELEGATE(x, Dump(runtime, ht, pr, pd)); } \
inline HTREEDB_TREENODE STDCALL \
	Head \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	) { return V3C_DELEGATE(x, Head(runtime, ht)); } \
inline HTREEDB_TREENODE STDCALL \
	Tail \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	) { return V3C_DELEGATE(x, Tail(runtime, ht)); } \
inline HTREEDB_TREENODE STDCALL \
	Top \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	) { return V3C_DELEGATE(x, Top(runtime, ht)); } \
inline HTREEDB_TREENODE STDCALL \
	Index \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, Index(runtime, ht, u)); } \
inline PVOID STDCALL \
	PointerHead \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	) { return V3C_DELEGATE(x, PointerHead(runtime, ht)); } \
inline PVOID STDCALL \
	PointerTail \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	) { return V3C_DELEGATE(x, PointerTail(runtime, ht)); } \
inline PVOID STDCALL \
	PointerTop \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	) { return V3C_DELEGATE(x, PointerTop(runtime, ht)); } \
inline PVOID STDCALL \
	PointerIndex \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, PointerIndex(runtime, ht, u)); } \
\
/* "Handle" methods */ \
\
inline void STDCALL \
	Init \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	) { V3C_DELEGATE(x, Init(runtime, ht)); } \
inline void STDCALL \
	DumpNode \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREENODE hn \
	, treedb_tree_renderer_ptr_t pr \
	, treedb_tree_data_renderer_ptr_t pd \
	) { V3C_DELEGATE(x, DumpNode(runtime, hn, pr, pd)); } \
inline bool STDCALL \
	InsertNode \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, InsertNode(runtime, ht, hn)); } \
inline void STDCALL \
	InsertNodeBefore \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREENODE hn_ref \
	, HTREEDB_TREENODE hn \
	) { V3C_DELEGATE(x, InsertNodeBefore(runtime, ht, hn_ref, hn)); } \
inline void STDCALL \
	InsertNodeAfter \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREENODE hn_ref \
	, HTREEDB_TREENODE hn \
	) { V3C_DELEGATE(x, InsertNodeAfter(runtime, ht, hn_ref, hn)); } \
inline void STDCALL \
	RelinkNode \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREENODE hn \
	) { V3C_DELEGATE(x, RelinkNode(runtime, ht, hn)); } \
inline void STDCALL \
	UnlinkNode \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREENODE hn \
	) { V3C_DELEGATE(x, UnlinkNode(runtime, ht, hn)); } \
inline void STDCALL \
	DeleteNode \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREENODE hn \
	) { V3C_DELEGATE(x, DeleteNode(runtime, ht, hn)); } \
\
inline TreedbSearchResult STDCALL \
	SearchClosest \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	, HTREEDB_TREENODE * phn \
	) { return V3C_DELEGATE(x, SearchClosest(runtime, ht, hkey, phn)); } \
inline TreedbSearchResult STDCALL \
	SearchLe \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	, HTREEDB_TREENODE * phn \
	) { return V3C_DELEGATE(x, SearchLe(runtime, ht, hkey, phn)); } \
inline TreedbSearchResult STDCALL \
	SearchGe \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	, HTREEDB_TREENODE * phn \
	) { return V3C_DELEGATE(x, SearchGe(runtime, ht, hkey, phn)); } \
inline HTREEDB_TREENODE STDCALL \
	Search \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, Search(runtime, ht, hkey)); } \
inline HTREEDB_TREENODE STDCALL \
	SearchLt \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, SearchLt(runtime, ht, hkey)); } \
inline HTREEDB_TREENODE STDCALL \
	SearchGt \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, SearchGt(runtime, ht, hkey)); } \
inline BOOL STDCALL NodeHasNext \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodeHasNext(runtime, hn)); } \
inline HTREEDB_TREENODE STDCALL NodeNext \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodeNext(runtime, hn)); } \
inline PVOID STDCALL PointerNodeNext \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, PointerNodeNext(runtime, hn)); } \
inline BOOL STDCALL NodeHasPrev \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodeHasPrev(runtime, hn)); } \
inline HTREEDB_TREENODE STDCALL NodePrev \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodePrev(runtime, hn)); } \
inline PVOID STDCALL PointerNodePrev \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, PointerNodePrev(runtime, hn)); } \
inline uintptr_t STDCALL NodeIndex \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodeIndex(runtime, ht, hn)); } \
inline HTREEDB_TREENODE STDCALL NodeAtIndex \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREENODE hn \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, NodeAtIndex(runtime, hn, u)); } \
inline PVOID STDCALL PointerNodeAtIndex \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREENODE hn \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, PointerNodeAtIndex(runtime, hn, u)); } \
inline uintptr_t STDCALL NodeCount \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREENODE hn \
	) { return V3C_DELEGATE(x, NodeCount(runtime, hn)); } \
\
/* "Pointer" methods */ \
\
inline void STDCALL \
	InitPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PVOID pt \
	) { V3C_DELEGATE(x, InitPtr(runtime, pt)); } \
inline void STDCALL \
	DumpNodePtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PCVOID pn \
	, treedb_tree_renderer_ptr_t pr \
	, treedb_tree_data_renderer_ptr_t pd \
	) { V3C_DELEGATE(x, DumpNodePtr(runtime, pn, pr, pd)); } \
inline bool STDCALL \
	InsertNodePtr \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, PVOID pn \
	) { return V3C_DELEGATE(x, InsertNodePtr(runtime, ht, pn)); } \
inline void STDCALL \
	InsertNodeBeforePtr \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, PVOID pn \
	, PVOID pn_new \
	) { V3C_DELEGATE(x, InsertNodeBeforePtr(runtime, ht, pn, pn_new)); } \
inline void STDCALL \
	InsertNodeAfterPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, PVOID pn \
	, PVOID pn_new \
	) { V3C_DELEGATE(x, InsertNodeAfterPtr(runtime, ht, pn, pn_new)); } \
inline void STDCALL \
	RelinkNodePtr \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, PVOID pn \
	) { V3C_DELEGATE(x, RelinkNodePtr(runtime, ht, pn)); } \
inline void STDCALL \
	UnlinkNodePtr \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, PVOID pn \
	) { V3C_DELEGATE(x, UnlinkNodePtr(runtime, ht, pn)); } \
inline void STDCALL \
	DeleteNodePtr \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, PVOID pn \
	) { V3C_DELEGATE(x, DeleteNodePtr(runtime, ht, pn)); } \
\
inline TreedbSearchResult STDCALL \
	SearchClosestPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	, PVOID * ppn \
	) { return V3C_DELEGATE(x, SearchClosestPtr(runtime, ht, hkey, ppn)); } \
inline TreedbSearchResult STDCALL \
	SearchLePtr \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	, PVOID * ppn \
	) { return V3C_DELEGATE(x, SearchLePtr(runtime, ht, hkey, ppn)); } \
inline TreedbSearchResult STDCALL \
	SearchGePtr \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	, PVOID * ppn \
	) { return V3C_DELEGATE(x, SearchGePtr(runtime, ht, hkey, ppn)); } \
inline PVOID STDCALL \
	PointerSearch \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, PointerSearch(runtime, ht, hkey)); } \
inline PVOID STDCALL \
	PointerSearchLt \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, PointerSearchLt(runtime, ht, hkey)); } \
inline PVOID STDCALL \
	PointerSearchGt \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, HTREEDB_TREEKEY hkey \
	) { return V3C_DELEGATE(x, PointerSearchGt(runtime, ht, hkey)); } \
inline BOOL STDCALL NodeHasNextPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PCVOID pn \
	) { return V3C_DELEGATE(x, NodeHasNextPtr(runtime, pn)); } \
inline HTREEDB_TREENODE STDCALL NodeNextPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PCVOID pn \
	) { return V3C_DELEGATE(x, NodeNextPtr(runtime, pn)); } \
inline PVOID STDCALL PointerNodeNextPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PCVOID pn \
	) { return V3C_DELEGATE(x, PointerNodeNextPtr(runtime, pn)); } \
inline BOOL STDCALL NodeHasPrevPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PCVOID pn \
	) { return V3C_DELEGATE(x, NodeHasPrevPtr(runtime, pn)); } \
inline HTREEDB_TREENODE STDCALL NodePrevPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PCVOID pn \
	) { return V3C_DELEGATE(x, NodePrevPtr(runtime, pn)); } \
inline PVOID STDCALL PointerNodePrevPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PCVOID pn \
	) { return V3C_DELEGATE(x, PointerNodePrevPtr(runtime, pn)); } \
inline uintptr_t STDCALL NodeIndexPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, HTREEDB_TREE ht \
	, PCVOID pn \
	) { return V3C_DELEGATE(x, NodeIndexPtr(runtime, ht, pn)); } \
inline HTREEDB_TREENODE STDCALL NodeAtIndexPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PCVOID pn \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, NodeAtIndexPtr(runtime, pn, u)); } \
inline PVOID STDCALL PointerNodeGetPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PCVOID pn \
	, uintptr_t u \
	) { return V3C_DELEGATE(x, PointerNodeAtIndexPtr(runtime, pn, u)); } \
inline uintptr_t STDCALL NodeCountPtr \
	( treedb_tree_runtime_ptr_t runtime \
	, PCVOID pn \
	) { return V3C_DELEGATE(x, NodeCountPtr(runtime, pn)); }

#define TREEDB_ITreeBackend_DELEGATE_TO(x) \
inline HTREEDB_TREEKEY STDCALL \
	UnpackKey(treedb_tree_runtime_ptr_t runtime, PCVOID pv) \
		{ return V3C_DELEGATE(x, UnpackKey(DGTHIS(x) runtime, pv)); } \
inline int STDCALL \
	Compare(treedb_tree_runtime_ptr_t runtime, HTREEDB_TREEKEY a \
			, HTREEDB_TREEKEY b)\
		{ return V3C_DELEGATE(x, Compare(DGTHIS(x) runtime, a, b)); } \
inline PVOID STDCALL \
	AllocNode(treedb_tree_runtime_ptr_t runtime, HTREEDB_TREEKEY key) \
		{ return V3C_DELEGATE(x, AllocNode(DGTHIS(x) runtime, key)); } \
inline void STDCALL \
	FreeNode(treedb_tree_runtime_ptr_t runtime, PVOID pn) \
		{ return V3C_DELEGATE(x, FreeNode(DGTHIS(x) runtime, pn)); }

#define TREEDB_ITreeRenderer_DELEGATE_TO(x) \
void STDCALL Add(const char * text, int last) \
		{ return V3C_DELEGATE(x, Add(DGTHIS(x) text, last)); } \
void STDCALL Push() \
		{ return V3C_DELEGATE(x, Push(DGTHIS0(x))); } \
void STDCALL Pop() \
		{ return V3C_DELEGATE(x, Pop(DGTHIS0(x))); } \
void STDCALL Reset() \
		{ return V3C_DELEGATE(x, Reset(DGTHIS0(x))); } \
void STDCALL Term() \
		{ return V3C_DELEGATE(x, Term(DGTHIS0(x))); }

/******************************************************************************/
/* typedefs / forward declarations                                            */
/******************************************************************************/
  #ifndef MetaTreedb_tree_typedefs_DEFINED
	#define MetaTreedb_tree_typedefs_DEFINED

typedef size_t HTREEDB_TREE;
typedef size_t HTREEDB_TREENODE;
typedef PCVOID HTREEDB_TREEKEY;

struct treedb_tree_runtime_t;
typedef struct treedb_tree_runtime_t treedb_tree_runtime_t
	, * treedb_tree_runtime_ptr_t;

typedef struct treedb_tree_backend_t treedb_tree_backend_t
	, * treedb_tree_backend_ptr_t;

typedef struct treedb_tree_renderer_t treedb_tree_renderer_t
	, * treedb_tree_renderer_ptr_t;

typedef struct treedb_tree_data_renderer_t treedb_tree_data_renderer_t
	, * treedb_tree_data_renderer_ptr_t;

/* v-table pointers should really be const pointers, but it's not a big deal.

NEVER,NEVER,NEVER think that you can omit these v-tables in c++!!!
Why:
1. It causes a compile error when you try to instantiate an abstract class
2. We obtain the implementation (along with the v-table) with a function call
   and c++ doesn't copy over the (hidden) v-table with respect to c++ objects
*/
typedef struct treedb_tree_impl_vtbl_t treedb_tree_impl_vtbl_t
	, * treedb_tree_impl_vtbl_ptr_t;
typedef struct treedb_allocator_impl_vtbl_t treedb_allocator_impl_vtbl_t
	, * treedb_allocator_impl_vtbl_ptr_t;
typedef struct treedb_tree_backend_vtbl_t treedb_tree_backend_vtbl_t
	, * treedb_tree_backend_vtbl_ptr_t;
typedef struct treedb_tree_renderer_vtbl_t treedb_tree_renderer_vtbl_t
	, * treedb_tree_renderer_vtbl_ptr_t;
typedef struct treedb_tree_data_renderer_vtbl_t treedb_tree_data_renderer_vtbl_t
	, * treedb_tree_data_renderer_vtbl_ptr_t;
typedef struct treedb_fd_tree_renderer_vtbl_t treedb_fd_tree_renderer_vtbl_t
	, * treedb_fd_tree_renderer_vtbl_ptr_t;

typedef struct treedb_tree_impl_t treedb_tree_impl_t, * treedb_tree_impl_ptr_t;

typedef const treedb_tree_impl_t * treedb_const_tree_impl_ptr_t;

typedef struct treedb_fd_tree_renderer_t treedb_fd_tree_renderer_t
	, * treedb_fd_tree_renderer_ptr_t;


  #endif /* MetaTreedb_tree_typedefs_DEFINED */

/******************************************************************************/
/* treedb_tree_impl_t                                                         */
/******************************************************************************/
  #define treedb_tree_impl_t_methods(Imp, Prefix, Runtime) \
	STDMETHOD##Imp##_(void, Prefix##Clear) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Clone) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht_to*/ \
		, HTREEDB_TREE /*ht_from*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREE, Prefix##Alloc) \
		( THIS0(Runtime) \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Free) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##Count) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		) PURE; \
	STDMETHOD##Imp##_(TreedbInsertResult, Prefix##Insert) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		, PVOID * /*ppn*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##Remove) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##RemoveBetween) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREENODE /*hn_lower*/ \
		, HTREEDB_TREENODE /*hn_upper*/ \
		, TreedbNodeDistanceFlags /*flags*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##RemoveMany) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*lower_key*/ \
		, HTREEDB_TREEKEY /*upper_key*/ \
		, TreedbKeyDistanceFlags /*flags*/ \
		) PURE; \
	STDMETHOD##Imp##_(intptr_t, Prefix##NodeDistance) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREENODE /*hn_lower*/ \
		, HTREEDB_TREENODE /*hn_upper*/ \
		, TreedbNodeDistanceFlags /*flags*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##KeyDistance) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hlower*/ \
		, HTREEDB_TREEKEY /*hupper*/ \
		, TreedbKeyDistanceFlags /*flags*/ \
		, intptr_t * /*pres*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Dump) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, treedb_tree_renderer_ptr_t /*pr*/ \
		, treedb_tree_data_renderer_ptr_t /*pd*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##Head) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##Tail) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##Top) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##Index) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, size_t /*u*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerHead) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerTail) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerTop) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerIndex) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, size_t /*u*/ \
		) PURE; \
	\
	/* "Handle" methods */ \
	STDMETHOD##Imp##_(void, Prefix##Init) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##DumpNode) \
		( THIS(Runtime) \
		  HTREEDB_TREENODE /*hn*/ \
		, treedb_tree_renderer_ptr_t /*pr*/ \
		, treedb_tree_data_renderer_ptr_t /*pd*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##InsertNode) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##InsertNodeBefore) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREENODE /*hn_ref*/ \
		, HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##InsertNodeAfter) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREENODE /*hn_ref*/ \
		, HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##RelinkNode) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##UnlinkNode) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##DeleteNode) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	\
	STDMETHOD##Imp##_(TreedbSearchResult, Prefix##SearchClosest) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		, HTREEDB_TREENODE * /*phn*/ \
		) PURE; \
	STDMETHOD##Imp##_(TreedbSearchResult, Prefix##SearchLe) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		, HTREEDB_TREENODE * /*phn*/ \
		) PURE; \
	STDMETHOD##Imp##_(TreedbSearchResult, Prefix##SearchGe) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		, HTREEDB_TREENODE * /*phn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##Search) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##SearchLt) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##SearchGt) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##NodeHasNext) \
		( THIS(Runtime) \
		  HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##NodeNext) \
		( THIS(Runtime) \
		  HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerNodeNext) \
		( THIS(Runtime) \
		  HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##NodeHasPrev) \
		( THIS(Runtime) \
		  HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##NodePrev) \
		( THIS(Runtime) \
		  HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerNodePrev) \
		( THIS(Runtime) \
		  HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##NodeIndex) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##NodeAtIndex) \
		( THIS(Runtime) \
		  HTREEDB_TREENODE /*hn*/ \
		, size_t /*u*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerNodeAtIndex) \
		( THIS(Runtime) \
		  HTREEDB_TREENODE /*hn*/ \
		, size_t /*u*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##NodeCount) \
		( THIS(Runtime) \
		  HTREEDB_TREENODE /*hn*/ \
		) PURE; \
	\
	\
	/* "Pointer" methods */ \
	STDMETHOD##Imp##_(void, Prefix##InitPtr) \
		( THIS(Runtime) \
		  PVOID /*pt*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##DumpNodePtr) \
		( THIS(Runtime) \
		  PCVOID /*pn*/ \
		, treedb_tree_renderer_ptr_t /*pr*/ \
		, treedb_tree_data_renderer_ptr_t /*pd*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##InsertNodePtr) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##InsertNodeBeforePtr) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, PVOID /*pn*/ \
		, PVOID /*pn_new*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##InsertNodeAfterPtr) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, PVOID /*pn*/ \
		, PVOID /*pn_new*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##RelinkNodePtr) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##UnlinkNodePtr) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, PVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##DeleteNodePtr) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, PVOID /*pn*/ \
		) PURE; \
	\
	STDMETHOD##Imp##_(TreedbSearchResult, Prefix##SearchClosestPtr) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		, PVOID * /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(TreedbSearchResult, Prefix##SearchLePtr) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		, PVOID * /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(TreedbSearchResult, Prefix##SearchGePtr) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		, PVOID * /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerSearch) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerSearchLt) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerSearchGt) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, HTREEDB_TREEKEY /*hkey*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##NodeHasNextPtr) \
		( THIS(Runtime) \
		  PCVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##NodeNextPtr) \
		( THIS(Runtime) \
		  PCVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerNodeNextPtr) \
		( THIS(Runtime) \
		  PCVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(BOOL, Prefix##NodeHasPrevPtr) \
		( THIS(Runtime) \
		  PCVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##NodePrevPtr) \
		( THIS(Runtime) \
		  PCVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerNodePrevPtr) \
		( THIS(Runtime) \
		  PCVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##NodeIndexPtr) \
		( THIS(Runtime) \
		  HTREEDB_TREE /*ht*/ \
		, PCVOID /*pn*/ \
		) PURE; \
	STDMETHOD##Imp##_(HTREEDB_TREENODE, Prefix##NodeAtIndexPtr) \
		( THIS(Runtime) \
		  PCVOID /*pn*/ \
		, size_t /*u*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##PointerNodeAtIndexPtr) \
		( THIS(Runtime) \
		  PCVOID /*pn*/ \
		, size_t /*u*/ \
		) PURE; \
	STDMETHOD##Imp##_(size_t, Prefix##NodeCountPtr) \
		( THIS(Runtime) \
		  PCVOID /*pn*/ \
		) PURE

  #ifdef COBJMACROS

	#define treedb_tree_impl_t_Clear(Runtime, htree) \
	  TREEDB_IFACE_IMPL_CCALL(Clear, Runtime, htree)
	#define treedb_tree_impl_t_Clone(Runtime, ht_to, ht_from) \
	  TREEDB_IFACE_IMPL_CCALL(Clone, Runtime, ht_to, ht_from)

	#define treedb_tree_impl_t_Alloc(Runtime) \
	  TREEDB_IFACE_IMPL_CCALL(Alloc, Runtime)
	#define treedb_tree_impl_t_Free(Runtime, htree) \
	  TREEDB_IFACE_IMPL_CCALL(Free, Runtime, htree)
	#define treedb_tree_impl_t_Count(Runtime, htree) \
	  TREEDB_IFACE_IMPL_CCALL(Count, Runtime, htree)
	#define treedb_tree_impl_t_Insert(Runtime, htree, pv, ppn) \
	  TREEDB_IFACE_IMPL_CCALL(Insert, Runtime, htree, pv, ppn)
	#define treedb_tree_impl_t_Remove(Runtime, htree, pv) \
	  TREEDB_IFACE_IMPL_CCALL(Remove, Runtime, htree, pv)
	#define treedb_tree_impl_t_RemoveBetween(Runtime, htree, hn_lower \
		, hn_upper, flags) \
	  TREEDB_IFACE_IMPL_CCALL(RemoveBetween, Runtime, htree \
		, hn_lower, hn_upper, flags)
	#define treedb_tree_impl_t_RemoveMany(Runtime, htree, lower_key, upper_key \
		, flags) \
	  TREEDB_IFACE_IMPL_CCALL(RemoveMany, Runtime, htree, lower_key, upper_key \
		, flags)
	#define treedb_tree_impl_t_NodeDistance(Runtime, htree, hn_lower, hn_upper \
		, flags) \
	  TREEDB_IFACE_IMPL_CCALL(NodeDistance, Runtime, htree, hn_lower, hn_upper \
		, flags)
	#define treedb_tree_impl_t_KeyDistance(Runtime, htree, hlower, hupper \
		, flags, pres) \
	  TREEDB_IFACE_IMPL_CCALL(KeyDistance, Runtime, htree, hlower, hupper \
		, flags, pres)
	#define treedb_tree_impl_t_Dump(Runtime, htree, pr, pd) \
	  TREEDB_IFACE_IMPL_CCALL(Dump, Runtime, htree, pr, pd)
	#define treedb_tree_impl_t_Head(Runtime, htree) \
	  TREEDB_IFACE_IMPL_CCALL(Head, Runtime, htree)
	#define treedb_tree_impl_t_Tail(Runtime, htree) \
	  TREEDB_IFACE_IMPL_CCALL(Tail, Runtime, htree)
	#define treedb_tree_impl_t_Top(Runtime, htree) \
	  TREEDB_IFACE_IMPL_CCALL(Top, Runtime, htree)
	#define treedb_tree_impl_t_Index(Runtime, htree, u) \
	  TREEDB_IFACE_IMPL_CCALL(Index, Runtime, htree, u)
	#define treedb_tree_impl_t_PointerHead(Runtime, htree) \
	  TREEDB_IFACE_IMPL_CCALL(PointerHead, Runtime, htree)
	#define treedb_tree_impl_t_PointerTail(Runtime, htree) \
	  TREEDB_IFACE_IMPL_CCALL(PointerTail, Runtime, htree)
	#define treedb_tree_impl_t_PointerTop(Runtime, htree) \
	  TREEDB_IFACE_IMPL_CCALL(PointerTop, Runtime, htree)
	#define treedb_tree_impl_t_PointerIndex(Runtime, htree, u) \
	  TREEDB_IFACE_IMPL_CCALL(PointerIndex, Runtime, htree, u)

/* "Handle" macros ---------------------------------------------------------- */
	#define treedb_tree_impl_t_Init(Runtime, htree) \
	  TREEDB_IFACE_IMPL_CCALL(Init, Runtime, htree)
	#define treedb_tree_impl_t_DumpNode(Runtime, pr, pd, hn) \
	  TREEDB_IFACE_IMPL_CCALL(DumpNode, Runtime, pr, pd, hn)
	#define treedb_tree_impl_t_InsertNode(Runtime, htree, hn) \
	  TREEDB_IFACE_IMPL_CCALL(InsertNode, Runtime, htree, hn)
	#define treedb_tree_impl_t_InsertNodeBefore(Runtime, htree, hn, hn_new) \
	  TREEDB_IFACE_IMPL_CCALL(InsertNodeBefore, Runtime, htree, hn, hn_new)
	#define treedb_tree_impl_t_InsertNodeAfter(Runtime, htree, hn, hn_new) \
	  TREEDB_IFACE_IMPL_CCALL(InsertNodeAfter, Runtime, htree, hn, hn_new)
	#define treedb_tree_impl_t_RelinkNode(Runtime, htree, hn) \
	  TREEDB_IFACE_IMPL_CCALL(RelinkNode, Runtime, htree, hn)
	#define treedb_tree_impl_t_UnlinkNode(Runtime, htree, hn) \
	  TREEDB_IFACE_IMPL_CCALL(UnlinkNode, Runtime, htree, hn)
	#define treedb_tree_impl_t_DeleteNode(Runtime, htree, hn) \
	  TREEDB_IFACE_IMPL_CCALL(DeleteNode, Runtime, htree, hn)
	#define treedb_tree_impl_t_SearchClosest(Runtime, htree, k, phn) \
	  TREEDB_IFACE_IMPL_CCALL(SearchClosest, Runtime, htree, k, phn)
	#define treedb_tree_impl_t_SearchLe(Runtime, htree, k, phn) \
	  TREEDB_IFACE_IMPL_CCALL(SearchLe, Runtime, htree, k, phn)
	#define treedb_tree_impl_t_SearchGe(Runtime, htree, k, phn) \
	  TREEDB_IFACE_IMPL_CCALL(SearchGe, Runtime, htree, k, phn)
	#define treedb_tree_impl_t_Search(Runtime, htree, k) \
	  TREEDB_IFACE_IMPL_CCALL(Search, Runtime, htree, k)
	#define treedb_tree_impl_t_SearchLt(Runtime, htree, k) \
	  TREEDB_IFACE_IMPL_CCALL(SearchLt, Runtime, htree, k)
	#define treedb_tree_impl_t_SearchGt(Runtime, htree, k) \
	  TREEDB_IFACE_IMPL_CCALL(SearchGt, Runtime, htree, k)
	#define treedb_tree_impl_t_NodeHasNext(Runtime, hn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeHasNext, Runtime, hn)
	#define treedb_tree_impl_t_NodeNext(Runtime, hn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeNext, Runtime, hn)
	#define treedb_tree_impl_t_PointerNodeNext(Runtime, hn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeNext, Runtime, hn)
	#define treedb_tree_impl_t_NodeHasPrev(Runtime, hn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeHasPrev, Runtime, hn)
	#define treedb_tree_impl_t_NodePrev(Runtime, hn) \
	  TREEDB_IFACE_IMPL_CCALL(NodePrev, Runtime, hn)
	#define treedb_tree_impl_t_PointerNodePrev(Runtime, hn) \
	  TREEDB_IFACE_IMPL_CCALL(NodePrev, Runtime, hn)
	#define treedb_tree_impl_t_NodeIndex(Runtime, hn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeIndex, Runtime, hn)
	#define treedb_tree_impl_t_NodeAtIndex(Runtime, hn, u) \
	  TREEDB_IFACE_IMPL_CCALL(NodeAtIndex, Runtime, hn, u)
	#define treedb_tree_impl_t_PointerNodeIndex(Runtime, hn, n) \
	  TREEDB_IFACE_IMPL_CCALL(PointerNodeIndex, Runtime, hn, n)
	#define treedb_tree_impl_t_NodeCount(Runtime, hn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeCount, Runtime, hn)

	#define treedb_tree_impl_t_NodeToData(This, h) \
	  (((HTREEDB_HANDLE)(h)) + (This)->m_pDescription->m_aligned_node_size)
	#define treedb_tree_impl_t_DataToNode(This, h) \
	  (((HTREEDB_HANDLE)(h)) - (This)->m_pDescription->m_aligned_node_size)

/* "Pointer" macros --------------------------------------------------------  */
	#define treedb_tree_impl_t_InitPtr(Runtime, ptree) \
	  TREEDB_IFACE_IMPL_CCALL(InitPtr, Runtime, ptree)
	#define treedb_tree_impl_t_DumpNodePtr(Runtime, pr, pd, pn) \
	  TREEDB_IFACE_IMPL_CCALL(DumpNodePtr, Runtime, pr, pd, pn)
	#define treedb_tree_impl_t_InsertNodePtr(Runtime, htree, pn) \
	  TREEDB_IFACE_IMPL_CCALL(InsertNodePtr, Runtime, htree, pn)
	#define treedb_tree_impl_t_InsertNodeBeforePtr(Runtime, htree, pn \
		, pnew_node) \
	  TREEDB_IFACE_IMPL_CCALL(InsertNodeBeforePtr, Runtime, htree, pn \
		, pnew_node)
	#define treedb_tree_impl_t_InsertNodeAfterPtr(Runtime, htree, pn \
		, pnew_node) \
	  TREEDB_IFACE_IMPL_CCALL(InsertNodeAfterPtr, Runtime, htree, pn, pnew_node)
	#define treedb_tree_impl_t_RelinkNodePtr(Runtime, htree, pn) \
	  TREEDB_IFACE_IMPL_CCALL(RelinkNodePtr, Runtime, htree, pn)
	#define treedb_tree_impl_t_UnlinkNodePtr(Runtime, htree, pn) \
	  TREEDB_IFACE_IMPL_CCALL(UnlinkNodePtr, Runtime, htree, pn)
	#define treedb_tree_impl_t_DeleteNodePtr(Runtime, htree, pn) \
	  TREEDB_IFACE_IMPL_CCALL(DeleteNodePtr, Runtime, htree, pn)

	#define treedb_tree_impl_t_SearchClosestPtr(Runtime, htree, k, ppnode) \
	  TREEDB_IFACE_IMPL_CCALL(SearchClosestPtr, Runtime, htree, k, ppnode)
	#define treedb_tree_impl_t_SearchLePtr(Runtime, htree, k, ppnode) \
	  TREEDB_IFACE_IMPL_CCALL(SearchLePtr, Runtime, htree, k, ppnode)
	#define treedb_tree_impl_t_SearchGePtr(Runtime, htree, k, ppnode) \
	  TREEDB_IFACE_IMPL_CCALL(SearchGePtr, Runtime, htree, k, ppnode)
	#define treedb_tree_impl_t_PointerSearch(Runtime, htree, k) \
	  TREEDB_IFACE_IMPL_CCALL(PointerSearch, Runtime, htree, k)
	#define treedb_tree_impl_t_PointerSearchLt(Runtime, htree, k) \
	  TREEDB_IFACE_IMPL_CCALL(PointerSearchLt, Runtime, htree, k)
	#define treedb_tree_impl_t_PointerSearchGt(Runtime, htree, k) \
	  TREEDB_IFACE_IMPL_CCALL(PointerSearchGt, Runtime, htree, k)

	#define treedb_tree_impl_t_NodeHasNextPtr(Runtime, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeHasNextPtr, Runtime, pn)
	#define treedb_tree_impl_t_NodeNextPtr(Runtime, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeNextPtr, Runtime, pn)
	#define treedb_tree_impl_t_PointerNodeNextPtr(Runtime, pn) \
	  TREEDB_IFACE_IMPL_CCALL(PointerNodeNextPtr, Runtime, pn)
	#define treedb_tree_impl_t_NodeHasPrevPtr(Runtime, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeHasPrevPtr, Runtime, pn)
	#define treedb_tree_impl_t_NodePrevPtr(Runtime, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodePrevPtr, Runtime, pn)
	#define treedb_tree_impl_t_PointerNodePrevPtr(Runtime, pn) \
	  TREEDB_IFACE_IMPL_CCALL(PointerNodePrevPtr, Runtime, pn)
	#define treedb_tree_impl_t_NodeIndexPtr(Runtime, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeIndexPtr, Runtime, pn)
	#define treedb_tree_impl_t_NodeAtIndexPtr(Runtime, pn, u) \
	  TREEDB_IFACE_IMPL_CCALL(NodeAtIndexPtr, Runtime, pn, u)
	#define treedb_tree_impl_t_PointerIndexPtr(Runtime, u) \
	  TREEDB_IFACE_IMPL_CCALL(PointerIndexPtr, Runtime, u)
	#define treedb_tree_impl_t_NodeCountPtr(Runtime, pn) \
	  TREEDB_IFACE_IMPL_CCALL(NodeCountPtr, Runtime, pn)

	#define treedb_tree_impl_t_NodeToDataPtr(This, p) \
	  (((char *)(p)) + (This)->m_pDescription->m_aligned_node_size)
	#define treedb_tree_impl_t_DataToNodePtr(This, p) \
	  (((char *)(p)) - (This)->m_pDescription->m_aligned_node_size)

/* Allocator convenience macros --------------------------------------------- */
	#define treedb_tree_impl_t_PointerToOffset(This, u) \
	  treedb_allocator_t_PointerToOffset((This)->m_pAllocator, u)
	#define treedb_tree_impl_t_OffsetToPointer(This, u) \
	  treedb_allocator_t_OffsetToPointer((This)->m_pAllocator, u)
	#define treedb_tree_impl_t_PointerPack(This, p) \
	  treedb_allocator_t_PointerPack((This)->m_pAllocator, p)
	#define treedb_tree_impl_t_PointerUnpack(This, u) \
	  treedb_allocator_t_PointerUnpack((This)->m_pAllocator, u)

/* Allocator convenience handle macros -------------------------------------- */
	#define treedb_tree_impl_t_Read(This, hloc) \
	  treedb_allocator_t_Read((This)->m_pAllocator, hloc)
	#define treedb_tree_impl_t_Write(This, hloc, hvalue) \
	  treedb_allocator_t_Write((This)->m_pAllocator, hloc, hvalue)
	#define treedb_tree_impl_t_PointerRead(This, hloc) \
	  treedb_allocator_t_PointerRead((This)->m_pAllocator, hloc)
	#define treedb_tree_impl_t_PointerWrite(This, hloc, pv) \
	  treedb_allocator_t_PointerWrite((This)->m_pAllocator, hloc, pv)
	#define treedb_tree_impl_t_PointerAddTo(This, hloc, u) \
	  treedb_allocator_t_PointerAddTo((This)->m_pAllocator, hloc, u)

/* Allocator convenience pointer macros ------------------------------------- */
	#define treedb_tree_impl_t_ReadPtr(This, pv) \
	  treedb_allocator_t_ReadPtr((This)->m_pAllocator, p)
	#define treedb_tree_impl_t_WritePtr(This, pv, hvalue) \
	  treedb_allocator_t_WritePtr((This)->m_pAllocator, pv, hvalue)
	#define treedb_tree_impl_t_PointerReadPtr(This, pv) \
	  treedb_allocator_t_PointerReadPtr((This)->m_pAllocator, pv)
	#define treedb_tree_impl_t_PointerWritePtr(This, pv, pvvalue) \
	  treedb_allocator_t_PointerWritePtr((This)->m_pAllocator, pv, pvvalue)
	#define treedb_tree_impl_t_PointerAddToPtr(This, pv, u) \
	  treedb_allocator_t_PointerAddToPtr((This)->m_pAllocator, pv, u)

/* Backend convenience macros ----------------------------------------------- */
	#define treedb_tree_impl_t_allows_duplicates(This) \
	  ((This)->m_pDescription->m_flags & eTreedbContainerAllowsDuplicates)

	#define treedb_tree_impl_t_PointerToOffset(This, u) \
	  treedb_allocator_t_PointerToOffset((This)->m_pAllocator, u)
	#define treedb_tree_impl_t_OffsetToPointer(This, u) \
	  treedb_allocator_t_OffsetToPointer((This)->m_pAllocator, u)

  #endif /* #ifdef COBJMACROS */

  #define treedb_tree_impl_vtbl_t_entries_default(Prefix) \
	& Prefix##Clear \
	, & Prefix##Clone \
	, & Prefix##Alloc \
	, & Prefix##Free \
	, & Prefix##Count \
	, & Prefix##Insert \
	, & Prefix##Remove \
	, & Prefix##RemoveBetween \
	, & Prefix##RemoveMany \
	, & Prefix##NodeDistance \
	, & Prefix##KeyDistance \
	, & Prefix##Dump \
	, & Prefix##Head \
	, & Prefix##Tail \
	, & Prefix##Top \
	, & Prefix##Index \
	, & Prefix##PointerHead \
	, & Prefix##PointerTail \
	, & Prefix##PointerTop \
	, & Prefix##PointerIndex \
	\
	, & Prefix##Init \
	, & Prefix##DumpNode \
	, & Prefix##InsertNode \
	, & Prefix##InsertNodeBefore \
	, & Prefix##InsertNodeAfter \
	, & Prefix##RelinkNode \
	, & Prefix##UnlinkNode \
	, & Prefix##DeleteNode \
	\
	, & Prefix##SearchClosest \
	, & Prefix##SearchLe \
	, & Prefix##SearchGe \
	, & Prefix##Search \
	, & Prefix##SearchLt \
	, & Prefix##SearchGt \
	, & Prefix##NodeHasNext \
	, & Prefix##NodeNext \
	, & Prefix##PointerNodeNext \
	, & Prefix##NodeHasPrev \
	, & Prefix##NodePrev \
	, & Prefix##PointerNodePrev \
	, & Prefix##NodeIndex \
	, & Prefix##NodeAtIndex \
	, & Prefix##PointerNodeAtIndex \
	, & Prefix##NodeCount \
	\
	, & Prefix##InitPtr \
	, & Prefix##DumpNodePtr \
	, & Prefix##InsertNodePtr \
	, & Prefix##InsertNodeBeforePtr \
	, & Prefix##InsertNodeAfterPtr \
	, & Prefix##RelinkNodePtr \
	, & Prefix##UnlinkNodePtr \
	, & Prefix##DeleteNodePtr \
	\
	, & Prefix##SearchClosestPtr \
	, & Prefix##SearchLePtr \
	, & Prefix##SearchGePtr \
	, & Prefix##PointerSearch \
	, & Prefix##PointerSearchLt \
	, & Prefix##PointerSearchGt \
	, & Prefix##NodeHasNextPtr \
	, & Prefix##NodeNextPtr \
	, & Prefix##PointerNodeNextPtr \
	, & Prefix##NodeHasPrevPtr \
	, & Prefix##NodePrevPtr \
	, & Prefix##PointerNodePrevPtr \
	, & Prefix##NodeIndexPtr \
	, & Prefix##NodeAtIndexPtr \
	, & Prefix##PointerNodeAtIndexPtr \
	, & Prefix##NodeCountPtr

  #ifndef treedb_tree_impl_vtbl_t_entries
	#define treedb_tree_impl_vtbl_t_entries(x) \
	  treedb_tree_impl_vtbl_t_entries_default(x)
  #endif

  #define treedb_tree_impl_t_members(vtbl_ptr_t) \
	vtbl_ptr_t m_pVtbl; \
	treedb_allocator_ptr_t m_pAllocator; \
	treedb_tree_backend_ptr_t m_pBackend; \
	TreedbItemDescriptionConstPtr m_pDescription

  #ifndef MetaTreedb_treedb_tree_impl_t_DEFINED
	#define MetaTreedb_treedb_tree_impl_t_DEFINED

	#ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
struct treedb_tree_impl_vtbl_t
{
	treedb_tree_impl_t_methods(,,treedb_tree_runtime_t);
};
	#ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_tree_impl_t
{
  #ifdef __cplusplus
	inline treedb_tree_impl_t()
	: m_pVtbl(0), m_pAllocator(0), m_pBackend(0), m_pDescription(0)
	{}
	#define DGTHIS_MEM(x,m) m
	#define DGTHIS0(x) treedb_tree_t_to_runtime(this)
	#define DGTHIS(x) treedb_tree_t_to_runtime(this),
	#define V3C_DELEGATE(Inst, x) m_pVtbl->x
	TREEDB_ITreeImpl_DELEGATE_TO();
	#undef DGTHIS_MEM
	#undef DGTHIS0
	#undef DGTHIS
	#undef V3C_DELEGATE
  #endif
	treedb_tree_impl_t_members(treedb_tree_impl_vtbl_ptr_t);
};

	#define META_TREEDB_TREE_IMPL_INIT_BARE 0,0,0,0
	#define META_TREEDB_TREE_IMPL_INIT { META_TREEDB_TREE_IMPL_INIT_BARE }

  #endif /* #ifndef MetaTreedb_treedb_tree_impl_t_DEFINED */

extern void treedb_tree_impl_t_Setup
( treedb_tree_impl_ptr_t pm
, treedb_allocator_ptr_t pa
, treedb_tree_backend_ptr_t pb
, TreedbItemDescription * pd
, treedb_const_tree_impl_ptr_t ptemplate
);
static inline void treedb_tree_impl_t_Setup2
( treedb_tree_impl_ptr_t pm
, treedb_allocator_on_storage_ptr_t pa
, treedb_tree_backend_ptr_t pb
, TreedbItemDescription * pd
, treedb_const_tree_impl_ptr_t ptemplate
) {
	return treedb_tree_impl_t_Setup(pm, (treedb_allocator_ptr_t)pa, pb, pd
		, ptemplate);
}
/******************************************************************************/
/* treedb_tree_runtime_t                                                      */
/*                                                                            */
/* May supply additional information beyond the implementation pointer.       */
/*                                                                            */
/* By implementing the backend you will quickly find out if a                 */
/* treedb_tree_ptr_t will do instead.                                         */
/*                                                                            */
/******************************************************************************/
struct treedb_tree_runtime_t {
	treedb_tree_impl_ptr_t m_pImpl;
};

/******************************************************************************/
/* treedb_tree_t                                                              */
/*                                                                            */
/* Node data may be modified in-place but if you change the key, remember to  */
/* first unlink the node!                                                     */
/*                                                                            */
/******************************************************************************/
static inline
treedb_tree_runtime_ptr_t
treedb_tree_t_to_runtime(treedb_tree_ptr_t p)
{
	return (treedb_tree_runtime_ptr_t)p;
}

struct treedb_tree_t {
  #ifdef __cplusplus
	#define DGTHIS_MEM(x,m) m
	#define DGTHIS0(x) treedb_tree_t_to_runtime(this)
	#define DGTHIS(x) treedb_tree_t_to_runtime(this),
	#define V3C_DELEGATE(Inst, x) m_pImpl->m_pVtbl->x
	TREEDB_ITree_DELEGATE_TO();
	#undef DGTHIS_MEM
	#undef DGTHIS0
	#undef DGTHIS
	#undef V3C_DELEGATE
  #endif
	treedb_tree_impl_ptr_t m_pImpl;
	HTREEDB_TREE m_handle;
};
  #define META_TREEDB_TREE_INIT_BARE 0,0
  #define META_TREEDB_TREE_INIT { META_TREEDB_TREE_INIT_BARE }

extern
void treedb_tree_t_Setup
( treedb_tree_ptr_t p
, treedb_tree_impl_ptr_t pImpl
, size_t uPayload
);

  #ifdef COBJMACROS

	#define treedb_tree_t_Init(This) \
	  treedb_tree_impl_t_Init(treedb_tree_t_to_runtime(This), (This)->m_handle)
	#define treedb_tree_t_Clear(This) \
	  treedb_tree_impl_t_Clear(treedb_tree_t_to_runtime(This), (This)->m_handle)
	#define treedb_tree_t_Clone(This, ht_to) \
	  treedb_tree_impl_t_Clone(treedb_tree_t_to_runtime(This), ht_to \
		, (This)->m_handle)

	#define treedb_tree_t_Count(This) \
	  treedb_tree_impl_t_Count(treedb_tree_t_to_runtime(This), (This)->m_handle)
	#define treedb_tree_t_Insert(This, pv, ppn) \
	  treedb_tree_impl_t_Insert(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, pv, ppn)
	#define treedb_tree_t_Remove(This, pv) \
	  treedb_tree_impl_t_Remove(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, pv)
	#define treedb_tree_t_RemoveBetween(This, hn_lower, hn_upper, flags) \
	  treedb_tree_impl_t_RemoveBetween(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, hn_lower, hn_upper, flags)
	#define treedb_tree_t_RemoveMany(This, lower_key, upper_key, flags) \
	  treedb_tree_impl_t_RemoveMany(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, lower_key, upper_key, flags)
	#define treedb_tree_t_NodeDistance(This, hlower, hupper, flags) \
	  treedb_tree_impl_t_NodeDistance(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, hlower, hupper, flags)
	#define treedb_tree_t_KeyDistance(This, hn_lower, hn_upper, flags, pres) \
	  treedb_tree_impl_t_KeyDistance(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, hn_lower, hn_upper, flags, pres)

	#define treedb_tree_t_Dump(This, pr, pd) \
	  treedb_tree_impl_t_Dump(treedb_tree_t_to_runtime(This), (This)->m_handle \
		, pr, pd)

	#define treedb_tree_t_Head(This) \
	  treedb_tree_impl_t_Head(treedb_tree_t_to_runtime(This), (This)->m_handle)
	#define treedb_tree_t_Tail(This) \
	  treedb_tree_impl_t_Tail(treedb_tree_t_to_runtime(This), (This)->m_handle)
	#define treedb_tree_t_Top(This) \
	  treedb_tree_impl_t_Top(treedb_tree_t_to_runtime(This), (This)->m_handle)
	#define treedb_tree_t_Index(This, u) \
	  treedb_tree_impl_t_Index(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, u)

	#define treedb_tree_t_PointerHead(This) \
	  treedb_tree_impl_t_PointerHead(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_tree_t_PointerTail(This) \
	  treedb_tree_impl_t_PointerTail(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_tree_t_PointerTop(This) \
	  treedb_tree_impl_t_PointerTop(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle)
	#define treedb_tree_t_PointerIndex(This, u) \
	  treedb_tree_impl_t_PointerIndex(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, u)

/* "Handle" macros ---------------------------------------------------------- */
	#define treedb_tree_t_DumpNode(This, pr, pd, hn) \
	  treedb_tree_impl_t_DumpNode(treedb_tree_t_to_runtime(This), pr, pd, hn)
	#define treedb_tree_t_InsertNode(This, hn) \
	  treedb_tree_impl_t_InsertNode(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, hn)
	#define treedb_tree_t_InsertNodeBefore(This, hn, hnode_new) \
	  treedb_tree_impl_t_InsertNodeBefore(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, hn, hnode_new)
	#define treedb_tree_t_InsertNodeAfter(This, hn, hnode_new) \
	  treedb_tree_impl_t_InsertNodeAfter(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, hn, hnode_new)
	#define treedb_tree_t_RelinkNode(This, hn) \
	  treedb_tree_impl_t_RelinkNode(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, hn)
	#define treedb_tree_t_UnlinkNode(This, hn) \
	  treedb_tree_impl_t_UnlinkNode(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, hn)
	#define treedb_tree_t_DeleteNode(This, hn) \
	  treedb_tree_impl_t_DeleteNode(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, hn)
	#define treedb_tree_t_SearchClosest(This, k, phn) \
	  treedb_tree_impl_t_SearchClosest(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k, phn)
	#define treedb_tree_t_SearchLe(This, k, phn) \
	  treedb_tree_impl_t_SearchLe(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k, phn)
	#define treedb_tree_t_SearchGe(This, k, phn) \
	  treedb_tree_impl_t_SearchGe(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k, phn)
	#define treedb_tree_t_Search(This, k) \
	  treedb_tree_impl_t_Search(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k)
	#define treedb_tree_t_SearchLt(This, k) \
	  treedb_tree_impl_t_SearchLt(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k)
	#define treedb_tree_t_SearchGt(This, k) \
	  treedb_tree_impl_t_SearchGt(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k)

	#define treedb_tree_t_NodeHasNext(This, hn) \
	  treedb_tree_impl_t_NodeHasNext(treedb_tree_t_to_runtime(This), hn)
	#define treedb_tree_t_NodeNext(This, hn) \
	  treedb_tree_impl_t_NodeNext(treedb_tree_t_to_runtime(This), hn)
	#define treedb_tree_t_PointerNodeNext(This, hn) \
	  treedb_tree_impl_t_PointerNodeNext(treedb_tree_t_to_runtime(This), hn)
	#define treedb_tree_t_NodeHasPrev(This, hn) \
	  treedb_tree_impl_t_node_HasPrev(treedb_tree_t_to_runtime(This), hn)
	#define treedb_tree_t_NodePrev(This, hn) \
	  treedb_tree_impl_t_NodePrev(treedb_tree_t_to_runtime(This), hn)
	#define treedb_tree_t_PointerNodePrev(This, hn) \
	  treedb_tree_impl_t_PointerNodePrev(treedb_tree_t_to_runtime(This), hn)
	#define treedb_tree_t_NodeIndex(This, ht, hn) \
	  treedb_tree_impl_t_NodeIndex(treedb_tree_t_to_runtime(This), ht, hn)
	#define treedb_tree_t_NodeAtIndex(This, hn, u) \
	  treedb_tree_impl_t_NodeAtIndex(treedb_tree_t_to_runtime(This), hn, u)
	#define treedb_tree_t_PointerNodeAtIndex(This, hn, u) \
	  treedb_tree_impl_t_PointerNodeAtIndex(treedb_tree_t_to_runtime(This), hn \
		, u)
	#define treedb_tree_t_NodeCount(This, hn) \
	  treedb_tree_impl_t_NodeCount(treedb_tree_t_to_runtime(This), hn)

/* "Pointer" macros --------------------------------------------------------  */
	#define treedb_tree_t_DumpNodePtr(This, pr, pd, pn) \
	  treedb_tree_impl_t_DumpNodePtr(treedb_tree_t_to_runtime(This), pr, pd, pn)
	#define treedb_tree_t_InsertNodePtr(This, pn) \
	  treedb_tree_impl_t_InsertNodePtr(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, pn)
	#define treedb_tree_t_InsertNodeBeforePtr(This, pn, pnew_node) \
	  treedb_tree_impl_t_InsertNodeBeforePtr(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, pn, pnew_node)
	#define treedb_tree_t_InsertNodeAfterPtr(This, pn, pnew_node) \
	  treedb_tree_impl_t_InsertNodeAfterPtr(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, pn, pnew_node)
	#define treedb_tree_t_RelinkNodePtr(This, pn) \
	  treedb_tree_impl_t_RelinkNodePtr(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, pn)
	#define treedb_tree_t_UnlinkNodePtr(This, pn) \
	  treedb_tree_impl_t_UnlinkNodePtr(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, pn)
	#define treedb_tree_t_DeleteNodePtr(This, pn) \
	  treedb_tree_impl_t_DeleteNodePtr(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, pn)

	#define treedb_tree_t_SearchClosestPtr(This, k, ppnode) \
	  treedb_tree_impl_t_SearchClosestPtr(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k, ppnode)
	#define treedb_tree_t_SearchLePtr(This, k, ppnode) \
	  treedb_tree_impl_t_SearchLePtr(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k, ppnode)
	#define treedb_tree_t_SearchGePtr(This, k, ppnode) \
	  treedb_tree_impl_t_SearchGePtr(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k, ppnode)
	#define treedb_tree_t_PointerSearch(This, k) \
	  treedb_tree_impl_t_PointerSearch(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k)
	#define treedb_tree_t_PointerSearchLt(This, k) \
	  treedb_tree_impl_t_PointerSearchLt(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k)
	#define treedb_tree_t_PointerSearchGt(This, k) \
	  treedb_tree_impl_t_PointerSearchGt(treedb_tree_t_to_runtime(This) \
		, (This)->m_handle, k)

	#define treedb_tree_t_NodeHasNextPtr(This, pn) \
	  treedb_tree_impl_t_NodeHasNextPtr(treedb_tree_t_to_runtime(This), pn)
	#define treedb_tree_t_NodeNextPtr(This, pn) \
	  treedb_tree_impl_t_NodeNextPtr(treedb_tree_t_to_runtime(This), pn)
	#define treedb_tree_t_PointerNodeNextPtr(This, pn) \
	  treedb_tree_impl_t_PointerNodeNextPtr(treedb_tree_t_to_runtime(This), pn)
	#define treedb_tree_t_NodeHasPrevPtr(This, pn) \
	  treedb_tree_impl_t_NodeHasPrevPtr(treedb_tree_t_to_runtime(This), pn)
	#define treedb_tree_t_NodePrevPtr(This, pn) \
	  treedb_tree_impl_t_NodePrevPtr(treedb_tree_t_to_runtime(This), pn)
	#define treedb_tree_t_PointerNodePrevPtr(This, pn) \
	  treedb_tree_impl_t_PointerNodePrevPtr(treedb_tree_t_to_runtime(This), pn)
	#define treedb_tree_t_NodeIndexPtr(This, ht, pn) \
	  treedb_tree_impl_t_NodeIndexPtr(treedb_tree_t_to_runtime(This), ht, pn)
	#define treedb_tree_t_NodeAtIndexPtr(This, pn, u) \
	  treedb_tree_impl_t_NodeAtIndexPtr(treedb_tree_t_to_runtime(This), pn, u)
	#define treedb_tree_t_PointerNodeAtIndexPtr(This, pn, u) \
	  treedb_tree_impl_t_PointerNodeAtIndexPtr(treedb_tree_t_to_runtime(This) \
		, pn, u)
	#define treedb_tree_t_NodeCountPtr(This, pn) \
	  treedb_tree_impl_t_NodeCountPtr(treedb_tree_t_to_runtime(This), pn)

	#define treedb_tree_t_NodeToData(This, h) \
	  (((HTREEDB_HANDLE)(h)) \
		+ This->m_pImpl->m_pDescription->m_aligned_node_size)
	#define treedb_tree_t_DataToNode(This, h) \
	  (((HTREEDB_HANDLE)(h)) \
		- This->m_pImpl->m_pDescription->m_aligned_node_size)

	#define treedb_tree_t_NodeToDataPtr(This, p) \
	  ((char *)(p) + (This)->m_pImpl->m_pDescription->m_aligned_node_size)
	#define treedb_tree_t_DataToNodePtr(This, p) \
	  ((char *)(p) - (This)->m_pImpl->m_pDescription->m_aligned_node_size)

/* Allocator convenience macros --------------------------------------------- */
	#define treedb_tree_t_PointerToOffset(This, u) \
	  treedb_allocator_t_PointerToOffset((This)->m_pImpl->m_pAllocator, u)
	#define treedb_tree_t_OffsetToPointer(This, u) \
	  treedb_allocator_t_OffsetToPointer((This)->m_pImpl->m_pAllocator, u)
	#define treedb_tree_t_PointerPack(This, p) \
	  treedb_allocator_t_PointerPack((This)->m_pImpl->m_pAllocator, p)
	#define treedb_tree_t_PointerUnpack(This, u) \
	  treedb_allocator_t_PointerUnpack((This)->m_pImpl->m_pAllocator, u)

/* Allocator convenience handle macros -------------------------------------- */
	#define treedb_tree_t_Read(This, hloc) \
	  treedb_allocator_t_Read((This)->m_pImpl->m_pAllocator, hloc)
	#define treedb_tree_t_Write(This, hloc, hvalue) \
	  treedb_allocator_t_Write((This)->m_pImpl->m_pAllocator, hloc, hvalue)
	#define treedb_tree_t_PointerRead(This, hloc) \
	  treedb_allocator_t_PointerRead((This)->m_pImpl->m_pAllocator, hloc)
	#define treedb_tree_t_PointerWrite(This, hloc, pv) \
	  treedb_allocator_t_PointerWrite((This)->m_pImpl->m_pAllocator, hloc, pv)
	#define treedb_tree_t_PointerAddTo(This, hloc, u) \
	  treedb_allocator_t_PointerAddTo((This)->m_pImpl->m_pAllocator, hloc, u)

/* Allocator convenience pointer macros ------------------------------------- */
	#define treedb_tree_t_ReadPtr(This, pv) \
	  treedb_allocator_t_ReadPtr((This)->m_pImpl->m_pAllocator, p)
	#define treedb_tree_t_WritePtr(This, pv, hvalue) \
	  treedb_allocator_t_WritePtr((This)->m_pImpl->m_pAllocator, pv, hvalue)
	#define treedb_tree_t_PointerReadPtr(This, pv) \
	  treedb_allocator_t_PointerReadPtr((This)->m_pImpl->m_pAllocator, pv)
	#define treedb_tree_t_PointerWritePtr(This, pv, pvvalue) \
	  treedb_allocator_t_PointerWritePtr((This)->m_pImpl->m_pAllocator, pv \
		, pvvalue)
	#define treedb_tree_t_PointerAddToPtr(This, pv, u) \
	  treedb_allocator_t_PointerAddToPtr((This)->m_pImpl->m_pAllocator, pv, u)


/* Backend convenience macros ----------------------------------------------- */
	#define treedb_tree_t_backend_UnpackKey(This, pv) \
	  treedb_tree_backend_t_UnpackKey((This)->m_pImpl->m_pBackend \
		, treedb_tree_t_to_runtime(This), pv)
	#define treedb_tree_t_backend_Compare(This, a, b) \
	  treedb_tree_backend_t_Compare((This)->m_pImpl->m_pBackend \
		, treedb_tree_t_to_runtime(This), a, b)

	#define treedb_tree_t_backend_AllocNode(This, pv) \
	  treedb_tree_backend_t_AllocNode((This)->m_pImpl->m_pBackend \
		, treedb_tree_t_to_runtime(This), pv)
	#define treedb_tree_t_backend_FreeNode(This, pv) \
	  treedb_tree_backend_t_FreeNode((This)->m_pImpl->m_pBackend \
		, treedb_tree_t_to_runtime(This), pv)


/* More convenience macros -------------------------------------------------- */
	#define treedb_tree_t_offset_size(This) \
	  (This)->m_pImpl->m_pDescription.m_pointer.m_uSize
	#define treedb_tree_t_offset_alignment(This) \
	  (This)->m_pImpl->m_pDescription.m_pointer.m_uAlign

	#define treedb_tree_t_root_size(This) \
	  (This)->m_pImpl->m_pDescription.m_root.m_uSize
	#define treedb_tree_t_root_alignment(This) \
	  (This)->m_pImpl->m_pDescription.m_root.m_uAlign

	#define treedb_tree_t_node_size(This) \
	  (This)->m_pImpl->m_pDescription->m_node.m_uSize
	#define treedb_tree_t_aligned_node_size(This) \
	  (This)->m_pImpl->m_pDescription->m_aligned_node_size
	#define treedb_tree_t_node_alignment(This) \
	  (This)->m_pImpl->m_pDescription->m_node.m_uAlign

	#define treedb_tree_t_allows_duplicates(This) \
	  ((This)->m_pImpl->m_pDescription->m_flags \
		& eTreedbContainerAllowsDuplicates)
	#define treedb_tree_t_is_pointer(This) \
	  ((This)->m_pImpl->m_pDescription->m_flags & eTreedbContainerIsPointer)
	#define treedb_tree_t_is_offset(This) \
	  (!treedb_tree_t_is_pointer(This))

/* Avl-specific macros ------------------------------------------------------ */
	#define treedb_avl_tree_t_has_count(This) \
	  ((This)->m_pImpl->m_pDescription->m_flags & eTreedbContainerHasCount)
	#define treedb_avl_tree_t_has_depth(This) \
	  ((This)->m_pImpl->m_pDescription->m_flags & eTreedbContainerHasDepth)

  #endif /* #ifdef COBJMACROS */

/******************************************************************************/
/* treedb_tree_backend_t                                                      */
/******************************************************************************/
extern void treedb_tree_backend_t_Setup
( treedb_tree_backend_ptr_t pb
, PVOID pVtbl
);

  #define treedb_tree_backend_t_methods(Imp, Prefix, Class, Runtime) \
	STDMETHOD##Imp##_(HTREEDB_TREEKEY, Prefix##UnpackKey) \
		( THIS(Class) \
		  Runtime * /*runtime*/ \
		, PCVOID /*pv*/ \
		) PURE; \
	STDMETHOD##Imp##_(int, Prefix##Compare) \
		( THIS(Class) \
		  Runtime * /*runtime*/ \
		, HTREEDB_TREEKEY /*a*/ \
		, HTREEDB_TREEKEY /*b*/ \
		) PURE; \
	STDMETHOD##Imp##_(PVOID, Prefix##AllocNode) \
		( THIS(Class) \
		  Runtime * /*runtime*/ \
		, HTREEDB_TREEKEY /*pv*/ \
		) PURE; \
	STDMETHOD##Imp##_(void, Prefix##FreeNode) \
		( THIS(Class) \
		  Runtime * /*runtime*/ \
		, PVOID /*pv*/ \
		) PURE

  #define treedb_tree_backend_vtbl_t_entries_default(Prefix) \
	& Prefix##UnpackKey \
	, & Prefix##Compare \
	, & Prefix##AllocNode \
	, & Prefix##FreeNode

  #ifndef treedb_tree_backend_vtbl_t_entries
	#define treedb_tree_backend_vtbl_t_entries(x) \
	  treedb_tree_backend_vtbl_t_entries_default(x)
  #endif

  #ifdef COBJMACROS

	#define treedb_tree_backend_t_UnpackKey(This, runtime, pv) \
	  V3C_IFACE_CALL(UnpackKey, This, runtime, pv)
	#define treedb_tree_backend_t_Compare(This, runtime, pav, pbv) \
	  V3C_IFACE_CALL(Compare, This, runtime, pav, pbv)
	#define treedb_tree_backend_t_AllocNode(This, runtime, pv) \
	  V3C_IFACE_CALL(AllocNode, This, runtime, pv)
	#define treedb_tree_backend_t_FreeNode(This, runtime, pv) \
	  V3C_IFACE_CALL(FreeNode, This, runtime, pv)

  #endif /* #ifdef COBJMACROS */

  #define treedb_tree_backend_t_members(vtbl_ptr_t) \
	vtbl_ptr_t m_pVtbl

  #ifndef MetaTreedb_treedb_tree_backend_t_DEFINED
	#define MetaTreedb_treedb_tree_backend_t_DEFINED

	#ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
struct treedb_tree_backend_vtbl_t
{
	treedb_tree_backend_t_methods(,,treedb_tree_backend_t
		, treedb_tree_runtime_t);
};
	#ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_tree_backend_t
{
	
	#ifdef __cplusplus
	inline treedb_tree_backend_t() : m_pVtbl(0) {}
	#endif
	treedb_tree_backend_t_members(treedb_tree_backend_vtbl_ptr_t);
};

  #endif /* #ifndef MetaTreedb_treedb_tree_backend_t_DEFINED */

  #define META_TREEDB_TREE_BACKEND_INIT_BARE 0
  #define META_TREEDB_TREE_BACKEND_INIT { META_TREEDB_TREE_BACKEND_INIT_BARE }

/******************************************************************************/
/* treedb_tree_renderer_t - render tree-structured data                       */
/******************************************************************************/
  #define treedb_tree_renderer_t_methods(Imp, Prefix, Class) \
	STDMETHOD##Imp##_(void, Prefix##Add) \
		(THIS(Class) const char * /*text*/, int /*last*/) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Push)(THIS0(Class)) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Pop)(THIS0(Class)) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Reset)(THIS0(Class)) PURE; \
	STDMETHOD##Imp##_(void, Prefix##Term)(THIS0(Class)) PURE

  #ifdef COBJMACROS

	#define treedb_tree_renderer_t_Add(This, text, last) \
	  V3C_IFACE_CALL(Add, This, text, last)
	#define treedb_tree_renderer_t_Push(This) \
	  V3C_IFACE_CALL(Push, This)
	#define treedb_tree_renderer_t_Pop(This) \
	  V3C_IFACE_CALL(Pop, This)
	#define treedb_tree_renderer_t_Reset(This) \
	  V3C_IFACE_CALL(Reset, This)
	#define treedb_tree_renderer_t_Term(This) \
	  V3C_IFACE_CALL(Term, This)

  #endif /* #ifdef COBJMACROS */

  #define treedb_tree_renderer_t_members(vtbl_ptr_t) \
	vtbl_ptr_t m_pVtbl

  #define treedb_tree_renderer_vtbl_t_entries_default(Prefix) \
	& Prefix##Add \
	, & Prefix##Push \
	, & Prefix##Pop \
	, & Prefix##Reset \
	, & Prefix##Term

  #ifndef treedb_tree_renderer_vtbl_t_entries
	#define treedb_tree_renderer_vtbl_t_entries(x) \
	  treedb_tree_renderer_vtbl_t_entries_default(x)
  #endif

  #ifndef MetaTreedb_treedb_tree_renderer_t_DEFINED
	#define MetaTreedb_treedb_tree_renderer_t_DEFINED

	#ifndef __cplusplus
struct treedb_tree_renderer_vtbl_t
{
	treedb_tree_renderer_t_methods(,,treedb_tree_renderer_t);
};
	#endif

struct treedb_tree_renderer_t
{
	#ifdef __cplusplus
	treedb_tree_renderer_t_methods(,,treedb_tree_renderer_t);
	#endif
	treedb_tree_renderer_t_members(treedb_tree_renderer_vtbl_ptr_t);
};

  #endif /* #ifndef MetaTreedb_treedb_tree_renderer_t_DEFINED */

extern void render_tree_to_fd
( treedb_tree_ptr_t ptree
, treedb_tree_data_renderer_ptr_t pd
, int fd
);

/******************************************************************************/
/* treedb_fd_tree_renderer_t - render tree-structured data to a file          */
/******************************************************************************/
  #ifndef MetaTreedb_treedb_fd_tree_renderer_t_DEFINED
	#define MetaTreedb_treedb_fd_tree_renderer_t_DEFINED

    #ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
struct treedb_fd_tree_renderer_vtbl_t
{
	treedb_tree_renderer_t_methods(,,treedb_fd_tree_renderer_t);
};
    #ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_fd_tree_renderer_t
{
	treedb_tree_renderer_t_members(treedb_fd_tree_renderer_vtbl_ptr_t);
	v3c_tree_printer m_printer;
};

  #endif /* #ifndef MetaTreedb_treedb_fd_tree_renderer_t_DEFINED */

extern treedb_fd_tree_renderer_vtbl_t treedb_fd_tree_renderer_vtbl;

  #define INIT_TREEDB_FD_TREE_RENDERER_BARE(fd) \
	(treedb_fd_tree_renderer_vtbl_ptr_t)& treedb_fd_tree_renderer_vtbl \
		, V3C_TREE_PRINTER_INIT_WITH(fd)

  #define INIT_TREEDB_FD_TREE_RENDERER(fd) \
	{ INIT_TREEDB_FD_TREE_RENDERER_BARE(fd) };

/******************************************************************************/
/* treedb_tree_data_renderer_t - render stored data usefully                  */
/******************************************************************************/
  #define treedb_tree_data_renderer_t_methods(Imp, Prefix, Class) \
	STDMETHOD##Imp##_(PSTR, Prefix##Dump) \
		( THIS(Class) \
		  treedb_tree_runtime_ptr_t /*runtime*/ \
		, PCVOID /*pv*/) PURE

  #ifdef COBJMACROS

	#define treedb_tree_data_renderer_t_Dump(This, tree, pv) \
	  V3C_IFACE_CALL(Dump, This, tree, pv)

  #endif /* #ifdef COBJMACROS */

  #define treedb_tree_data_renderer_vtbl_t_entries_default(Prefix) \
	& Prefix##Dump

  #ifndef treedb_tree_data_renderer_vtbl_t_entries
	#define treedb_tree_data_renderer_vtbl_t_entries(x) \
	  treedb_tree_data_renderer_vtbl_t_entries_default(x)
  #endif

  #define treedb_tree_data_renderer_t_members(vtbl_ptr_t) \
	vtbl_ptr_t m_pVtbl

  #ifndef MetaTreedb_treedb_tree_data_renderer_t_DEFINED
	#define MetaTreedb_treedb_tree_data_renderer_t_DEFINED

	#ifdef __cplusplus
	  #include "meta-treedb-cxx-push-c.h"
	#endif
struct treedb_tree_data_renderer_vtbl_t
{
	treedb_tree_data_renderer_t_methods(,,treedb_tree_data_renderer_t);
};
	#ifdef __cplusplus
	  #include "meta-treedb-cxx-pop-c.h"
	#endif

struct treedb_tree_data_renderer_t
{
	treedb_tree_data_renderer_t_members(treedb_tree_data_renderer_vtbl_ptr_t);
};

  #endif /* #ifndef MetaTreedb_treedb_tree_data_renderer_t_DEFINED */

  #ifdef __cplusplus
} // extern "C" {
  #endif

#endif /* #ifndef v3c_meta_treedb_tree_h_included */
